var MapConstants = {
//各个省、自治区、直辖市的行政简称
    PROVINCE_SHORT_NAME_MAP: {
        京: "北京市",
        津: "天津市",
        冀: "河北省",
        晋: "山西省",
        内: "内蒙古自治区",
        辽: "辽宁省",
        吉: "吉林省",
        黑: "黑龙江省",
        沪: "上海市",
        苏: "江苏省",
        浙: "浙江省",
        皖: "安徽省",
        闽: "福建省",
        赣: "江西省",
        鲁: "山东省",
        豫: "河南省",
        鄂: "湖北省",
        湘: "湖南省",
        粤: "广东省",
        桂: "广西壮族自治区",
        琼: "海南省",
        蜀: "四川省",
        川: "四川省",
        贵: "贵州省",
        黔: "贵州省",
        云: "云南省",
        滇: "云南省",
        渝: "重庆市",
        藏: "西藏自治区",
        秦: "陕西省",
        陕: "陕西省",
        甘: "甘肃省",
        陇: "甘肃省",
        青: "青海省",
        宁: "宁夏回族自治区",
        新: "新疆维吾尔自治区",
        港: "香港特别行政区",
        澳: "澳门特别行政区",
        台: "台湾省"
    },
//行政区域的简称（如江苏省→江苏，无锡市→无锡，新疆维吾尔自治区→新疆，昌吉回族自治州→昌吉，青龙满族自治县→青龙）
    ABBREVIATION_NAME_MAP: {
        新疆维吾尔自治区: "新疆",
        内蒙古自治区: "内蒙古",
        西藏自治区: "西藏",
        宁夏回族自治区: "宁夏",
        广西壮族自治区: "广西",

        克孜勒苏柯尔克孜自治州: "克孜勒苏柯尔克孜",
        博尔塔拉蒙古自治州: "博尔塔拉",
        巴音郭楞蒙古自治州: "巴音郭楞",
        昌吉回族自治州: "昌吉",
        伊犁哈萨克自治州: "伊犁",
        海南藏族自治州: "海南",
        果洛藏族自治州: "果洛",
        海西蒙古族藏族自治州: "海西",
        黄南藏族自治州: "黄南",
        玉树藏族自治州: "玉树",
        海北藏族自治州: "海北",
        临夏回族自治州: "临夏",
        甘南藏族自治州: "甘南",
        楚雄彝族自治州: "楚雄",
        怒江傈僳族自治州: "怒江",
        迪庆藏族自治州: "迪庆",
        德宏傣族景颇族自治州: "德宏",
        文山壮族苗族自治州: "文山",
        红河哈尼族彝族自治州: "红河",
        西双版纳傣族自治州: "西双版纳",
        大理白族自治州: "大理",
        黔西南布依族苗族自治州: "黔西南",
        黔东南苗族侗族自治州: "黔东南",
        黔南布依族苗族自治州: "黔南",
        阿坝藏族羌族自治州: "阿坝",
        甘孜藏族自治州: "甘孜",
        凉山彝族自治州: "凉山",
        湘西土家族苗族自治州: "湘西",
        恩施土家族苗族自治州: "恩施",
        延边朝鲜族自治州: "延边",

        青龙满族自治县: "青龙",
        大厂回族自治县: "大厂",
        孟村回族自治县: "孟村",
        宽城满族自治县: "宽城",
        围场满族蒙古族自治县: "围场",
        丰宁满族自治县: "丰宁",
        桓仁满族自治县: "桓仁",
        本溪满族自治县: "本溪",
        新宾满族自治县: "新宾",
        清原满族自治县: "清原",
        岫岩满族自治县: "岫岩",
        宽甸满族自治县: "宽甸",
        阜新蒙古族自治县: "阜新",
        喀喇沁左翼蒙古族自治县: "喀喇沁左翼",
        伊通满族自治县: "伊通",
        长白朝鲜族自治县: "长白",
        前郭尔罗斯蒙古族自治县: "前郭尔罗斯",
        杜尔伯特蒙古族自治县: "杜尔伯特",
        景宁畲族自治县: "景宁",
        长阳土家族自治县: "长阳",
        五峰土家族自治县: "五峰",
        城步苗族自治县: "城步",
        江华瑶族自治县: "江华",
        通道侗族自治县: "通道",
        芷江侗族自治县: "芷江",
        新晃侗族自治县: "新晃",
        麻阳苗族自治县: "麻阳",
        靖州苗族侗族自治县: "靖州",
        乳源瑶族自治县: "乳源",
        连山壮族瑶族自治县: "连山",
        连南瑶族自治县: "连南",
        隆林各族自治县: "隆林",
        富川瑶族自治县: "富川",
        金秀瑶族自治县: "金秀",
        龙胜各族自治县: "龙胜",
        恭城瑶族自治县: "恭城",
        融水苗族自治县: "融水",
        三江侗族自治县: "三江",
        环江毛南族自治县: "环江",
        大化瑶族自治县: "大化",
        罗城仫佬族自治县: "罗城",
        巴马瑶族自治县: "巴马",
        都安瑶族自治县: "都安",
        昌江黎族自治县: "昌江",
        琼中黎族苗族自治县: "琼中",
        陵水黎族自治县: "陵水",
        保亭黎族苗族自治县: "保亭",
        白沙黎族自治县: "白沙",
        乐东黎族自治县: "乐东",
        石柱土家族自治县: "石柱",
        彭水苗族土家族自治县: "彭水",
        酉阳土家族苗族自治县: "酉阳",
        秀山土家族苗族自治县: "秀山",
        马边彝族自治县: "马边",
        峨边彝族自治县: "峨边",
        北川羌族自治县: "北川",
        木里藏族自治县: "木里",
        三都水族自治县: "三都",
        沿河土家族自治县: "沿河",
        印江土家族苗族自治县: "印江",
        玉屏侗族自治县: "玉屏",
        松桃苗族自治县: "松桃",
        关岭布依族苗族自治县: "关岭",
        紫云苗族布依族自治县: "紫云",
        镇宁布依族苗族自治县: "镇宁",
        务川仡佬族苗族自治县: "务川",
        道真仡佬族苗族自治县: "道真",
        威宁彝族回族苗族自治县: "威宁",
        宁蒗彝族自治县: "宁蒗",
        玉龙纳西族自治县: "玉龙",
        石林彝族自治县: "石林",
        禄劝彝族苗族自治县: "禄劝",
        寻甸回族彝族自治县: "寻甸",
        峨山彝族自治县: "峨山",
        新平彝族傣族自治县: "新平",
        元江哈尼族彝族傣族自治县: "元江",
        沧源佤族自治县: "沧源",
        耿马傣族佤族自治县: "耿马",
        双江拉祜族佤族布朗族傣族自治县: "双江",
        江城哈尼族彝族自治县: "江城",
        墨江哈尼族自治县: "墨江",
        宁洱哈尼族彝族自治县: "宁洱",
        景东彝族自治县: "景东",
        镇沅彝族哈尼族拉祜族自治县: "镇沅",
        景谷傣族彝族自治县: "景谷",
        孟连傣族拉祜族佤族自治县: "孟连",
        澜沧拉祜族自治县: "澜沧",
        西盟佤族自治县: "西盟",
        维西傈僳族自治县: "维西",
        兰坪白族普米族自治县: "兰坪",
        贡山独龙族怒族自治县: "贡山",
        南涧彝族自治县: "南涧",
        漾濞彝族自治县: "漾濞",
        巍山彝族回族自治县: "巍山",
        屏边苗族自治县: "屏边",
        河口瑶族自治县: "河口",
        金平苗族瑶族傣族自治县: "金平",
        天祝藏族自治县: "天祝",
        张家川回族自治县: "张家川",
        肃南裕固族自治县: "肃南",
        肃北蒙古族自治县: "肃北",
        阿克塞哈萨克族自治县: "阿克塞",
        东乡族自治县: "东乡",
        积石山保安族东乡族撒拉族自治县: "积石山",
        大通回族土族自治县: "大通",
        互助土族自治县: "互助",
        循化撒拉族自治县: "循化",
        化隆回族自治县: "化隆",
        民和回族土族自治县: "民和",
        门源回族自治县: "门源",
        河南蒙古族自治县: "河南",
        塔什库尔干塔吉克自治县: "塔什库尔干",
        和布克赛尔蒙古自治县: "和布克赛尔",
        巴里坤哈萨克自治县: "巴里坤",
        察布查尔锡伯自治县: "察布查尔",
        木垒哈萨克自治县: "木垒",
        焉耆回族自治县: "焉耆",

        莫力达瓦达斡尔族自治旗: "莫力达瓦",
        鄂伦春自治旗: "鄂伦春",
        鄂温克族自治旗: "鄂温克",

        六枝特区: "六枝",

        神农架林区: "神农架"
    },
//行政区域后缀
    REGION_SUFFIX: {
        province: "省",
        specialAdminRegion: "特别行政区",
        city: "市",
        region: "地区",
        prefecture: "州",
        autonomousPrefecture: "自治州",
        league: "盟",
        adminArea: "区",
        county: "县",
        autonomousCounty: "自治县",
        flag: "旗"
    }
}
