FR.Chart =  FR.Chart || {};

/**
 * 图表常量
 *@class FR.Chart.Constants
 */
FR.Chart.Constants = {
    /**
     * @static
     * @property  标记点默认宽高度
     */
    MarkerDefaultSize:10,

    /**
     * @static
     * @property 固定字符串 省略号
     */
	ESP	: 	'…',

    /**
     * @static
     * @property  气泡宽度比较
     */
    BubbleType_Width: 1,
    /**
     * @static
     * @property 气泡面积比较
     */
    BubbleType_Area: 2,

    /**
     * @static
     * @property 全距图 坐标轴高度
     */
    RangeAxisHeight: 50,

    /**
     * @static
     * @property 仪表盘刻度颜色
     */
    MeterTickColor: 'rgb(47, 46, 46)',
    /**
     * @static
     * @property 仪表盘指针颜色
     */
    MeterNeedleColor: 'rgb(47, 46, 46)',

    /**
     * @static
     * @property 坐标轴刻度宽度
     */
    AxisTickWidth: 1,

    /**
     * @static
     * @property  默认颜色模式.
     */
    Color_DEFAULT: 0,
    /**
     * @static
     * @property 颜色精确选择
     */
    Color_ACC:	1,
    /**
     * @static
     * @property 颜色渐变
     */
    Color_GRADIENT:2,

    /**
     * @static
     * @property 风格无
     */
    STYLE_NONE: 0,
    /**
     * @static
     * @property 风格3D
     */
    STYLE_3D:	1,
    /**
     * @static
     * @property  风格外发光
     */
    STYLE_OUTER: 2,
    /**
     * @static
     * @property 风格默认
     */
    STYLE_DEFAULT: 3,
    /**
     * @static
     * @property 风格渐变
     */
    STYLE_SHADE: 4,
    /**
     * @static
     * @property 风格透明
     */
    STYLE_TRANSPARENT: 5,

    /**
     * @static
     * @property 用于表示“天”类型的日期
     */
    DAY: 1,

    /**
     * @static
     * @property 用于表示“月”类型的日期
     */
    MONTH: 2,

    /**
     * @static
     * @property 用于表示“年”类型的日期
     */
    YEAR: 3,

    /**
     * @static
     * @property 用于表示“小时”类型的日期
     */
    Hour: 4,

    /**
     * @static
     * @property 用于表示“分钟”类型的日期
     */
    Minute: 5,

    /**
     * @static
     * @property 用于表示“秒”类型的日期
     */
    Second: 6,

    /**
     * @static
     * @property 中间对齐
     */
    CENTER: 0,

    /**
     * @static
     * @property 上对齐
     */
    TOP: 1,

    /**
     * @static
     * @property 左对齐
     */
    LEFT: 2,

    /**
     * @static
     * @property 下对齐
     */
    BOTTOM: 3,

    /**
     * @static
     * @property 右对齐
     */
    RIGHT: 4,

    /**
     * @static
     * @property 右上对齐
     */
    RIGHT_TOP : 8,

    /**
     * @static
     * @property 刻度位置 无
     */
    TICK_MARK_NONE: 0,
    /**
     * @static
     * @property 刻度 内
     */
    TICK_MARK_INSIDE: 1,
    /**
     * @static
     * @property 刻度外
     */
    TICK_MARK_OUTSIDE: 2,
    /**
     * @static
     * @property 刻度交叉
     */
    TICK_MARK_CROSS: 3,

    /**
     * @static
     * @property 线型无
     */
    LINE_NONE: 0,
    /**
     * @static
     * @property  1像素线型
     */
    LINE_THIN: 1,
    /**
     * @static
     * @property  暂无
     */
    LINE_MEDIUM: 2,
    /**
     * @static
     * @property 暂无
     */
    LINE_DASH: 3,
    /**
     * @static
     * @property 暂无
     */
    LINE_HAIR: 4,
    /**
     * @static
     * @property 暂无
     */
    LINE_HAIR2: 14,
    /**
     * @static
     * @property 3像素线型
     */
    LINE_THICK: 5,
    /**
     * @static
     * @property 暂无
     */
    LINE_DOT: 7,
    /**
     * @static
     * @property 暂无
     */
    LINE_MEDIUM_DASH: 8,
    /**
     * @static
     * @property 暂无
     */
    LINE_DASH_DOT: 9,
    /**
     * @static
     * @property 暂无
     */
    LINE_MEDIUM_DASH_DOT: 10,
    /**
     * @static
     * @property 暂无
     */
    LINE_DASH_DOT_DOT: 11,
    /**
     * @static
     * @property 暂无
     */
    LINE_MEDIUM_DASH_DOT_DOT: 12,
    /**
     * @static
     * @property 暂无
     */
    LINE_SLANTED_DASH_DOT: 13,

    /**
     * @static
     * @property 暂无
     */
    LINE_CHART_THIN_ARROW : 21,
    /**
     * @static
     * @property 暂无
     */
    LINE_CHART_MED_ARROW : 22,
    /**
     * @static
     * @property 暂无
     */
    LINE_CHART_THICK_ARROW : 23,

    /**
     * @static
     * @property 标签 自适应
     */
    LABEL_AROUND: 3,
    /**
     * @static
     * @property 标签位置上
     */
    LABEL_TOP: 2,
    /**
     * @static
     * @property 标签位置下
     */
    LABEL_BOTTOM: 1,
    /**
     * @static
     * @property 标签无
     */
    LABEL_NONE: 0,

    /**
     * @static
     * @property 图片布局 自适应
     */
    IMAGE_TILED: 0,
    /**
     * @static
     * @property 图片布局 居中
     */
    IMAGE_CENTER: 1,
    /**
     * @static
     * @property 图片布局 扩展拉伸
     */
    IMAGE_EXTEND: 2,
    /**
     * @static
     * @property 图片布局 默认
     */
    IMAGE_DEFAULT: 3,
    /**
     * @static
     * @property 图片布局 自适应
     */
    IMAGE_ADJUST: 4,

    /**
     * @static
     * @property 标签位置 内(饼图)
     */
    INSIDE: 5,
    /**
     * @static
     * @property 标签位置 外(饼图)
     */
    OUTSIDE: 6,
    /**
     * @static
     * @property 坐标轴内侧
     */
    AXISINSIDE: 7,

    /**
     * @static
     * @property 趋势线 线性拟合
     */
    TRENDLINE_LINEAR: 0,
    /**
     * @static
     * @property 趋势线 多项式拟合
     */
    TRENDLINE_POLYNOMIAL: 1,
    /**
     * @static
     * @property 趋势线 对数拟合
     */
    TRENDLINE_LOG: 2,
    /**
     * @static
     * @property 趋势线 指数拟合
     */
    TRENDLINE_EXPONENT: 3,
    /**
     * @static
     * @property 趋势线 平方拟合
     */
    TRENDLINE_POWER: 4,
    /**
     * @static
     * @property 趋势线 平均拟合
     */
    TRENDLINE_MA: 5
};

FR.Chart.ChartPaintConstants = {
    ACTION_MODEL_DEFAULT: 0, // 默认动态,为最开始打开时候的动态
    ACTION_MODEL_NULL: 1, // 没有动态,即在动态展示过程中没有变化
    ACTION_MODEL_CHANGE: 2, // 对比变化动态,为交互过程中的动态,主要是从一个状态变化到另一种状态过程中的动态


    ACTION_STEP_Number: [36, 1, 36],
    ACTION_TIME: [1000, 1, 500],


    STATE_DISAPPEAR: 0,	//该系列正在消失
    STATE_UNENABLE: 1,	//该系列不画
    STATE_ENABLE: 2,	//画该系列
    STATE_APPEAR: 3,	//该系列正在出现
    STATE_TRANSPARENT: 4 //该系列参与计算，但是不画，或者说是透明的
};

FR.Chart.ChartIconState = {
    STATE_NORMAL:0,
    STATE_OVER:1,
    STATE_SELECT:2
};

//组合地图的类型
FR.Chart.MapType = {
    Map_Normal:0,
    Map_Bubble:1,
    Map_Pie:2,
    Map_Column:3
};

FR.Chart.ChartCoreConstants = {
    CHART_Color_ARRAY: [
        "rgb(25,79,151)",
        "rgb(85,85,85)",
        "rgb(189,107,8)",
        "rgb(0,104,107)",
        "rgb(200,45,49)",

        "rgb(98,91,161)",
        "rgb(137,137,137)",
        "rgb(156,152,0)",
        "rgb(0,127,84)",
        "rgb(161,149,197)",

        "rgb(16,54,103)",
        "rgb(241,146,114)",
        "rgb(193,140,0)",
        "rgb(54,54,54)",
        "rgb(66,111,179)",

        "rgb(102,191,127)",
        "rgb(249,205,118)",
        "rgb(57,40,132)",
        "rgb(0,174,113)",
        "rgb(147,170,214)",

        "rgb(73,7,97)",
        "rgb(250,241,75)",
        "rgb(149,83,5)",
        "rgb(1,98,65)",
        "rgb(115,136,193)",

        "rgb(143,30,32)",
        "rgb(249,205,118)",
        "rgb(214,155,1)",
        "rgb(183,183,183)",
        "rgb(81,31,144)",

        "rgb(153,208,185)",
        "rgb(199,195,0)"
    ],

    //明亮
    BRIGHT_COLOR_ARRAY:["rgb(14,114,204)","rgb(108,163,15)","rgb(245,147,17)","rgb(250,67,67)","rgb(22,175,204)","rgb(133,192,33)","rgb(209,42,106)","rgb(14,114,204)","rgb(108,163,15)","rgb(245,147,17)","rgb(250,67,67)","rgb(22,175,204)","rgb(133,192,33)","rgb(209,42,106)","rgb(14,114,204)","rgb(108,163,15)","rgb(245,147,17)","rgb(250,67,67)","rgb(22,175,204)","rgb(133,192,33)","rgb(209,42,106)","rgb(14,114,204)","rgb(108,163,15)","rgb(245,147,17)","rgb(250,67,67)","rgb(22,175,204)","rgb(133,192,33)","rgb(209,42,106)","rgb(14,114,204)","rgb(108,163,15)","rgb(245,147,17)","rgb(250,67,67)"],

    //雅致
    ELEGANT_COLOR_ARRAY:["rgb(54,130,190)","rgb(69,167,118)","rgb(240,83,38)","rgb(238,215,119)","rgb(51,79,101)","rgb(179,151,78)","rgb(56,203,125)","rgb(221,174,51)","rgb(132,75,179)","rgb(147,197,85)","rgb(95,102,148)","rgb(223,56,129)","rgb(46,146,150)","rgb(54,130,190)","rgb(69,167,118)","rgb(240,83,38)","rgb(238,215,119)","rgb(51,79,101)","rgb(179,151,78)","rgb(56,203,125)","rgb(221,174,51)","rgb(132,75,179)","rgb(147,197,85)","rgb(95,102,148)","rgb(223,56,129)","rgb(46,146,150)","rgb(54,130,190)","rgb(69,167,118)","rgb(240,83,38)","rgb(238,215,119)","rgb(51,79,101)","rgb(179,151,78)"],

    //柔和
    SOFT_COLOR_ARRAY:["rgb(91,155,213)","rgb(237,125,49)","rgb(112,173,71)","rgb(255,192,0)","rgb(68,114,196)","rgb(145,208,36)","rgb(178,53,230)","rgb(2,174,117)","rgb(91,155,213)","rgb(237,125,49)","rgb(112,173,71)","rgb(255,192,0)","rgb(68,114,196)","rgb(145,208,36)","rgb(178,53,230)","rgb(2,174,117)","rgb(91,155,213)","rgb(237,125,49)","rgb(112,173,71)","rgb(255,192,0)","rgb(68,114,196)","rgb(145,208,36)","rgb(178,53,230)","rgb(2,174,117)","rgb(91,155,213)","rgb(237,125,49)","rgb(112,173,71)","rgb(255,192,0)","rgb(68,114,196)","rgb(145,208,36)","rgb(178,53,230)","rgb(2,174,117)"],

    //淡雅
    SIMPLE_COLOR_ARRAY:["rgb(124,181,236)","rgb(67,67,72)","rgb(144,237,125)","rgb(247,163,92)","rgb(128,133,233)","rgb(241,92,128)","rgb(228,211,84)","rgb(124,181,236)","rgb(67,67,72)","rgb(144,237,125)","rgb(247,163,92)","rgb(128,133,233)","rgb(241,92,128)","rgb(228,211,84)","rgb(124,181,236)","rgb(67,67,72)","rgb(144,237,125)","rgb(247,163,92)","rgb(128,133,233)","rgb(241,92,128)","rgb(228,211,84)","rgb(124,181,236)","rgb(67,67,72)","rgb(144,237,125)","rgb(247,163,92)","rgb(128,133,233)","rgb(241,92,128)","rgb(228,211,84)","rgb(124,181,236)","rgb(67,67,72)","rgb(144,237,125)","rgb(247,163,92)"],

    //复古
    RETRO_COLOR_ARRAY:["rgb(7,128,207)","rgb(118,80,5)","rgb(250,109,29)","rgb(14,44,130)","rgb(182,181,31)","rgb(218,31,24)","rgb(112,24,102)","rgb(244,122,117)","rgb(0,157,178)","rgb(2,75,81)","rgb(7,128,207)","rgb(118,80,5)","rgb(250,109,29)","rgb(14,44,130)","rgb(182,181,31)","rgb(218,31,24)","rgb(112,24,102)","rgb(244,122,117)","rgb(0,157,178)","rgb(2,75,81)","rgb(7,128,207)","rgb(118,80,5)","rgb(250,109,29)","rgb(14,44,130)","rgb(182,181,31)","rgb(218,31,24)","rgb(112,24,102)","rgb(244,122,117)","rgb(0,157,178)","rgb(2,75,81)","rgb(7,128,207)","rgb(118,80,5)"],

    //商务
    BUSINESS_COLOR_ARRAY:["rgb(25,79,151)","rgb(85,85,85)","rgb(189,107,8)","rgb(0,104,107)","rgb(200,45,49)","rgb(98,91,161)","rgb(137,137,137)","rgb(156,152,0)","rgb(0,127,84)","rgb(161,149,197)","rgb(16,54,103)","rgb(241,146,114)","rgb(193,140,0)","rgb(54,54,54)","rgb(66,111,179)","rgb(102,191,127)","rgb(249,205,118)","rgb(57,40,132)","rgb(0,174,113)","rgb(147,170,214)","rgb(73,7,97)","rgb(250,241,75)","rgb(149,83,5)","rgb(1,98,65)","rgb(115,136,193)","rgb(143,30,32)","rgb(249,205,118)","rgb(214,155,1)","rgb(183,183,183)","rgb(81,31,144)","rgb(153,208,185)","rgb(199,195,0)"],

    //清新
    FRESH_COLOR_ARRAY:["rgb(0,168,225)","rgb(153,204,0)","rgb(227,0,57)","rgb(252,211,0)","rgb(128,0,128)","rgb(0,153,78)","rgb(255,102,0)","rgb(128,128,0)","rgb(219,0,194)","rgb(0,128,128)","rgb(0,0,255)","rgb(200,204,0)","rgb(0,18,133)","rgb(0,202,204)","rgb(224,56,0)","rgb(250,155,0)","rgb(133,10,0)","rgb(153,0,137)","rgb(191,102,0)","rgb(0,191,94)","rgb(141,0,220)","rgb(250,241,0)","rgb(149,83,0)","rgb(0,98,65)","rgb(115,136,193)","rgb(143,30,32)","rgb(249,205,118)","rgb(214,155,1)","rgb(183,183,183)","rgb(81,31,144)","rgb(153,208,185)","rgb(199,195,0)"],

    //经典
    CLASSIC_COLOR_ARRAY:["rgb(0,44,83)","rgb(255,165,16)","rgb(12,132,198)","rgb(255,189,102)","rgb(247,77,77)","rgb(36,85,164)","rgb(65,183,172)","rgb(0,44,83)","rgb(255,165,16)","rgb(12,132,198)","rgb(255,189,102)","rgb(247,77,77)","rgb(36,85,164)","rgb(65,183,172)","rgb(0,44,83)","rgb(255,165,16)","rgb(12,132,198)","rgb(255,189,102)","rgb(247,77,77)","rgb(36,85,164)","rgb(65,183,172)","rgb(0,44,83)","rgb(255,165,16)","rgb(12,132,198)","rgb(255,189,102)","rgb(247,77,77)","rgb(36,85,164)","rgb(65,183,172)","rgb(0,44,83)","rgb(255,165,16)","rgb(12,132,198)","rgb(255,189,102)"],

    //渐变
    GRADUAL_COLOR_ARRAY:["rgb(113,174,70)","rgb(150,183,68)","rgb(196,204,56)","rgb(235,225,42)","rgb(234,176,38)","rgb(227,133,43)","rgb(216,93,42)","rgb(206,38,38)","rgb(172,32,38)","rgb(113,174,70)","rgb(150,183,68)","rgb(196,204,56)","rgb(235,225,42)","rgb(234,176,38)","rgb(227,133,43)","rgb(216,93,42)","rgb(206,38,38)","rgb(172,32,38)","rgb(113,174,70)","rgb(150,183,68)","rgb(196,204,56)","rgb(235,225,42)","rgb(234,176,38)","rgb(227,133,43)","rgb(216,93,42)","rgb(206,38,38)","rgb(172,32,38)","rgb(113,174,70)","rgb(150,183,68)","rgb(196,204,56)","rgb(235,225,42)","rgb(234,176,38)"],

    //怀旧
    NOSTALGIA_COLOR_ARRAY:["rgb(59,98,145)","rgb(148,60,57)","rgb(119,144,67)","rgb(98,76,124)","rgb(56,132,152)","rgb(191,115,52)","rgb(63,104,153)","rgb(156,64,61)","rgb(125,152,71)","rgb(103,80,131)","rgb(59,139,161)","rgb(201,121,55)","rgb(66,109,161)","rgb(164,67,64)","rgb(132,159,75)","rgb(108,84,138)","rgb(63,146,169)","rgb(211,127,58)","rgb(69,114,167)","rgb(170,70,67)","rgb(137,165,78)","rgb(113,88,143)","rgb(65,152,175)","rgb(219,132,61)","rgb(72,118,174)","rgb(177,73,70)","rgb(142,172,81)","rgb(117,91,149)","rgb(68,158,182)","rgb(228,138,64)","rgb(75,123,180)","rgb(183,76,73)"],

    CHART_FILL_Color_ARRAY: []
};

/**
 * 名字和对应的颜色数组
 * @type {{bright: *, elegant: *, soft: *, simple: *, old: *, business: *, pure: *, classic: *, gradual: *, nostalgia: *}}
 */
FR.Chart.DefinedColors = {
    bright:FR.Chart.ChartCoreConstants.BRIGHT_COLOR_ARRAY,
    elegant:FR.Chart.ChartCoreConstants.ELEGANT_COLOR_ARRAY,
    soft:FR.Chart.ChartCoreConstants.SOFT_COLOR_ARRAY,
    simple:FR.Chart.ChartCoreConstants.SIMPLE_COLOR_ARRAY,
    retro:FR.Chart.ChartCoreConstants.RETRO_COLOR_ARRAY,
    business:FR.Chart.ChartCoreConstants.BUSINESS_COLOR_ARRAY,
    fresh:FR.Chart.ChartCoreConstants.FRESH_COLOR_ARRAY,
    classic:FR.Chart.ChartCoreConstants.CLASSIC_COLOR_ARRAY,
    gradual:FR.Chart.ChartCoreConstants.GRADUAL_COLOR_ARRAY,
    nostalgia:FR.Chart.ChartCoreConstants.NOSTALGIA_COLOR_ARRAY
};

/**
 *  集中管理的图表对应类型, 以便于初始化
 * @type  Bar2DPlotGlyph LinePlotGlyph
 */
FR.Chart.Type = {

    Bar:{
        plotType:"Bar2DPlotGlyph",
        dataSeries : "DataSeries",
        dataPoint : "DataPoint",
        xAxisGlyph : "CategoryAxisGlyph",
        yAxisGlyph : "ValueAxisGlyph",
        dataDefinition:"NormalDataDefinition",
        simpleIconType:"Column"
    },

    Bar3D:{
        plotType:"Bar3DPlotGlyph",
        dataSeries : "DataSeries",
        dataPoint : "DataPoint",
        xAxisGlyph : "CategoryAxisGlyph",
        yAxisGlyph : "ValueAxisGlyph",
        dataDefinition:"NormalDataDefinition",
        simpleIconType:"Column"
    },

    Line:{
        plotType:"LinePlotGlyph",
        dataSeries : "DataSeries",
        dataPoint : "DataPoint",
        xAxisGlyph : "CategoryAxisGlyph",
        yAxisGlyph : "ValueAxisGlyph",
        dataDefinition:"NormalDataDefinition",
        simpleIconType:"Line"
    },

    Area:{
        plotType:"AreaPlotGlyph",
        dataSeries : "DataSeries4Area",
        dataPoint : "DataPoint",
        xAxisGlyph : "CategoryAxisGlyph",
        yAxisGlyph : "ValueAxisGlyph",
        dataDefinition:"NormalDataDefinition",
        simpleIconType:"Area"
    },

    Area3D:{
        plotType:"Area3DPlotGlyph",
        dataSeries : "DataSeries4Area",
        dataPoint : "DataPoint",
        xAxisGlyph : "CategoryAxisGlyph",
        yAxisGlyph : "ValueAxisGlyph",
        dataDefinition:"NormalDataDefinition",
        simpleIconType:"Area"
    },

    Pie:{
        plotType:"PiePlotGlyph",
        dataSeries : "DataSeries",
        dataPoint : "DataPoint4Pie",
        dataDefinition:"NormalDataDefinition",
        simpleIconType:"Pie"
    },

    CompositePie:{
        plotType:"CompositePiePlotGlyph",
        dataSeries : "DataSeries",
        dataPoint : "DataPoint4Pie",
        dataDefinition:"NormalDataDefinition",
        simpleIconType:"Pie"
    },

    Pie3D:{
        plotType:"Pie3DPlotGlyph",
        dataSeries : "DataSeries",
        dataPoint : "DataPoint4Pie",
        dataDefinition:"NormalDataDefinition",
        simpleIconType:"Pie"
    },

    Custom:{
        plotType:"CustomPlotGlyph",
        dataSeries : "DataSeries",
        dataPoint : "DataPoint",
        xAxisGlyph : "CategoryAxisGlyph",
        yAxisGlyph : "ValueAxisGlyph",
        secondAxisGlyph : "ValueAxisGlyph",
        dataDefinition:"NormalDataDefinition",
        simpleIconType:"Custom"
    },

    Scatter:{
        plotType:"XYScatterPlotGlyph",
        dataSeries : "DataSeries",
        dataPoint : "DataPoint4XY",
        dataDefinition:"ScatterDefinition",
        simpleIconType:"Scatter"
    },

    Bubble:{
        plotType:"BubblePlotGlyph",
        dataSeries : "DataSeries",
        dataPoint : "DataPoint4Bubble",
        dataDefinition:"BubbleDefinition",
        simpleIconType:"Bubble"
    },

    Radar:{
        plotType:"RadarPlotGlyph",
        dataSeries : "DataSeries",
        dataPoint : "DataPoint",
        dataDefinition:"NormalDataDefinition",
        simpleIconType:"Radar"
    },

    Stock:{
        plotType:"StockPlotGlyph",
        dataSeries : "DataSeries",
        dataPoint : "DataPoint4Stock",
        dataDefinition:"StockDefinition",
        simpleIconType:"Stock"
    },

    Meter:{
        plotType:"MeterPlotGlyph",
        dataSeries : "DataSeries",
        dataPoint : "DataPoint",
        dataDefinition:"MeterDefinition",
        simpleIconType:"Meter"
    },

    Range:{
        plotType:"RangePlotGlyph",
        dataSeries : "DataSeries",
        dataPoint : "DataPoint",
        dataDefinition:"NormalDataDefinition",
        simpleIconType:"Range"
    },

    Gantt:{
        plotType:"GanttPlotGlyph",
        dataSeries : "DataSeries",
        dataPoint : "DataPoint4Gantt",
        dataDefinition:"GanttDefinition",
        simpleIconType:"Gantt"
    },

    Donut:{
        plotType:"Donut2DPlotGlyph",
        dataSeries : "DataSeries",
        dataPoint : "DataPoint",
        dataDefinition:"NormalDataDefinition",
        simpleIconType:"Donut"
    },

    Donut3D:{
        plotType:"Donut3DPlotGlyph",
        dataSeries : "DataSeries",
        dataPoint : "DataPoint",
        dataDefinition:"NormalDataDefinition",
        simpleIconType:"Donut"
    },

    Map:{
        plotType:"MapPlotGlyph",
        dataSeries:"DataSeries",
        dataPoint:"DataPoint4Map",
        dataDefinition:"MapSingleLayerDefinition",
        simpleIconType:"Map"
    },

    GisMap:{
        plotType:"GisMapPlotGlyph",
        dataSeries:"DataSeries",
        dataPoint:"DataPoint4GisMap",
        dataDefinition:"GisMapDefinition",
        simpleIconType:"GisMap"
    },

    getSimpleIconType:function(chartOption){
        if(!chartOption.chartType || !FR.Chart.Type[chartOption.chartType]){
            return "Column";
        }else{
            //okaycharts的属性
            var chartType = FR.Chart.Type[chartOption.chartType].simpleIconType;
            if(chartType == "Column" && chartOption.plot){
                chartType = chartOption.plot.isHorizontal ? "Bar" : "Column";
            }
            return chartType;
        }
    }
};

//兼容下接口名字和代码名字
FR.Chart.AxisConfig = {
    ValueAxis:"ValueAxisGlyph",
    CategoryAxis:"CategoryAxisGlyph",
    DateAxis:"DateAxisGlyph"
};

//位置和对齐方式
FR.Chart.Position = {
    "center":0,
    "top": 1,
    "left": 2,
    "bottom": 3,
    "right":4,
    "right-top":8,
    "inside": 5,
    "outside": 6
};

FR.Chart.PlotStyle = {
    "3D":1,
    "highlight":2,
    "gradient":4,
    "transparent":5
}

//超链的方式
FR.Chart.HyperlinkType = {
    JS:0,
    WEB:1,
    RELATE:2
};

/**
 * 填充的样式
 * @type {{fill: number, gradient: number}}
 */
FR.Chart.FillStyle = {
    "fill":1,
    "gradient":2
};

//分隔符
FR.Chart.Separator = [',','.',';',' ','{BR}'];

//比较
FR.Chart.Compare = {
    EQUALS:0,
    NOT_EQUAL:1,
    GREATER_THAN:2,
    GREATER_THAN_OR_EQUAL:3,
    LESS_THAN:4,
    LESS_THAN_OR_EQUAL:5
};

/**
 * 图表样式所用用的常量
 * @class FR.Chart.Style
 */
FR.Chart.Style = {
    /**
     * @static
     * @property 水平文本
     */
    HORIZONTALTEXT: 0,
    /**
     * @static
     * @property 垂直文本
     */
    VERTICALTEXT: 1,

    /**
     * @static
     * @property 右道左
     */
    RIGHT_TO_LEFT: 0,
    /**
     * @static
     * @property 左道右
     */
    LEFT_TO_RIGHT: 1,

    /**
     * @static
     * @property 格式的数据格式
     */
    format: null,
    /**
     * @static
     * @property 格式字体
     */
    frFont: null,

    /**
     * @static
     * @property 格式背景
     */
    background: null,

    /**
     * @static
     * @property 水平方向
     */
    horizontal_alignment: FR.Chart.Constants.LEFT,
    /**
     * @static
     * @property 垂直方向
     */
    vertical_alignment: FR.Chart.Constants.CENTER,

    /**
     * @static
     * @property 文本格式
     */
    textStyle: 0,
    /**
     * @static
     * @property 垂直文本
     */
    verticalText: 0,
    /**
     * @static
     * @property 文本方向
     */
    textDirection: 0,
    /**
     * @static
     * @property 角度旋转
     */
    rotation: 0,

    /**
     * @static
     * @property 图片布局
     */
    imageLayout: FR.Chart.Constants.IMAGE_DEFAULT
};