FR.Chart = FR.Chart || {};

/**
 * TODO:待补充
 * @class FR.Chart.TextAttr
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.TextAttr = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};
        this.frFont = js.font == undefined ? null : new FR.Chart.FRFont(js.font);

        this.direction = FR.pick(js.direction, FR.Chart.Style.LEFT_TO_RIGHT);
        this.rotation = FR.pick(js.rotation, 0);
        this.horizontalAlignment = FR.pick(js.horizontalAlignment, FR.Chart.Constants.LEFT);
        this.verticalAlignment = FR.pick(js.verticalAlignment, FR.Chart.Constants.CENTER);
        this.alignText = FR.pick(js.alignText, FR.Chart.Style.HORIZONTALTEXT);
    },

    clone: function () {
        var cloned = new FR.Chart.TextAttr();

        cloned.frFont = this.frFont;
        cloned.direction = this.direction;
        cloned.rotation = this.rotation;
        cloned.horizontalAlignment = this.horizontalAlignment;
        cloned.verticalAlignment = this.verticalAlignment;
        cloned.alignText = this.alignText;

        return cloned;
    }
});

/**
 * TODO:待补充
 * @class FR.Chart.AttrFillStyle
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.AttrFillStyle = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};

        this.colorStyle = FR.Chart.ChartUtils.getFillColorStyle(js.colorStyle);

        this.colorlist = [];
        if(js.definedColors){//优先加载默认的颜色
            this.colorlist = FR.Chart.DefinedColors[js.definedColors];
        }

        if (js.colorList) {
            for (var i = 0; i < js.colorList.length; i++) {
                this.colorlist[i] = js.colorList[i];
            }
        }
    },

    getColorIndex: function (index) {
        if (index >= 0) {
            return this.colorlist[index % this.colorlist.length];
        }

        return 'rgb(255, 255, 255)';
    },

    getColorSize: function () {
        return this.colorlist.length;
    },

    equals: function (condition) {
        return condition && condition instanceof FR.Chart.AttrFillStyle;
    }
});

/**
 * TODO:待补充
 * @class FR.Chart.AttrMarkerType
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.AttrMarkerType = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};

        this.markerType = js.markerType;
    },

    equals: function (condition) {
        return condition && condition instanceof FR.Chart.AttrMarkerType;
    }
});

/**
 * TODO:待补充
 * @class FR.Chart.AttrAxisPosition
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.AttrAxisPosition = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};

        this.axisPosition = FR.pick(js.axisPosition, "LEFT");
    },

    equals: function (condition) {
        return condition && condition instanceof FR.Chart.AttrAxisPosition;
    }
});

/**
 * TODO:待补充
 * @class FR.Chart.AttrAlpha
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.AttrAlpha = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};
        this.alpha = FR.pick(js.alpha, 1.0);
    },

    equals: function (condition) {
        return condition && condition instanceof FR.Chart.AttrAlpha;
    }
});

/**
 * TODO:待补充
 * @class FR.Chart.AttrBorder
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.AttrBorder = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};

        this.borderColor = FR.pick(js.borderColor, "black");
        this.borderStyle = FR.pick(js.borderStyle, FR.Chart.Constants.LINE_NONE);
        this.isRoundBorder = FR.pick(js.isRoundBorder, false);
    },

    equals: function (condition) {
        return condition && condition instanceof FR.Chart.AttrBorder;
    },

    setBorderColor: function (borderColor) {
        this.borderColor = borderColor;
    },

    getBorderColor: function () {
        return this.borderColor;
    },

    setBorderStyle: function (borderStyle) {
        this.borderStyle = borderStyle;
    },

    getBorderStyle: function () {
        return this.borderStyle;
    }
});

/**
 * TODO:待补充
 * @class FR.Chart.AttrBackground
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.AttrBackground = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};

        // 暂时只有ColorBackground, 全部转成图片之后过来.
        this.seriesBackground = FR.Chart.AbstractBackground.initBackground(js.seriesBackground);
    },

    equals: function (condition) {
        return condition && condition instanceof FR.Chart.AttrBackground;
    }
});

/**
 * TODO:待补充
 * @class FR.Chart.AttrColor
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.AttrColor = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};

        this.seriesColor = js.seriesColor;
    },

    equals: function (condition) {
        return condition && condition instanceof FR.Chart.AttrColor;
    },

    setSeriesColor: function (seriesColor) {
        this.seriesColor = seriesColor;
    },

    getSeriesColor: function () {
        return this.seriesColor;
    }
});

/**
 * TODO:待补充
 * @class FR.Chart.AttrLine
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.AttrLine = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};

        this.seriesLineColor = js.seriesLineColor;
        this.seriesLineStyle = FR.pick(js.seriesLineStyle, FR.Chart.Constants.LINE_THIN);
    },

    draw: function (ctx, shape) {
        if(!ctx){
            return;
        }
        ctx.save();

        if (this.seriesLineColor && this.seriesLineStyle != FR.Chart.Constants.LINE_NONE) {
            ctx.lineWidth = FR.Chart.GraphHelper.getLineStyleSize(this.seriesLineStyle);
            ctx.strokeStyle = this.seriesLineColor;

            shape.draw(ctx);
        }

        ctx.restore();
    },

    equals: function (condition) {
        return condition && condition instanceof FR.Chart.AttrLine;
    }
});

/**
 * 线条的样式
 * @class FR.Chart.AttrLineStyle
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.AttrLineStyle = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};

        this.lineStyle = FR.pick(js.lineStyle, FR.Chart.Constants.LINE_THIN);
    },

    equals: function (condition) {
        return condition && condition instanceof FR.Chart.AttrLineStyle;
    }
});

FR.Chart.AttrNullValueBreak = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};

        this.isNullValueBreak = FR.pick(js.isNullValueBreak, false);
    },

    equals: function (condition) {
        return condition && condition instanceof FR.Chart.AttrNullValueBreak;
    }
});

FR.Chart.AttrCurveLine = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};
        this.isCurve = FR.pick(js.isCurve, false);
    },

    equals: function (condition) {
        return condition && condition instanceof FR.Chart.AttrCurveLine;
    }
});

FR.Chart.AttrLineSeries = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};
        this.isCurve = FR.pick(js.isCurve, false);
        this.isNullValueBreak = FR.pick(js.isNullValueBreak, true);
        this.lineStyle = FR.pick(js.lineStyle, FR.Chart.Constants.LINE_THICK);
        this.markerType = FR.pick(js.markerType, FR.Chart.Marker.NullMarker);
        this.axisPosition = FR.pick(js.axisPosition, FR.Chart.CustomAttr.Axis_LEFT);
    },

    equals: function (condition) {
        return condition && condition instanceof FR.Chart.AttrLineSeries;
    }
});

FR.Chart.AttrBarSeries = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};
        this.seriesOverlapPercent = FR.pick(js.seriesOverlapPercent, -0.25);
        this.categoryIntervalPercent = FR.pick(js.categoryIntervalPercent, 1);
        this.axisPosition = FR.pick(js.axisPosition, FR.Chart.CustomAttr.Axis_LEFT);
    },

    equals: function (condition) {
        return condition && condition instanceof FR.Chart.AttrBarSeries;
    }
});

FR.Chart.AttrAreaSeries = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};
        this.isCurve = FR.pick(js.isCurve, false);
        this.markerType = FR.pick(js.markerType, FR.Chart.Marker.NullMarker);
        this.axisPosition = FR.pick(js.axisPosition, FR.Chart.CustomAttr.Axis_LEFT);
    },

    equals: function (condition) {
        return condition && condition instanceof FR.Chart.AttrAreaSeries;
    }
});

/**
 * 趋势线
 * @class FR.Chart.AttrTrendLine
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.AttrTrendLine = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        if (js && js.trendLineList) {
            this.trendLineList = [];
            for (var i = 0; i < js.trendLineList.length; i++) {
                this.trendLineList[i] = new FR.Chart.TrendLine(js.trendLineList[i]);
            }
        }
    },

    equals: function (condition) {
        return condition && condition instanceof FR.Chart.AttrTrendLine;
    }
});

/**
 * TODO:待补充
 * @class FR.Chart.AttrContents
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.AttrContents = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};

        this.seriesLabel = FR.pick(js.labelContent || js.seriesLabel || "");

        this.isShowGuidLine = FR.pick(js.leadLine || js.isShowGuidLine || false);

        this.position = FR.pick(FR.Chart.ChartUtils.getPosition(js.position), FR.Chart.Constants.TOP);

        this.isWhiteBackground = FR.pick(js.isWhiteBackground, true);

        this.isShowMutiSeries = FR.pick(js.isShowMutiSeries, false);

        this.textAttr = js.textAttr == undefined ? null : new FR.Chart.TextAttr(js.textAttr);
        this.format = js.valueFormat;
        this.percentFormat = js.percentFormat;
    },

    equals: function (condition) {
        return condition && condition instanceof FR.Chart.AttrContents;
    }
});

/**
 * 背景
 * @class FR.Chart.AbstractBackground
 * @abstract
 */
FR.Chart.AbstractBackground = {
    initBackground: function (js) {
        js = js || {};

        this.background = null;

        if (js.backgroundType) {
            // ImageBackground, GriantBackground, PatterBackground, TextureBackground, IntervalColorBackground
            if (js.backgroundType == "TextureBackground" || js.backgroundType == "PatternBackground") {
                this.background = new FR.Chart.PatterBackground(js);
            } else {
                this.background = new FR.Chart[js.backgroundType](js);
            }

            this.background.backgroundType = js.backgroundType;
        }

        return this.background;
    }
};

/**
 * 颜色类型的背景，使用参见{@link FR.Chart.ColorBackground#getInstance}
 * @class FR.Chart.ColorBackground
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.ColorBackground = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};

        this.color = js.color;
        this.isHorizontal = js.isHorizontal;
        this.backgroundType = FR.pick(js.backgroundType, "ColorBackground");
    },

    paint: function (ctx, shape) {
        if (this.color && shape && ctx) {
            ctx.save();
            ctx.fillStyle = this.color;

            shape.paint(ctx);

            ctx.strokeStyle = this.color;
            shape.draw(ctx);

            ctx.restore();
        }
    },

    draw: function (ctx, shape) {
        if (this.color && shape && ctx) {
            ctx.save();
            ctx.strokeStyle = this.color;

            shape.draw(ctx);
            ctx.restore();
        }
    }
});
$.extend(FR.Chart.ColorBackground, /**@class FR.Chart.ColorBackground*/{
    /**
     * @static
     * @param color 颜色
     * @returns {FR.Chart.ColorBackground} 颜色背景
     */
    getInstance: function (color) {
        var background = new FR.Chart.ColorBackground();
        background.color = color;
        return background;
    }
});


/**
 * 交互色背景
 * @class FR.Chart.IntervalColorBackground
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.IntervalColorBackground = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};

        this.bgColor = js.bgColor;
        this.position = FR.pick(js.position, FR.Chart.Constants.LEFT);
        this.intervalLength = FR.pick(js.intervalLength, 0);
    },

    paint: function (ctx, shape) {
        if (this.intervalLength <= 0 || this.bgColor == null || this.bgColor == "") {
            return;
        }

        if (shape instanceof FR.Chart.Bounds && ctx) {
            ctx.save();

            var newBounds = FR.Chart.GraphHelper.dealRectShape4JSPaint(shape);

            var axisGap = 1;// 预留axisGap
            var width = newBounds.width - axisGap * 2;
            var height = newBounds.height - axisGap * 2;
            var x = newBounds.x + axisGap;
            var y = newBounds.y + newBounds.height + axisGap;

            ctx.fillStyle = this.bgColor;

            var vNumber = parseInt(height / this.intervalLength);
            var hNumber = parseInt(width / this.intervalLength);
            // 水平或者垂直 依赖于值轴. (相对垂直相交)
            if (this.position == FR.Chart.Constants.LEFT || this.position == FR.Chart.Constants.RIGHT) {
                for (var i = 0; i < vNumber; i++) {
                    if (i % 2 === 0) {
                        ctx.fillRect(x, y - (i + 1) * this.intervalLength, width, this.intervalLength);
                    }
                }
                if (vNumber % 2 === 0) {
                    ctx.fillRect(x, newBounds.y, width, height - vNumber * this.intervalLength);
                }
            } else {
                for (var i = 0; i < hNumber; i++) {
                    if (i % 2 === 0) {
                        ctx.fillRect(x + i * this.intervalLength, newBounds.y, this.intervalLength, height);
                    }
                }
                if (hNumber % 2 === 0) {
                    ctx.fillRect(x + hNumber * this.intervalLength, newBounds.y, width - hNumber * this.intervalLength, height);
                }
            }

            ctx.restore();
        }
    }
});

/**
 * 渐变色背景
 * @class FR.Chart.GradientBackground
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.GradientBackground = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};

        this.useCell = FR.pick(js.useCell, true);
        this.direction = FR.pick(js.direction, 0);
        this.cyclic = js.cyclic;
        this.begin = FR.pick(js.begin, 0);
        this.finish = FR.pick(js.finish, 0);
        this.beginColor = js.beginColor;
        this.endColor = js.endColor;

        this.backgroundType = js.backgroundType || "GradientBackground";
    },

    createRadialPaint:function (ctx,shape){
        var centerPoint = shape.getCenterPoint();
        var paint = ctx.createRadialGradient(centerPoint.x, centerPoint.y, shape.getInnerRadius(), centerPoint.x, centerPoint.y, shape.getOuterRadius());
        paint.addColorStop(0, this.beginColor);
        paint.addColorStop(1, this.endColor);
        return paint;
    },


    createPaint: function (ctx, shape) {
        var bounds = shape.getBounds2D();
        var lineGradient;

        if(this.useCell){
            if (this.direction == FR.Chart.GradientBackground.LEFT2RIGHT) {
                lineGradient = ctx.createLinearGradient(bounds.x, bounds.y, bounds.x + bounds.width, bounds.y);
            } else if (this.direction == FR.Chart.GradientBackground.TOP2BOTTOM) {
                lineGradient = ctx.createLinearGradient(bounds.x, bounds.y, bounds.x, bounds.y + bounds.height);
            }
        }else{
            if(this.direction == FR.Chart.GradientBackground.LEFT2RIGHT){
                lineGradient = ctx.createLinearGradient(this.begin, bounds.y, this.finish, bounds.y);
            }else if(this.direction == FR.Chart.GradientBackground.TOP2BOTTOM){
                lineGradient = ctx.createLinearGradient(bounds.x, this.begin, bounds.x, this.finish);
            }
        }

        lineGradient.addColorStop(0, this.beginColor);
        lineGradient.addColorStop(1, this.endColor);

        return lineGradient;
    },

    draw: function (ctx, shape) {
        if (shape == null || this.beginColor == null || this.endColor == null || !ctx) {
            return;
        }

        ctx.save();

        ctx.strokeStyle =shape.isNeedRadialGradient()?this.createRadialPaint(ctx,shape):this.createPaint(ctx, shape);
        shape.draw(ctx);

        ctx.restore();
    },

    paint: function (ctx, shape) {
        if (shape == null || this.beginColor == null || this.endColor == null || !ctx) {
            return;
        }

        ctx.save();

        ctx.fillStyle =shape.isNeedRadialGradient()?this.createRadialPaint(ctx,shape): this.createPaint(ctx, shape);
        shape.paint(ctx);

        ctx.restore();
    }
});
$.extend(FR.Chart.GradientBackground, /**@class FR.Chart.GradientBackground*/{
    /**
     * @static
     * @property 从上到下渐变
     */
    TOP2BOTTOM: 1,

    /**
     * @static
     * @property 从左到右渐变
     */
    LEFT2RIGHT: 0
});

/**
 * 图案、自定义图片以及文理背景
 * @class FR.Chart.ImageBackground
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.ImageBackground = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};

        if (FR.Browser.isIE() || FR.Chart.ChartUtils.isIE11()) {
            this.iesrc = js.iesrc;
        } else {
            this.src = js.src;
        }

        this.layout = FR.pick(js.layout, FR.Chart.Constants.IMAGE_TILED);

        this.specifiedImageHeight = FR.pick(js.specifiedImageHeight, -1);
        this.specifiedImageWidth = FR.pick(js.specifiedImageWidth, -1);

        this.imgWidth = js.imgWidth;
        this.imgHeight = js.imgHeight;

        this.backgroundType = FR.pick(js.backgroundType, 'PatterBackground');
    },

    draw: function (ctx, shape) {
        if (FR.Browser.isIE() || FR.Chart.ChartUtils.isIE11()) {
            if(!this.iesrc || this.iesrc == "") {
                return;
            }
        } else {
            if(!this.src || this.src == "" ) {
                return;
            }
        }

        var image = new Image();

        var tmpAlpha = ctx.globalAlpha;

        image.onload = function () {
            ctx.globalAlpha = tmpAlpha;
            ctx.strokeStyle = ctx.createPattern(image, 'repeat');
            shape.draw(ctx);
        };

        if (FR.Browser.isIE() || FR.Chart.ChartUtils.isIE11()) {
            image.src = FR.servletURL + "?op=fr_attach&cmd=ah_image&id=" + this.iesrc;
        } else {
            image.src = this.src;
        }
    },

    paint: function (ctx, shape) {
        if (FR.Browser.isIE() || FR.Chart.ChartUtils.isIE11()) {
            if(!this.iesrc || this.iesrc == "") {
                return;
            }
        } else {
            if(!this.src || this.src == "" ) {
                return;
            }
        }

        var ib = this;

        var image = new Image();
        if (FR.Browser.isIE() || FR.Chart.ChartUtils.isIE11()) {
            image.src = FR.servletURL + "?op=fr_attach&cmd=ah_image&id=" + this.iesrc;
        } else {
            image.src = this.src;
        }

        var tmpAlpha = ctx.globalAlpha;

        if (image.complete) {// 应对IE下的缓存图片, 导致不需要位移.
            ctx.globalAlpha = tmpAlpha;
            ib.paintImg(ctx, shape, image, ib);
        } else {
            image = new Image();
            image.onload = function () {
                ctx.globalAlpha = tmpAlpha;
                ib.paintImg(ctx, shape, image, ib);
            };

            if (FR.Browser.isIE() || FR.Chart.ChartUtils.isIE11()) {
                image.src = FR.servletURL + "?op=fr_attach&cmd=ah_image&id=" + this.iesrc;
            } else {
                image.src = this.src;
            }
        }
    },

    paintImg: function (ctx, shape, image, ib) {
        if(!ctx){
            return;
        }

        ctx.save();

        ctx.fillStyle = "rgba(255,255,255,0.01)";
        shape.paint(ctx);
        ctx.clip();

        var bounds = shape.getBounds2D();

        var width = bounds.width;
        var height = bounds.height;

        if (!ib.imgWidth) {
            ib.imgWidth = image.width;
        }
        if (!ib.imgHeight) {
            ib.imgHeight = image.height;
        }

        var imgWidth;
        if (ib.specifiedImageWidth == -1) {
            imgWidth = ib.imgWidth;
        } else {
            imgWidth = ib.specifiedImageWidth;
        }

        var imgHeight;
        if (ib.specifiedImageHeight == -1) {
            imgHeight = ib.imgHeight;
        } else {
            imgHeight = ib.specifiedImageHeight;
        }

        if (ib.layout == FR.Chart.Constants.IMAGE_TILED) {

            if (imgWidth < 0 || imgHeight < 0) {
                return;
            }

            for (var x = 0; x < width; x += imgWidth) { // 不超出边界, 加入sWidth, sHeight 判断
                var sWidth = width - x > imgWidth ? imgWidth : width - x;
                for (var y = 0; y < height; y += imgHeight) {
                    var sHeight = height - y > imgHeight ? imgHeight : height - y;
                    ctx.drawImage(image, 0, 0, sWidth, sHeight,
                        bounds.x + x, bounds.y + y, sWidth, sHeight);
                }
            }

        } else if (ib.layout == FR.Chart.Constants.IMAGE_CENTER) {
            var dx, dy, dwidth, dheight, sx, sy, swidth, sheight;
            if (width < imgWidth) {
                dx = (imgWidth - width) * 0.5;
                sx = 0;
            } else {
                dx = 0;
                sx = (width - imgWidth) * 0.5;
            }
            if (height < imgHeight) {
                dy = (imgHeight - height) * 0.5;
                sy = 0;
            } else {
                dy = 0;
                sy = (height - imgHeight) * 0.5;
            }

            dwidth = Math.min(width, ib.imgWidth);
            swidth = Math.min(width, imgWidth);
            dheight = Math.min(height, ib.imgHeight);
            sheight = Math.min(height, imgHeight);

            ctx.drawImage(image, dx, dy, dwidth, dheight, bounds.x + sx, bounds.y + sy, swidth, sheight);

        } else if (ib.layout == FR.Chart.Constants.IMAGE_EXTEND) {

            ctx.drawImage(image, bounds.x, bounds.y, width, height);

        } else if (ib.layout == FR.Chart.Constants.IMAGE_DEFAULT) {

            ctx.drawImage(image, 0, 0, Math.min(width, ib.imgWidth), Math.min(height, ib.imgHeight),
                bounds.x, bounds.y, Math.min(width, imgWidth), Math.min(height, imgHeight));
        } else if (ib.layout == FR.Chart.Constants.IMAGE_ADJUST) {
            var imageWidth = ib.imgWidth;
            var imageHeight = ib.imgHeight;

            var scaleWidth = width / imageWidth;
            var scaleHeight = height / imageHeight;

            var x = bounds.x;
            var y = bounds.y;

            var paintWidth = width;
            var paintHeight = height;

            if (scaleWidth > scaleHeight) {
                paintWidth = (width * scaleHeight / scaleWidth);
                x = (width - paintWidth) / 2 + bounds.x;
            } else {
                paintHeight = (height * scaleWidth / scaleHeight);
                y = (height - paintHeight) / 2 + bounds.y;
            }
            ctx.drawImage(image, x, y, paintWidth, paintHeight);
        }
        else {
            ctx.drawImage(image, bounds.x, bounds.y, width, height);
        }

        ctx.restore();
    }
});

/**
 * 图案和文理背景
 * @class FR.Chart.PatterBackground
 * @extends FR.Chart.ImageBackground
 */
FR.Chart.PatterBackground = FR.extend(FR.Chart.ImageBackground, {
    paint: function (ctx, shape) {
        if (FR.Browser.isIE() || FR.Chart.ChartUtils.isIE11()) {
            if(!this.iesrc || this.iesrc == "") {
                return;
            }
        } else {
            if(!this.src || this.src == "" ) {
                return;
            }
        }

        if(!ctx){
            return;
        }
        ctx.save();
        var image = new Image();

        if (FR.Browser.isIE() || FR.Chart.ChartUtils.isIE11()) {
            image.src = FR.servletURL + "?op=fr_attach&cmd=ah_image&id=" + this.iesrc;
        } else {
            image.src = this.src;
        }

        if (image.complete) {// 应对IE下的缓存图片, 导致不需要位移.
            ctx.globalAlpha = tmpAlpha;
            ctx.fillStyle = ctx.createPattern(image, 'repeat');
            shape.paint(ctx);
        } else {
            image = new Image();

            var tmpAlpha = ctx.globalAlpha;
            var xylist = ctx.xylist;
            image.onload = function () {
                ctx.globalAlpha = tmpAlpha;
                ctx.fillStyle = ctx.createPattern(image, 'repeat');
                if (xylist) {
                    for (var i = 0; i < xylist.length; i = i + 2) {
                        ctx.translate(xylist[i], xylist[i + 1]);
                    }
                }
                shape.paint(ctx);
                if (xylist) {
                    for (var i = 0; i < xylist.length; i = i + 2) {
                        ctx.translate(-xylist[i], -xylist[i + 1]);
                    }
                }
            };

            if (FR.Browser.isIE() || FR.Chart.ChartUtils.isIE11()) {
                image.src = FR.servletURL + "?op=fr_attach&cmd=ah_image&id=" + this.iesrc;
            } else {
                image.src = this.src;
            }
        }

        ctx.restore();
    }
});

/**
 * 高光图表
 * @class FR.Chart.HighLightChart
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.HighLightChart = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        this.shape = null;
        this.isHorizontal = false;
    },

    paintStyle: function (ctx) {
        if (this.shape == null || FR.Chart.GraphHelper.isBoundsNaN(this.shape.getBounds2D())) {
            return;
        }
        if(!ctx){
            return;
        }
        ctx.save();

        var x = this.shape.getBounds2D().x;
        var y = this.shape.getBounds2D().y;

        var width = this.shape.getBounds2D().width;
        var height = this.shape.getBounds2D().height;

        // 矩形
        if (this.shape instanceof FR.Chart.Bounds) {

            var highLightpaint;
            var recHight;
            if (this.isHorizontal) {
                highLightpaint = ctx.createLinearGradient(x, y, x, y + height / 2);
                recHight = new FR.Chart.Bounds(x, y, width, height / 2);
            } else {
                highLightpaint = ctx.createLinearGradient(x, y, x + width / 2, y);
                recHight = new FR.Chart.Bounds(x, y, width / 2, height);
            }
            // 1728053247
            highLightpaint.addColorStop(0, 'rgba(255, 255, 255, 0.4)');
            highLightpaint.addColorStop(1, 'rgba(255, 255, 255, 0.1)');

            ctx.fillStyle = highLightpaint;
            recHight.paint(ctx);

            // 饼图Arc2D
        } else if (this.shape instanceof FR.Chart.Arc2D) {
            var cx = this.shape.x, cy = this.shape.y;
            var r = this.shape.radius;

            var c1 = (cx + r * Math.cos(330 * Math.PI / 180));
            var c2 = (cy - r * Math.sin(330 * Math.PI / 180));
            var endx = (cx + r * Math.cos(60 * Math.PI / 180));
            var endy = (cy - r * Math.sin(60 * Math.PI / 180));

            var highLightpaint = ctx.createRadialGradient(x, y, 0, x, y, r * 1.5);

            highLightpaint.addColorStop(0, 'rgba(255, 255, 255, 0.4)');
            highLightpaint.addColorStop(1, 'rgba(255, 255, 255, 0.1)');

            ctx.fillStyle = highLightpaint;

            ctx.beginPath();
            ctx.moveTo(endx, endy);
            //  从java60度位置. 到java 240的位置
            ctx.arc(cx, cy, r, 5 * Math.PI / 3, Math.PI * 2 / 3, true);
            ctx.quadraticCurveTo(c1, c2, endx, endy);
            ctx.fill();
        }

        ctx.restore();
    }
});

/**
 * 外发光图表
 * @class FR.Chart.OuterLight
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.OuterLight = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};

        this.outerSize = js.outerSize == undefined ? 0 : js.outerSize;
        this.outerAlpha = js.outerAlpha == undefined ? 0 : js.outerAlpha;
        this.outerColor = js.outerColor || null;
    },

    paint: function (ctx, shape, strokeSize) {
        if (FR.Browser.isIE()) {
            return;
        }

        if (shape == null || this.outerSize === 0 || this.outerAlpha === 0
            || this.outerColor == null) {
            return;
        }
        if(!ctx){
            return;
        }
        ctx.save();

        // 阴影之后. 模糊当作高亮
        ctx.shadowBlur = this.outerSize / 2;

        ctx.shadowColor = 'rgba(' + FR.Chart.Color.getColorArray(this.outerColor) + ',' + this.outerAlpha + ')';

        ctx.shadowOffsetY = 0;
        ctx.shadowOffsetX = 0;

        if (strokeSize <= 0) {
            shape.paint(ctx);
        } else {
            shape.draw(ctx);
        }
        ctx.restore();
    }
});


/**
 * 阴影，IE不支持才用的这个shadow，其他的直接使用的canvas的的接口
 * @class FR.Chart.Shadow
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.Shadow = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};

        this.shadowSize = js.shadowSize == undefined ? 0 : js.shadowSize;
        this.shadowAlpha = js.shadowAlpha == undefined ? 0 : js.shadowAlpha;
        this.shadowColor = js.shadowColor == undefined ? 'gray' : js.shadowColor;
    },

    paint: function (ctx, shape, strokeSize) {
        if (FR.Browser.isIE()) {
            return; // IE下直接跳过, 等到IE9之后再说
        }

        if (shape == null || this.shadowSize === 0 || this.shadowAlpha === 0
            || this.shadowColor == null) {
            return;
        }
        if(!ctx){
            return;
        }
        ctx.save();

        ctx.globalAlpha = this.shadowAlpha;
        // 要处理ShadowColor 加入透明度.
        var color = 'rgba(' + FR.Chart.Color.getColorArray(this.shadowColor) + ',' + this.shadowAlpha + ')';
        ctx.shadowColor = this.shadowColor;
        ctx.fillStyle = this.shadowColor;

        var xy = this.shadowSize / 30 * 6;
        var blurXY = this.shadowSize; // this.shadowSize/2 是设计器中真实的size, 然后*2 为FF下效果
        ctx.shadowOffsetX = this.shadowSize / 2 - xy;
        ctx.shadowOffsetY = this.shadowSize / 2 - xy;
        // 设计器的效果的size: 5, 10, 15, 分别对应FF下shadowBlure效果10, 20, 30, 偏移量(-2,-2)(-4,-4)(-6,-6);
        if (blurXY < 10) {// 小于10的时候, 同步设计器 大概在1像素多点的阴影
            blurXY = this.shadowSize / 4;
        }
        ctx.shadowBlur = blurXY;

        // Chrome,FF下 大概为Java下的1/3
        ctx.shadowBlur = blurXY / 3;

        if (strokeSize <= 0) {
            shape.paint(ctx);
        } else {
            shape.draw(ctx);
        }

        ctx.restore();
    }
});


/**
 * 透明图表
 * @class FR.Chart.TransparentChart
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.TransparentChart = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};
        this.color = js.color;
        this.avoidOriginDraw = !!js.avoidOriginDraw;
        this.axisReversed = js.axisReversed;
        this.alpha = FR.pick(js.alpha, 1);
        this.borderColor = js.borderColor;
        this.borderWidth  =js.borderWidth;
    },

    getPaintAlpha: function () {
        return this.alpha === undefined ? 0.33 : this.alpha;
    },

    getStrokeAlpha: function () {
        return this.alpha === undefined ? 0.7 : this.alpha;
    },

    getStrokeLineColor:function(){
        return this.borderColor === undefined ? this.color:this.borderColor;
    },

    getStrokeLineWidth: function () {
        return this.borderWidth === undefined ? 2 : this.borderWidth;
    }

});

/**
 * TODO:待补充
 * @class FR.Chart.BarTransparentChart
 * @extends FR.Chart.TransparentChart
 */
FR.Chart.BarTransparentChart = FR.extend(FR.Chart.TransparentChart, {
    initConstants: function (js) {
        js = js || {};
        this.rect = js.rect;
        this.newRect = this.rect;
        this.isHorizontal = !!js.isHorizontal;
        FR.Chart.BarTransparentChart.superclass.initConstants.apply(this, [js]);
    },

    clone: function (newRect) {
        var newObj = new FR.Chart.BarTransparentChart();
        newObj.rect = this.rect;
        newObj.isHorizontal = this.isHorizontal;
        newObj.newRect = newRect;
        newObj.color = this.color;
        newObj.avoidOriginDraw = this.avoidOriginDraw;
        newObj.axisReversed = this.axisReversed;
        newObj.alpha = this.alpha ;
        newObj.borderColor = this.borderColor;
        newObj.borderWidth  =this.borderWidth;
        return newObj;
    },

    paintStyle: function (ctx) {
        if(!ctx){
            return;
        }
        ctx.save();

        //填充
        ctx.fillStyle = this.color;
        ctx.globalAlpha = this.getPaintAlpha();
        this.newRect.paint(ctx);

        //画边框
        ctx.strokeStyle = this.getStrokeLineColor();
        ctx.globalAlpha = this.getStrokeAlpha();
        ctx.lineWidth = this.getStrokeLineWidth();

        if (this.axisReversed !== this.rect.isNigativeValue) {
            if (this.isHorizontal) {
                this.newRect.drawWithOutRight(ctx);
            } else {
                this.newRect.drawWithOutTop(ctx);
            }
        } else {
            if (this.isHorizontal) {
                this.newRect.drawWithOutLeft(ctx);
            } else {
                this.newRect.drawWithOutBottom(ctx);
            }

        }
        ctx.restore();
    }

});


/**
 * TODO:待补充
 * @class FR.Chart.StackedBarTransparentChartStyle
 * @extends FR.Chart.TransparentChart
 */
FR.Chart.StackedBarTransparentChartStyle = FR.extend(FR.Chart.TransparentChart, {
    initConstants: function (js) {
        js = js || {};
        this.rect = js.rect;
        this.newRect = this.rect;
        this.totalRect = js.rect;
        this.isFirst = false; //堆积图是否是第一个
        this.isHorizontal = !!js.isHorizontal;
        FR.Chart.StackedBarTransparentChartStyle.superclass.initConstants.apply(this, [js]);
    },

    clone: function (newRect) {
        var newObj = new FR.Chart.StackedBarTransparentChartStyle();
        newObj.rect = this.rect;
        newObj.isHorizontal = this.isHorizontal;
        newObj.newRect = newRect;
        newObj.color = this.color;
        newObj.isFirst = this.isFirst;
        newObj.avoidOriginDraw = this.avoidOriginDraw;
        newObj.axisReversed = this.axisReversed;
        newObj.alpha = this.alpha ;
        newObj.borderColor = this.borderColor;
        newObj.borderWidth  =this.borderWidth;
        return newObj;
    },

    paintStyle: function (ctx) {
        if(!ctx){
            return;
        }
        ctx.save();

        //填充
        ctx.fillStyle = this.color;
        ctx.globalAlpha = this.getPaintAlpha();
        this.newRect.paint(ctx);

        //画边框
        ctx.strokeStyle = this.getStrokeLineColor();
        ctx.globalAlpha = this.getStrokeAlpha();
        ctx.lineWidth = this.getStrokeLineWidth();

        if (this.isHorizontal) {
            if (this.isFirst) { //三条边
                if (this.axisReversed) {
                    this.newRect.drawWithOutRight(ctx);
                } else {
                    this.newRect.drawWithOutLeft(ctx);
                }
            } else {//两条边
                this.newRect.drawTopAndBottom(ctx);
            }
        } else {
            if (this.isFirst) {
                if (this.axisReversed) {
                    this.newRect.drawWithOutTop(ctx);
                } else {
                    this.newRect.drawWithOutBottom(ctx);
                }
            } else {
                this.newRect.drawLeftAndRight(ctx);
            }
        }

        ctx.restore();
    }
});


/**
 * TODO:待补充
 * @class FR.Chart.ArcTransparentChartStyle
 * @extends FR.Chart.TransparentChart
 */
FR.Chart.ArcTransparentChartStyle = FR.extend(FR.Chart.TransparentChart, {
    initConstants: function (js) {
        js = js || {};
        this.arcShape = js.arcShape;
        this.newArc = this.arcShape;
        FR.Chart.ArcTransparentChartStyle.superclass.initConstants.apply(this, [js]);
    },

    clone: function (newArc) {
        var newObj = new FR.Chart.ArcTransparentChartStyle();
        newObj.arcShape = this.arcShape;
        newObj.newArc = newArc;
        newObj.color = this.color;
        newObj.avoidOriginDraw = this.avoidOriginDraw;
        newObj.alpha = this.alpha ;
        newObj.borderColor = this.borderColor;
        newObj.borderWidth  =this.borderWidth;
        return newObj;
    },

    paintStyle: function (ctx) {
        if(!ctx){
            return;
        }
        ctx.save();

        //填充
        ctx.fillStyle = this.color;
        ctx.globalAlpha = this.getPaintAlpha();
        this.newArc.paint(ctx);

        //画边框
        ctx.strokeStyle = this.getStrokeLineColor();
        ctx.globalAlpha = this.getStrokeAlpha();
        ctx.lineWidth = this.getStrokeLineWidth();
        this.newArc.draw(ctx);

        ctx.restore();
    }
});


/**
 * TODO:待补充
 * @class FR.Chart.AreaTransparentChartStyle
 * @extends FR.Chart.TransparentChart
 */
FR.Chart.AreaTransparentChartStyle = FR.extend(FR.Chart.TransparentChart, {
    initConstants: function (js) {
        js = js || {};
        this.areaPath = js.areaPath;
        this.newArea = this.areaPath;
        FR.Chart.AreaTransparentChartStyle.superclass.initConstants.apply(this, [js]);
    },

    clone: function (newArea) {
        var newObj = new FR.Chart.AreaTransparentChartStyle();
        newObj.areaPath = this.areaPath;
        newObj.newArea = newArea;
        newObj.color = this.color;
        newObj.avoidOriginDraw = this.avoidOriginDraw;
        newObj.alpha = this.alpha ;
        newObj.borderColor = this.borderColor;
        newObj.borderWidth  =this.borderWidth;
        return newObj;
    },

    paintStyle: function (ctx) {
        if(!ctx){
            return;
        }
        ctx.save();

        ctx.fillStyle = this.color;
        ctx.globalAlpha = this.getPaintAlpha();
        this.newArea.paint(ctx);

        ctx.restore();
    }
});

/**
 * TODO:待补充
 * @class FR.Chart.TopDownShadeChart
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.TopDownShadeChart = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};
        this.color = js.color;
        this.avoidOriginDraw = !!js.avoidOriginDraw;
        this.axisReversed = js.axisReversed;
        this.alpha = FR.pick(js.alpha, 1);
        this.borderColor = js.borderColor;
        this.borderWidth  =js.borderWidth;
    },

    getStartColor: function () {
        return this.color;
    },

    getEndColor: function () {
        var rgb = FR.Chart.Color.getColorArray(this.color);
        var hsb = FR.Chart.Color.RGB2HSB(rgb[0], rgb[1], rgb[2]);
        return FR.Chart.Color.getColor(FR.Chart.Color.HSB2RGB(hsb[0], 0.13, 0.94));
    },

    getLineColor: function () {
        var rgb = FR.Chart.Color.getColorArray(this.color);
        var hsb = FR.Chart.Color.RGB2HSB(rgb[0], rgb[1], rgb[2]);
        return FR.Chart.Color.getColor(FR.Chart.Color.HSB2RGB(hsb[0], hsb[1] + 0.1, hsb[2] - 0.1));
    }

});

/**
 * TODO:待补充
 * @class FR.Chart.BarTopDownShadeStyle
 * @extends FR.Chart.TopDownShadeChart
 */
FR.Chart.BarTopDownShadeStyle = FR.extend(FR.Chart.TopDownShadeChart, {
    initConstants: function (js) {
        js = js || {};
        this.rect = js.rect;
        this.isHorizontal = !!js.isHorizontal;
        this.newRect = this.rect; //newRect是真正画的rect
        FR.Chart.BarTopDownShadeStyle.superclass.initConstants.apply(this, [js]);
    },

    clone: function (newRect) {
        var newObj = new FR.Chart.BarTopDownShadeStyle();
        newObj.rect = this.rect;
        newObj.isHorizontal = this.isHorizontal;
        newObj.newRect = newRect;
        newObj.color = this.color;
        newObj.avoidOriginDraw = this.avoidOriginDraw;
        newObj.axisReversed = this.axisReversed;
        newObj.alpha = this.alpha ;
        newObj.borderColor = this.borderColor;
        newObj.borderWidth  =this.borderWidth;
        return newObj;
    },

    paintStyle: function (ctx) {
        if (this.color) {

            if (FR.Chart.GraphHelper.isBoundsNaN(this.rect)) {
                return;
            }
            if(!ctx){
                return;
            }
            ctx.save();

            ctx.globalAlpha = this.alpha;
            if (this.isHorizontal) {
                this.horizontalPaint(ctx);
                this.horizontalDraw(ctx);
            } else {
                this.verticalPaint(ctx);
                this.verticalDraw(ctx);
            }

            ctx.restore();
        }
    },

    horizontalPaint: function (ctx) {
        if(!ctx){
            return;
        }
        ctx.save();
        var width = this.rect.width;
        var x = this.rect.x;
        var y = this.rect.y;
        var paint;
        if (this.axisReversed) {
            if (this.rect.isNigativeValue) {
                paint = ctx.createLinearGradient(x + width, y, x, y)
            } else {
                paint = ctx.createLinearGradient(x, y, x + width, y)
            }
        } else {
            if (this.rect.isNigativeValue) {
                paint = ctx.createLinearGradient(x, y, x + width, y)
            } else {
                paint = ctx.createLinearGradient(x + width, y, x, y)
            }
        }
        paint.addColorStop(0, this.getStartColor());
        paint.addColorStop(1, this.getEndColor());
        ctx.fillStyle = paint;
        this.newRect.paint(ctx);
        ctx.restore();
    },

    horizontalDraw: function (ctx) {
        if(!ctx){
            return;
        }
        ctx.save();
        ctx.strokeStyle = this.getLineColor();
        ctx.lineWidth = 1;
        if (this.axisReversed) {
            if (this.rect.isNigativeValue) {
                this.newRect.drawWithOutLeft(ctx);
            } else {
                this.newRect.drawWithOutRight(ctx);
            }
        } else {
            if (this.rect.isNigativeValue) {
                this.newRect.drawWithOutRight(ctx);
            } else {
                this.newRect.drawWithOutLeft(ctx);
            }
        }
        ctx.restore();
    },

    verticalPaint: function (ctx) {
        if(!ctx){
            return;
        }
        ctx.save();
        var height = this.rect.height;
        var x = this.rect.x;
        var y = this.rect.y;
        var paint;
        if (this.axisReversed) {
            if (this.rect.isNigativeValue) {
                paint = ctx.createLinearGradient(x, y, x, y + height);
            } else {
                paint = ctx.createLinearGradient(x, y + height, x, y);
            }
        } else {
            if (this.rect.isNigativeValue) {
                paint = ctx.createLinearGradient(x, y + height, x, y);
            } else {
                paint = ctx.createLinearGradient(x, y, x, y + height);
            }
        }
        paint.addColorStop(0, this.getStartColor());
        paint.addColorStop(1, this.getEndColor());
        ctx.fillStyle = paint;
        this.newRect.paint(ctx);
        ctx.restore();
    },

    verticalDraw: function (ctx) {
        if(!ctx){
            return;
        }
        ctx.save();
        ctx.strokeStyle = this.getLineColor();
        ctx.lineWidth = 1;
        if (this.axisReversed) {
            if (this.rect.isNigativeValue) {
                this.newRect.drawWithOutBottom(ctx);
            } else {
                this.newRect.drawWithOutTop(ctx);
            }
        } else {
            if (this.rect.isNigativeValue) {
                this.newRect.drawWithOutTop(ctx);
            } else {
                this.newRect.drawWithOutBottom(ctx);
            }
        }
        ctx.restore();
    }

});

/**
 * TODO:待补充
 * @class FR.Chart.StackedBarTopDownShadeStyle
 * @extends FR.Chart.TopDownShadeChart
 */
FR.Chart.StackedBarTopDownShadeStyle = FR.extend(FR.Chart.TopDownShadeChart, {
    initConstants: function (js) {
        js = js || {};
        this.rect = js.rect;
        this.totalRect = js.rect;
        this.isHorizontal = !!js.isHorizontal;
        this.newRect = this.rect;
        FR.Chart.StackedBarTopDownShadeStyle.superclass.initConstants.apply(this, [js]);
    },

    clone: function (newRect) {
        var newObj = new FR.Chart.StackedBarTopDownShadeStyle();
        newObj.rect = this.rect;
        newObj.isHorizontal = this.isHorizontal;
        newObj.newRect = newRect;
        newObj.color = this.color;
        newObj.avoidOriginDraw = this.avoidOriginDraw;
        newObj.totalRect = this.totalRect;
        newObj.isFirst = this.isFirst;
        newObj.axisReversed = this.axisReversed;
        return newObj;
    },

    paintStyle: function (ctx) {
        if(!ctx){
            return;
        }
        ctx.save();
        ctx.globalAlpha = this.alpha;

        if (this.animateGlyph) {
            this.animateGlyph.drawWithOutStyle(ctx);
        }

        var startColor = 'rgba(255, 255, 255, 0)';
        var endColor = 'rgba(255, 255, 255,0.73)';
//        一层渐变的白色
        if (this.isFirst) {
            var paint;
            var x = this.totalRect.x;
            var y = this.totalRect.y;
            var width = this.totalRect.width;
            var height = this.totalRect.height;

            if (this.axisReversed) {
                if (this.isHorizontal) {
                    paint = ctx.createLinearGradient(x, y, x + width, y);
                } else {
                    paint = ctx.createLinearGradient(x, y + height, x, y);
                }

            } else {
                if (this.isHorizontal) {
                    paint = ctx.createLinearGradient(x + width, y, x, y);
                } else {
                    paint = ctx.createLinearGradient(x, y, x, y + height);
                }
            }
            paint.addColorStop(0, startColor);
            paint.addColorStop(1, endColor);
            ctx.fillStyle = paint;
            this.totalRect.paint(ctx);
        }

        //边框老是被覆盖，往外扩一点
        var x = this.newRect.x;
        var y = this.newRect.y;
        var width = this.newRect.width;
        var height = this.newRect.height;
        var tmpRect = new FR.Chart.Bounds(x - 1, y - 1, width + 1, height + 1);

        ctx.strokeStyle = this.getLineColor();
        ctx.lineWidth = 1;

        if (this.isFirst) {//最上面的数据点才有
            if (this.axisReversed) {
                if (this.isHorizontal) {
                    tmpRect.drawWithOutRight(ctx);
                } else {
                    tmpRect.drawWithOutTop(ctx);
                }

            } else {
                if (this.isHorizontal) {
                    tmpRect.drawWithOutLeft(ctx);
                } else {
                    tmpRect.drawWithOutBottom(ctx);
                }
            }
        } else {
            if (this.isHorizontal) {
                tmpRect.drawTopAndBottom(ctx);
            } else {
                tmpRect.drawLeftAndRight(ctx);
            }
        }
        ctx.restore();
    }
});

/**
 * TODO:待补充
 * @class FR.Chart.ArcTopDownShadeStyle
 * @extends FR.Chart.TopDownShadeChart
 */
FR.Chart.ArcTopDownShadeStyle = FR.extend(FR.Chart.TopDownShadeChart, {
    initConstants: function (js) {
        js = js || {};
        this.arcShape = js.arcShape; //可能是arc2D,也可能是ring
        this.newArc = this.arcShape;
        this.totalRadius = FR.pick(js.totalRadius, 0);
        this.categoryCount = FR.pick(js.count, 1);
        this.alpha = js.alpha;
        FR.Chart.ArcTopDownShadeStyle.superclass.initConstants.apply(this, [js]);
    },

    clone: function (newArc) {
        var newObj = new FR.Chart.ArcTopDownShadeStyle();
        newObj.arcShape = this.arcShape;
        newObj.newArc = newArc;
        newObj.color = this.color;
        newObj.alpha = this.alpha;
        newObj.avoidOriginDraw = this.avoidOriginDraw;
        newObj.totalRadius = this.totalRadius;
        newObj.categoryCount = this.categoryCount;
        return newObj;
    },

    paintStyle: function (ctx) {
        if(!ctx){
            return;
        }
        ctx.save();
        ctx.globalAlpha = this.alpha;

        //填充
        var startPoint, endPoint, paint;
        if (this.arcShape.getExtent() <= 180 || this.categoryCount !== 1) {
            var centerX = this.arcShape.x;
            var centerY = this.arcShape.y;
            var radius = (this.totalRadius === 0 ? this.arcShape.getRadius() : this.totalRadius);
            paint = ctx.createRadialGradient(centerX, centerY, 0, centerX, centerY, radius);
            paint.addColorStop(0, this.getEndColor());
            paint.addColorStop(1, this.getStartColor());
        } else {
            var halfAngle = this.arcShape.getHalfAngle();
            if (halfAngle >= 45 && halfAngle < 135) {
                startPoint = this.arcShape.getPointWithAngle(90);
                endPoint = this.arcShape.getBottomPoint();
                endPoint.x = startPoint.x;
            } else if (halfAngle >= 135 && halfAngle < 225) {
                startPoint = this.arcShape.getPointWithAngle(180);
                endPoint = this.arcShape.getLeftMostPoint();
                endPoint.y = startPoint.y;
            } else if (halfAngle >= 225 && halfAngle < 315) {
                startPoint = this.arcShape.getPointWithAngle(270);
                endPoint = this.arcShape.getTopPoint();
                endPoint.x = startPoint.x;
            } else {
                startPoint = this.arcShape.getPointWithAngle(360);
                endPoint = this.arcShape.getRightMostPoint();
                endPoint.y = startPoint.y;
            }
            paint = ctx.createLinearGradient(startPoint.x, startPoint.y, endPoint.x, endPoint.y);
            paint.addColorStop(0, this.getStartColor());
            paint.addColorStop(1, this.getEndColor());
        }
        ctx.fillStyle = paint;
        this.newArc.paint(ctx);

        //边框
        ctx.strokeStyle = this.getLineColor();
        ctx.lineWidth = 1;
        this.newArc.draw(ctx);

        ctx.restore();
    },

    getStartColor: function () {
        return this.color;
    },

    getEndColor: function () {
        return FR.Chart.Color.brighterWithFactor(this.color, 0.4)
    }
});

/**
 * TODO:待补充
 * @class FR.Chart.AreaTopDownShadeStyle
 * @extends FR.Chart.TopDownShadeChart
 */
FR.Chart.AreaTopDownShadeStyle = FR.extend(FR.Chart.TopDownShadeChart, {
    initConstants: function (js) {
        js = js || {};
        this.areaPath = js.areaPath;
        this.newArea = this.areaPath;
        FR.Chart.AreaTopDownShadeStyle.superclass.initConstants.apply(this, [js]);
    },

    clone: function (newArea) {
        var newObj = new FR.Chart.AreaTopDownShadeStyle();
        newObj.areaPath = this.areaPath;
        newObj.newArea = newArea;
        newObj.color = this.color;
        newObj.avoidOriginDraw = this.avoidOriginDraw;
        newObj.axisReversed = this.axisReversed;
        return newObj;
    },

    getStartColor: function () {
        var colorArray = FR.Chart.Color.getColorArray(this.color);
        return 'rgba(' + colorArray + ',0.4' + ')'
    },

    getEndColor: function () {
        var colorArray = FR.Chart.Color.getColorArray(this.color);
        return 'rgba(' + colorArray + ',0' + ')'
    },

    paintStyle: function (ctx) {
        if(!ctx){
            return;
        }
        ctx.save();
        var bounds = this.newArea.getBounds2D();
        var paint;

        if (this.axisReversed) {
            paint = ctx.createLinearGradient(bounds.x, bounds.y + bounds.height, bounds.x, bounds.y);
        } else {
            paint = ctx.createLinearGradient(bounds.x, bounds.y, bounds.x, bounds.y + bounds.height);
        }
        paint.addColorStop(0, this.getStartColor());
        paint.addColorStop(1, this.getEndColor());
        ctx.fillStyle = paint;
        this.newArea.paint(ctx);
        ctx.restore();
    }
});

/**
 * TODO:待补充
 * @class FR.Chart.BarStyle
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.BarStyle = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};

        this.color = js.color;
        this.rect = js.rect;
        this.newRect = this.rect;
        this.axisReversed = js.axisReversed;
        this.avoidOriginDraw = !!js.avoidOriginDraw;
        this.alpha = FR.pick(js.alpha, 1);
        this.borderColor = js.borderColor;
        this.borderWidth  =js.borderWidth;
    },

    getStrokeColor: function () {
        var rgb = FR.Chart.Color.getColorArray(this.color);
        var hsb = FR.Chart.Color.RGB2HSB(rgb[0], rgb[1], rgb[2]);
        return FR.Chart.Color.getColor(FR.Chart.Color.HSB2RGB(hsb[0], hsb[1] - 0.1, hsb[2] + 0.1));
    },

    getShadeStartColor: function () {
        return FR.Chart.Color.getShadeStartColor(this.color, 0.35);
    },

    getShadeEndColor: function () {
        return FR.Chart.Color.getShadeEndColor(this.color, 0.35);
    },

    getInnerStrokeColor: function () {
        return 'rgba(255, 255, 255, 0.33)';
    }

});


/**
 * TODO:待补充
 * @class FR.Chart.StackedBar3DStyle
 * @extends FR.Chart.BarStyle
 */
FR.Chart.StackedBar3DStyle = FR.extend(FR.Chart.BarStyle, {
    initConstants: function (js) {
        js = js || {};
        this.isHorizontal = !!js.isHorizontal;
        this.totalRect = js.rect;
        FR.Chart.StackedBar3DStyle.superclass.initConstants.apply(this, [js]);
    },

    clone: function (newRect) {
        var newObj = new FR.Chart.StackedBar3DStyle();
        newObj.rect = this.rect;
        newObj.newRect = newRect;
        newObj.isFirst = this.isFirst;
        newObj.totalRect = this.totalRect;
        newObj.color = this.color;
        newObj.isHorizontal = this.isHorizontal;
        newObj.avoidOriginDraw = this.avoidOriginDraw;
        newObj.axisReversed = this.axisReversed;
        newObj.alpha = this.alpha ;
        newObj.borderColor = this.borderColor;
        newObj.borderWidth  =this.borderWidth;
        return newObj;
    },

    paintStyle: function (ctx) {

        if (this.color && this.newRect) {

            if (FR.Chart.GraphHelper.isBoundsNaN(this.rect)) {
                return;
            }

            //坐标轴逆序的时候的画法
            if (this.axisReversed) {
                this.drawWhenAxisReversed(ctx);
                return;
            }
            if(!ctx){
                return;
            }
            ctx.save();
            var width = this.newRect.width;
            var height = this.newRect.height;
            var x = this.newRect.x;
            var y = this.newRect.y;
            var paint;
            if (this.isHorizontal) {
                ctx.shadowOffsetX = 0;
                ctx.shadowOffsetY = 3;
                ctx.shadowColor = 'rgba(0, 0, 0, 0.2)';
                ctx.shadowBlur = 2;
                paint = ctx.createLinearGradient(x, y, x, y + height);
            } else {
                ctx.shadowOffsetX = 3;
                ctx.shadowOffsetY = 0;
                ctx.shadowColor = 'rgba(0, 0, 0, 0.2)';
                ctx.shadowBlur = 2;
                paint = ctx.createLinearGradient(x, y, x + width, y);
            }
            paint.addColorStop(0, this.getShadeStartColor());
            paint.addColorStop(1, this.getShadeEndColor());
            ctx.globalAlpha = this.alpha;
            ctx.fillStyle = paint;
            this.newRect.paint(ctx);
            ctx.restore()
            if(!ctx){
                return;
            }
            ctx.save();
            //外边框
            ctx.strokeStyle = this.getStrokeColor();
            ctx.lineWidth = 1;
            if (width > 4 && height > 4) {
                if (this.isHorizontal) {
                    if (this.isFirst) {
                        this.newRect.drawWithOutLeft(ctx);
                    } else {
                        this.newRect.drawTopAndBottom(ctx);
                    }
                } else {
                    if (this.isFirst) {
                        this.newRect.drawWithOutBottom(ctx);
                    } else {
                        this.newRect.drawLeftAndRight(ctx);
                    }
                }
            }

            //内层描边
            if (this.isFirst) {
                var drawRect = FR.Chart.GraphHelper.dealRectShape4JSDraw(this.totalRect);
                x = drawRect.x;
                y = drawRect.y;
                width = drawRect.width;
                height = drawRect.height;
                ctx.strokeStyle = this.getInnerStrokeColor();
                var upperLeftPath = new FR.Chart.GeneralPath();

                if (this.isHorizontal) {
                    upperLeftPath.moveTo(x + 1, y + 1);
                    upperLeftPath.lineTo(x + width - 1, y + 1);
                    upperLeftPath.lineTo(x + width - 1, y + height - 1);
                } else {
                    upperLeftPath.moveTo(x + 1, y + height - 1);
                    upperLeftPath.lineTo(x + 1, y + 1);
                    upperLeftPath.lineTo(x + width - 1, y + 1);
                }
                upperLeftPath.draw(ctx);
            }

            ctx.restore();
        }
    },

    drawWhenAxisReversed: function (ctx) {
        if(!ctx){
            return;
        }
        ctx.save();
        var width = this.newRect.width;
        var height = this.newRect.height;
        var x = this.newRect.x;
        var y = this.newRect.y;
        var paint;
        if (this.isHorizontal) {
            ctx.shadowOffsetX = 0;
            ctx.shadowOffsetY = -3;
            ctx.shadowColor = 'rgba(0, 0, 0, 0.2)';
            ctx.shadowBlur = 2;
            paint = ctx.createLinearGradient(x, y, x, y + height);
        } else {
            ctx.shadowOffsetX = 3;
            ctx.shadowOffsetY = 0;
            ctx.shadowColor = 'rgba(0, 0, 0, 0.2)';
            ctx.shadowBlur = 2;
            paint = ctx.createLinearGradient(x, y, x + width, y);
        }
        paint.addColorStop(0, this.getShadeStartColor());
        paint.addColorStop(1, this.getShadeEndColor());
        ctx.fillStyle = paint;
        this.newRect.paint(ctx);
        ctx.restore()
        if(!ctx){
            return;
        }
        ctx.save();
        //外边框
        ctx.strokeStyle = this.getStrokeColor();
        ctx.lineWidth = 1;
        if (width > 4 && height > 4) {
            if (this.isHorizontal) {
                if (this.isFirst) {
                    this.newRect.drawWithOutRight(ctx);
                } else {
                    this.newRect.drawTopAndBottom(ctx);
                }
            } else {
                if (this.isFirst) {
                    this.newRect.drawWithOutTop(ctx);
                } else {
                    this.newRect.drawLeftAndRight(ctx);
                }
            }
        }

        //内层描边
        if (this.isFirst) {
            var drawRect = FR.Chart.GraphHelper.dealRectShape4JSDraw(this.totalRect);
            x = drawRect.x;
            y = drawRect.y;
            width = drawRect.width;
            height = drawRect.height;
            ctx.strokeStyle = this.getInnerStrokeColor();
            var upperLeftPath = new FR.Chart.GeneralPath();

            if (this.isHorizontal) {
                upperLeftPath.moveTo(x + 1, y + height - 1);
                upperLeftPath.lineTo(x + 1, y + 1);
                upperLeftPath.lineTo(x + width - 1, y + 1);
            } else {
                upperLeftPath.moveTo(x + 1, y + 1)
                upperLeftPath.lineTo(x + 1, y + height - 1);
                upperLeftPath.lineTo(x + width - 1, y + height - 1);
            }
            upperLeftPath.draw(ctx);
        }

        ctx.restore();

    }

});


/**
 * TODO:待补充
 * @class FR.Chart.BarHorizontal3DStyle
 * @extends FR.Chart.BarStyle
 */
FR.Chart.BarHorizontal3DStyle = FR.extend(FR.Chart.BarStyle, {
    initConstants: function (js) {
        js = js || {};

        FR.Chart.BarHorizontal3DStyle.superclass.initConstants.apply(this, [js]);
    },

    clone: function (newRect) {
        var newObj = new FR.Chart.BarHorizontal3DStyle();
        newObj.rect = this.rect;
        newObj.newRect = newRect;
        newObj.color = this.color;
        newObj.avoidOriginDraw = this.avoidOriginDraw;
        newObj.axisReversed = this.axisReversed;
        newObj.alpha = this.alpha ;
        newObj.borderColor = this.borderColor;
        newObj.borderWidth  =this.borderWidth;
        return newObj;
    },

    paintStyle: function (ctx) {
        if (this.color) {

            if (FR.Chart.GraphHelper.isBoundsNaN(this.rect)) {
                return;
            }

            var x = this.newRect.x;
            var y = this.newRect.y;
            var width = this.newRect.width;
            var height = this.newRect.height;

            if (width < 4 || height < 4) {
                if(!ctx){
                    return;
                }
                ctx.save();
                ctx.fillStyle = this.color;
                this.newRect.paint(ctx);
                ctx.strokeStyle = this.color;
                this.newRect.draw(ctx);
                ctx.restore();
                return;
            }
            if(!ctx){
                return;
            }
            //渐变
            ctx.save();
            ctx.shadowOffsetX = 0;
            ctx.shadowOffsetY = 3;
            ctx.shadowColor = 'rgba(0, 0, 0, 0.2)';
            ctx.shadowBlur = 2;
            var paint = ctx.createLinearGradient(x, y, x, y + height);
            paint.addColorStop(0, this.getShadeStartColor());
            paint.addColorStop(1, this.getShadeEndColor());
            ctx.fillStyle = paint;
            ctx.globalAlpha = this.alpha;
            this.newRect.paint(ctx);
            ctx.restore();

            ctx.save();
            //描边
            ctx.strokeStyle = this.getStrokeColor();
            ctx.lineWidth = 1;
            this.newRect.draw(ctx);

            //内边
            var drawRect = FR.Chart.GraphHelper.dealRectShape4JSDraw(this.newRect);
            ctx.strokeStyle = this.getInnerStrokeColor();
            x = drawRect.x;
            y = drawRect.y;
            width = drawRect.width;
            height = drawRect.height;
            var upperLeftPath = new FR.Chart.GeneralPath();
            if (this.axisReversed) {
                upperLeftPath.moveTo(x + 1, y + height - 1);
                upperLeftPath.lineTo(x + 1, y + 1);
                upperLeftPath.lineTo(x + width - 1, y + 1);
            } else {
                upperLeftPath.moveTo(x + 1, y + 1);
                upperLeftPath.lineTo(x + width - 1, y + 1);
                upperLeftPath.lineTo(x + width - 1, y + height - 1);
            }
            upperLeftPath.draw(ctx);

            ctx.restore();
        }
    }
});


/**
 * TODO:待补充
 * @class FR.Chart.BarVertical3DStyle
 * @extends FR.Chart.BarStyle
 */
FR.Chart.BarVertical3DStyle = FR.extend(FR.Chart.BarStyle, {
    initConstants: function (js) {
        js = js || {};

        FR.Chart.BarVertical3DStyle.superclass.initConstants.apply(this, [js]);
    },

    clone: function (newRect) {
        var newObj = new FR.Chart.BarVertical3DStyle();
        newObj.rect = this.rect;
        newObj.newRect = newRect;
        newObj.color = this.color;
        newObj.avoidOriginDraw = this.avoidOriginDraw;
        newObj.axisReversed = this.axisReversed;
        newObj.alpha = this.alpha ;
        newObj.borderColor = this.borderColor;
        newObj.borderWidth  =this.borderWidth;
        return newObj;
    },

    paintStyle: function (ctx) {
        if (this.color) {

            if (FR.Chart.GraphHelper.isBoundsNaN(this.rect)) {
                return;
            }

            if(!ctx){
                return;
            }

            var x = this.newRect.x;
            var y = this.newRect.y;
            var width = this.newRect.width;
            var height = this.newRect.height;

            if (width < 4 || height < 4) {
                ctx.save();
                ctx.fillStyle = this.color;
                this.newRect.paint(ctx);
                ctx.strokeStyle = this.color;
                this.newRect.draw(ctx);
                ctx.restore();
                return;
            }

            //渐变
            ctx.save();
            ctx.shadowOffsetX = 3;
            ctx.shadowOffsetY = 0;
            ctx.shadowColor = 'rgba(0, 0, 0, 0.2)';
            ctx.shadowBlur = 2;
            var paint = ctx.createLinearGradient(x, y, x + width, y);
            paint.addColorStop(0, this.getShadeStartColor());
            paint.addColorStop(1, this.getShadeEndColor());
            ctx.fillStyle = paint;
            ctx.globalAlpha = this.alpha;
            this.newRect.paint(ctx);
            ctx.restore();

            ctx.save();
            //描边
            ctx.strokeStyle = this.getStrokeColor();
            ctx.lineWidth = 1;
            this.newRect.draw(ctx);

            //内边
            var drawRect = FR.Chart.GraphHelper.dealRectShape4JSDraw(this.newRect);
            ctx.strokeStyle = this.getInnerStrokeColor();
            x = drawRect.x;
            y = drawRect.y;
            width = drawRect.width;
            height = drawRect.height;
            var innerPath = new FR.Chart.GeneralPath();
            if (this.axisReversed) {
                innerPath.moveTo(x + 1, y + 1)
                innerPath.lineTo(x + 1, y + height - 1);
                innerPath.lineTo(x + width - 1, y + height - 1);
            } else {
                innerPath.moveTo(x + 1, y + height - 1);
                innerPath.lineTo(x + 1, y + 1);
                innerPath.lineTo(x + width - 1, y + 1);
            }
            innerPath.draw(ctx);

            ctx.restore();
        }
    }
});

/**
 * TODO:待补充
 * @class FR.Chart.HighLightStyle
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.HighLightStyle = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};
        this.color = js.color;
        this.rect = js.rect;
        this.newRect = this.rect;
        this.avoidOriginDraw = !!js.avoidOriginDraw;
        this.axisReversed = js.axisReversed;
        this.alpha = FR.pick(js.alpha, 1);
        this.borderColor = js.borderColor;
        this.borderWidth  =js.borderWidth;
    },

    getPaintStartColor: function () {
        return FR.Chart.Color.brighter(this.color);
    },

    getPaintEndColor: function () {
        return this.color;
    },

    getHighLightStartColor: function () {
        return 'rgba(255,255,255, 0.6)';
    },

    getHighLightEndColor: function () {
        return 'rgba(255,255,255, 0)';
    },

    getHighLightShape: function (rect) {
        var path = new FR.Chart.GeneralPath();
        var x = rect.x;
        var y = rect.y;
        var height = rect.height;
        var width = rect.width;
        if (this.axisReversed) {
            path.moveTo(x, y);
            path.lineTo(x, y + height);
            path.lineTo(x + width * 2 / 3, y + height);
        } else {
            path.moveTo(x, y + height);
            path.lineTo(x, y);
            path.lineTo(x + width * 2 / 3, y);
        }
        path.closePath();
        return path;
    },

    getHighLightHorizontalShape: function (rect) {
        var path = new FR.Chart.GeneralPath();
        var x = rect.x;
        var y = rect.y;
        var height = rect.height;
        var width = rect.width;
        if (this.axisReversed) {
            path.moveTo(x, y + height * 2 / 3);
            path.lineTo(x, y);
            path.lineTo(x + width, y);
        } else {
            path.moveTo(x, y);
            path.lineTo(x + width, y);
            path.lineTo(x + width, y + height * 2 / 3);
        }
        path.closePath();
        return path;
    }
});


/**
 * TODO:待补充
 * @class FR.Chart.BarHighLightStyle
 * @extends FR.Chart.HighLightStyle
 */
FR.Chart.BarHighLightStyle = FR.extend(FR.Chart.HighLightStyle, {
    initConstants: function (js) {
        js = js || {};
        this.isHorizontal = !!js.isHorizontal;
        FR.Chart.BarHighLightStyle.superclass.initConstants.apply(this, [js]);
    },

    clone: function (newRect) {
        var newObj = new FR.Chart.BarHighLightStyle();
        newObj.rect = this.rect;
        newObj.newRect = newRect;
        newObj.color = this.color;
        newObj.avoidOriginDraw = this.avoidOriginDraw;
        newObj.isHorizontal = this.isHorizontal;
        newObj.plotBounds = this.plotBounds;//记录绘图区的大小
        newObj.axisReversed = this.axisReversed;
        newObj.alpha = this.alpha ;
        newObj.borderColor = this.borderColor;
        newObj.borderWidth  =this.borderWidth;
        return newObj;
    },

    paintStyle: function (ctx) {
        if(!ctx){
            return;
        }

        if(this.rect.width < 6 || this.rect.height < 6){
            ctx.save();
            ctx.fillStyle = this.color;
            this.newRect.paint(ctx);
            ctx.restore();
            return ;
        }

        //背面高光阴影
        ctx.save();
        ctx.globalAlpha = this.alpha;
        //限制绘图区域
        ctx.fillStyle = "rgba(255,255,255,0.00)";
        this.plotBounds.paint(ctx);
        ctx.clip();
        var brightColor = FR.Chart.Color.brighter(this.color);
        ctx.shadowColor = 'rgba(' + FR.Chart.Color.getColorArray(brightColor) + ',0.75)';
        ctx.shadowBlur = 6;
        ctx.fillStyle = 'white';
        this.newRect.paint(ctx);
        ctx.restore();

        ctx.save();
        ctx.globalAlpha = this.alpha;

        var x = this.newRect.x;
        var y = this.newRect.y;
        var width = this.newRect.width;
        var height = this.newRect.height;
        //渐变填充
        var grd;
        if (this.axisReversed) {
            if (this.isHorizontal) {
                grd = ctx.createLinearGradient(x, y, x + width, y);
            } else {
                grd = ctx.createLinearGradient(x, y + height, x, y);
            }

        } else {
            if (this.isHorizontal) {
                grd = ctx.createLinearGradient(x + width, y, x, y);
            } else {
                grd = ctx.createLinearGradient(x, y, x, y + height);
            }
        }
        grd.addColorStop(0, this.getPaintStartColor());
        grd.addColorStop(1, this.getPaintEndColor());
        ctx.fillStyle = grd;
        this.newRect.paint(ctx);

        //高光
        grd = ctx.createLinearGradient(x, y, x, y + height);
        grd.addColorStop(0, this.getHighLightStartColor());
        grd.addColorStop(1, this.getHighLightEndColor());
        ctx.fillStyle = grd;
        if (this.isHorizontal) {
            this.getHighLightHorizontalShape(this.newRect).paint(ctx);
        } else {
            this.getHighLightShape(this.newRect).paint(ctx);
        }

        //一像素描边
        ctx.strokeStyle = 'rgb(255,255,255)';
        ctx.lineWidth = 1;
        this.newRect.draw(ctx);

        ctx.restore();
    }

});


/**
 * TODO:待补充
 * @class FR.Chart.StackedBarHighLightStyle
 * @extends FR.Chart.HighLightStyle
 */
FR.Chart.StackedBarHighLightStyle = FR.extend(FR.Chart.HighLightStyle, {
    initConstants: function (js) {
        js = js || {};
        this.totalRect = js.rect;
        this.isHorizontal = !!js.isHorizontal;
        FR.Chart.StackedBarHighLightStyle.superclass.initConstants.apply(this, [js]);
    },

    clone: function (newRect) {
        var newObj = new FR.Chart.StackedBarHighLightStyle();
        newObj.rect = this.rect;
        newObj.newRect = newRect;
        newObj.color = this.color;
        newObj.avoidOriginDraw = this.avoidOriginDraw;
        newObj.isHorizontal = this.isHorizontal;
        newObj.plotBounds = this.plotBounds;//记录绘图区的大小
        newObj.totalRect = this.totalRect;//堆积的时候的总的柱子
        newObj.isFirst = this.isFirst;
        newObj.axisReversed = this.axisReversed;
        newObj.alpha = this.alpha ;
        newObj.borderColor = this.borderColor;
        newObj.borderWidth  =this.borderWidth;
        return newObj;
    },

    paintStyle: function (ctx) {
        if(!ctx){
            return;
        }

        if(this.rect.width < 6 || this.rect.height < 6){
            ctx.save();
            ctx.fillStyle = this.color;
            this.newRect.paint(ctx);
            ctx.restore();
            return ;
        }

        //背面高光阴影
        ctx.save();
        ctx.globalAlpha = this.alpha;
        //限制绘图区域
        ctx.fillStyle = "rgba(255,255,255,0.00)";
        this.plotBounds.paint(ctx);
        ctx.clip();
        ctx.shadowColor = 'rgba(197,197,197, 0.75)';
        ctx.shadowBlur = 6;
        ctx.fillStyle = 'white';
        this.newRect.paint(ctx);
        ctx.restore();

        ctx.save();
        //渐变填充
        var x = this.totalRect.x;
        var y = this.totalRect.y;
        var width = this.totalRect.width;
        var height = this.totalRect.height;
        var grd;
        if (this.axisReversed) {
            if (this.isHorizontal) {
                grd = ctx.createLinearGradient(x, y, x + width, y);
            } else {
                grd = ctx.createLinearGradient(x, y + height, x, y);
            }

        } else {
            if (this.isHorizontal) {
                grd = ctx.createLinearGradient(x + width, y, x, y);
            } else {
                grd = ctx.createLinearGradient(x, y, x, y + height);
            }
        }
        grd.addColorStop(0, this.getPaintStartColor());
        grd.addColorStop(1, this.getPaintEndColor());
        ctx.fillStyle = grd;
        this.newRect.paint(ctx);
        ctx.restore();
    },

    paintHighLight: function (ctx) {
        if (this.isFirst) {
            ctx.save()
            var x = this.totalRect.x;
            var y = this.totalRect.y;
            var width = this.totalRect.width;
            var height = this.totalRect.height;

            if(width < 6 || height < 6){
                return ;
            }

            if (this.axisReversed) {
                grd = ctx.createLinearGradient(x, y + height, x, y);
                grd.addColorStop(0, this.getHighLightStartColor());
                grd.addColorStop(1, this.getHighLightEndColor());
                ctx.fillStyle = grd;
                if (this.isHorizontal) {
                    this.getHighLightHorizontalShape(this.totalRect).paint(ctx);
                } else {
                    this.getHighLightShape(this.totalRect).paint(ctx);
                }

            } else {
                grd = ctx.createLinearGradient(x, y, x, y + height);
                grd.addColorStop(0, this.getHighLightStartColor());
                grd.addColorStop(1, this.getHighLightEndColor());
                ctx.fillStyle = grd;
                if (this.isHorizontal) {
                    this.getHighLightHorizontalShape(this.totalRect).paint(ctx);
                } else {
                    this.getHighLightShape(this.totalRect).paint(ctx);
                }
            }

            //一像素描边
            ctx.strokeStyle = 'rgb(255,255,255)';
            ctx.lineWidth = 1;
            this.totalRect.draw(ctx);

            ctx.restore();
        }
    }

});


/**
 * TODO:待补充
 * @class FR.Chart.DonutOuterStyle
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.DonutOuterStyle = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};
        this.color = js.color;
        this.arcShape = js.arcShape;
        this.newArc = this.arcShape;
        this.totalRadius = js.totalRadius;
    },

    clone: function (newArc) {
        var newObj = new FR.Chart.DonutOuterStyle();
        newObj.arcShape = this.arcShape;
        newObj.newArc = newArc;
        newObj.color = this.color;
        newObj.totalRadius = this.totalRadius;
        return newObj;
    },

    paintStyle: function (ctx) {
        if(!ctx){
            return;
        }
        ctx.save();

        var startPoint = this.getShadeStartPoint();
        var endPoint = this.getShadeEndPoint();
        var grd = ctx.createLinearGradient(startPoint.x, startPoint.y, endPoint.x, endPoint.y);
        grd.addColorStop(0, this.getPaintStartColor());
        grd.addColorStop(1, this.getPaintEndColor());
        ctx.fillStyle = grd;
        this.newArc.paint(ctx);

        ctx.restore();
    },

    getShadeStartPoint: function () {
        var x = this.arcShape.x - this.totalRadius * Math.cos(Math.PI * 135 / 180);
        var y = this.arcShape.y - this.totalRadius * Math.sin(Math.PI * 135 / 180);
        return new FR.Chart.Point2D(x, y);
    },

    getShadeEndPoint: function () {
        var x = this.arcShape.x - this.totalRadius * Math.cos(Math.PI * 315 / 180);
        var y = this.arcShape.y - this.totalRadius * Math.sin(Math.PI * 315 / 180);
        return new FR.Chart.Point2D(x, y);
    },

    getPaintStartColor: function () {
        return FR.Chart.Color.brighterWithFactor(this.color, 0.5);
    },

    getPaintEndColor: function () {
        return this.color;
    }

});


/**
 * TODO:待补充
 * @class FR.Chart.AreaHighLightStyle
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.AreaHighLightStyle = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};
        this.color = js.color;
        this.areaPath = js.areaPath;
        this.newArea = this.areaPath;
        this.axisReversed = js.axisReversed;
    },

    clone: function (newArea) {
        var newObj = new FR.Chart.AreaHighLightStyle();
        newObj.areaPath = this.areaPath;
        newObj.newArea = newArea;
        newObj.color = this.color;
        newObj.axisReversed = this.axisReversed;
        return newObj;
    },

    getStartColor: function () {
        var colorArray = FR.Chart.Color.getColorArray(this.color);
        return 'rgba(' + colorArray + ',0.33' + ')'
    },

    getEndColor: function () {
        var colorArray = FR.Chart.Color.getColorArray(this.color);
        return 'rgba(' + colorArray + ',0' + ')'
    },

    paintStyle: function (ctx) {
        if(!ctx){
            return;
        }
        ctx.save();
        ctx.globalAlpha = this.alpha;

        var bounds = this.newArea.getBounds2D();
        if(isNaN(bounds.x) || isNaN(bounds.y) || isNaN(bounds.width) || isNaN(bounds.height)){
            return;
        }
        var paint;
        if (this.axisReversed) {
            paint = ctx.createLinearGradient(bounds.x, bounds.y + bounds.height, bounds.x, bounds.y)
        } else {
            paint = ctx.createLinearGradient(bounds.x, bounds.y, bounds.x, bounds.y + bounds.height)
        }
        paint.addColorStop(0, this.getStartColor());
        paint.addColorStop(1, this.getEndColor());
        ctx.fillStyle = paint;
        this.newArea.paint(ctx);
        ctx.restore();
    }
});


/**
 * TODO:待补充
 * @class FR.Chart.AreaPlane3DStyle
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.AreaPlane3DStyle = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};
        this.areaPath = js.areaPath;
        this.newArea = this.areaPath;
        this.color = js.color;
        this.avoidOriginDraw = !!js.avoidOriginDraw;
        this.axisReversed = js.axisReversed;
    },

    clone: function (newArea) {
        var newObj = new FR.Chart.AreaPlane3DStyle();
        newObj.color = this.color;
        newObj.avoidOriginDraw = this.avoidOriginDraw;
        newObj.areaPath = this.areaPath;
        newObj.newArea = newArea;
        newObj.axisReversed = this.axisReversed;
        return newObj;
    },

    getShadeColor: function () {
        var rgb = FR.Chart.Color.getColorArray(this.color);
        var hsb = FR.Chart.Color.RGB2HSB(rgb[0], rgb[1], rgb[2]);
        return FR.Chart.Color.getColor(FR.Chart.Color.HSB2RGB(hsb[0], hsb[1] * 2, hsb[2] / 2));
    },

    paintStyle: function (ctx) {
        if(!ctx){
            return;
        }

        if (this.animateGlyph) {
            ctx.save();
            ctx.globalAlpha = this.alpha;
            if (this.axisReversed) {
                ctx.shadowOffsetY = 3;
            } else {
                ctx.shadowOffsetY = -3;
            }
            ctx.shadowOffsetX = 3;
            ctx.shadowColor = 'rgb(122,122,122)';
            ctx.shadowBlur = 3;
            this.animateGlyph.info.paint(ctx, this.animateGlyph.getOutline4Fill());
            ctx.restore();
        }
    }
});


/**
 * TODO:待补充
 * @class FR.Chart.ArcPlane3DStyle
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.ArcPlane3DStyle = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};
        this.arcShape = js.arcShape;
        this.newArc = this.arcShape;
        this.color = js.color;
        this.alpha = js.alpha;
        this.avoidOriginDraw = !!js.avoidOriginDraw;
        this.totalRadius = FR.pick(js.totalRadius, 0);
        this.categoryCount = FR.pick(js.count, 1); //面积图只有一个分类
        this.paintCount = 0;
    },

    clone: function (newArc) {
        var newObj = new FR.Chart.ArcPlane3DStyle();
        newObj.color = this.color;
        newObj.alpha = this.alpha;
        newObj.avoidOriginDraw = this.avoidOriginDraw;
        newObj.arcShape = this.arcShape;
        newObj.newArc = newArc;
        newObj.totalRadius = this.totalRadius;
        newObj.categoryCount = this.categoryCount;
        newObj.paintCount = this.paintCount;
        return newObj;
    },

    getShadeStartColor: function () {
        return FR.Chart.Color.getShadeStartColor(this.color, 0.35);
    },

    getShadeEndColor: function () {
        return FR.Chart.Color.getShadeEndColor(this.color, 0.35);
    },

    paintStyle: function (ctx) {
        if(!ctx){
            return;
        }
        ctx.save();

        ctx.globalAlpha = this.alpha;

        if(this.paintCount % 2 === 0){
            ctx.shadowOffsetX = 3;
            ctx.shadowOffsetY = -3;
            ctx.shadowColor = 'rgba(0, 0, 0, 0.25)';
            ctx.shadowBlur = 3;

            this.paintCount++;
        }

        //填充
        var startPoint, endPoint, paint;
        if (this.arcShape.getExtent() <= 180 || this.categoryCount !== 1) {
            var centerX = this.arcShape.x;
            var centerY = this.arcShape.y;
            var radius = (this.totalRadius === 0 ? this.arcShape.getRadius() : this.totalRadius);
            paint = ctx.createRadialGradient(centerX, centerY, 0, centerX, centerY, radius);
            paint.addColorStop(0, this.getShadeStartColor());
            paint.addColorStop(1, this.getShadeEndColor());
        } else {
            var halfAngle = this.arcShape.getHalfAngle();
            if (halfAngle >= 45 && halfAngle < 135) {
                startPoint = this.arcShape.getPointWithAngle(90);
                endPoint = this.arcShape.getBottomPoint();
                endPoint.x = startPoint.x;
            } else if (halfAngle >= 135 && halfAngle < 225) {
                startPoint = this.arcShape.getPointWithAngle(180);
                endPoint = this.arcShape.getLeftMostPoint();
                endPoint.y = startPoint.y;
            } else if (halfAngle >= 225 && halfAngle < 315) {
                startPoint = this.arcShape.getPointWithAngle(270);
                endPoint = this.arcShape.getTopPoint();
                endPoint.x = startPoint.x;
            } else {
                startPoint = this.arcShape.getPointWithAngle(360);
                endPoint = this.arcShape.getRightMostPoint();
                endPoint.y = startPoint.y;
            }
            paint = ctx.createLinearGradient(startPoint.x, startPoint.y, endPoint.x, endPoint.y);
            paint.addColorStop(0, this.getShadeEndColor());
            paint.addColorStop(1, this.getShadeStartColor());
        }
        ctx.fillStyle = paint;
        this.newArc.paint(ctx);

        ctx.restore();
    }
});


/**
 * TODO:待补充
 * @class FR.Chart.Arc3DStyleBase
 * @param baseShape 基础形状
 * @constructor
 */
FR.Chart.Arc3DStyleBase = function (baseShape) {
    this.baseShape = baseShape;
};

$.extend(FR.Chart.Arc3DStyleBase.prototype, /**@class FR.Chart.Arc3DStyleBase*/{
    paintStyle: function (ctx) {
        if(!ctx){
            return;
        }
        ctx.save();

        ctx.shadowOffsetY = -5;
        ctx.shadowOffsetX = -5;
        ctx.shadowColor = 'rgba(0, 0, 0, 0.45)';
        ctx.shadowBlur = 8;

        var shadeStart = this.baseShape.getPointWithAngle(45);
        var shadeEnd = this.baseShape.getPointWithAngle(225);
        var paint = ctx.createLinearGradient(shadeStart.x, shadeStart.y, shadeEnd.x, shadeEnd.y);
        paint.addColorStop(0, 'rgb(232, 229, 226)');
        paint.addColorStop(1, 'rgb(185, 182, 177)');
        ctx.fillStyle = paint;
        this.baseShape.paint(ctx);

        ctx.restore();
    }
});


/**
 * TODO:待补充
 * @class FR.Chart.ArcOuterBase
 * @param radius
 * @param centerPoint
 * @param innerRadius
 * @constructor
 */
FR.Chart.ArcOuterBase = function (radius, centerPoint, innerRadius) {
    this.radius = radius;
    this.centerPoint = centerPoint;
    this.innerRadius = FR.pick(innerRadius, 0);
};

$.extend(FR.Chart.ArcOuterBase.prototype, /**@class FR.Chart.ArcOuterBase*/{
    paintStyle: function (ctx) {
        if(!ctx){
            return;
        }
        var x = this.centerPoint.x;
        var y = this.centerPoint.y;
        var colorArray1 = FR.Chart.Color.getColorArray("rgb(134,149,157)");
        var colorArray2 = FR.Chart.Color.getColorArray("rgb(84,101,125)");
        var colorArray3 = FR.Chart.Color.getColorArray("rgb(189,189,189)");

        ctx.save();

        //饼图的底座
        if(this.innerRadius === 0){
            var paint = ctx.createRadialGradient(x, y, 0, x, y, this.radius);
            paint.addColorStop(0, FR.Chart.Color.getColorWithAlpha(colorArray1, 0));
            paint.addColorStop(0.85, FR.Chart.Color.getColorWithAlpha(colorArray1, 0));
            paint.addColorStop(0.98, FR.Chart.Color.getColorWithAlpha(colorArray2, 0.1));
            paint.addColorStop(1, FR.Chart.Color.getColorWithAlpha(colorArray2, 0.3));
            ctx.fillStyle = paint;
            var base = new FR.Chart.Arc2D(x, y, this.radius, 0, 360);
            base.paint(ctx);
        }else if (this.innerRadius / this.radius > 0.15){//圆环图的底座
            var percent = (this.innerRadius - 0.1 * this.radius) / this.radius;
            var paint = ctx.createRadialGradient(x, y, 0, x, y, this.radius);
            paint.addColorStop(0, FR.Chart.Color.getColorWithAlpha(colorArray3, 0));
            paint.addColorStop(percent, FR.Chart.Color.getColorWithAlpha(colorArray3, 0));
            paint.addColorStop(percent, FR.Chart.Color.getColorWithAlpha(colorArray3, 0.15));
            paint.addColorStop(this.innerRadius/this.radius, FR.Chart.Color.getColorWithAlpha(colorArray3, 0));
            paint.addColorStop(0.9, FR.Chart.Color.getColorWithAlpha(colorArray3, 0.05));
            paint.addColorStop(1, FR.Chart.Color.getColorWithAlpha(colorArray3, 0.2));
            ctx.fillStyle = paint;
            var base = new FR.Chart.Arc2D(x, y, this.radius, 0, 360);
            base.paint(ctx);
        }

        ctx.restore();
    }
});


/**
 * TODO:待补充
 * @class FR.Chart.Arc3DStyle
 * @param shape
 * @constructor
 */
FR.Chart.Arc3DStyle = function (shape) {
    this.arc2D = shape;
};

$.extend(FR.Chart.Arc3DStyle.prototype, /**@class FR.Chart.Arc3DStyle*/{
    paintStyle: function (ctx) {
        if(!ctx){
            return;
        }

        if (this.arc2D && this.arc2D.getBounds2D()) {

            var bounds = this.arc2D.getBounds2D();

            if (FR.Chart.GraphHelper.isBoundsNaN(bounds)) {
                return;
            }

            var width = bounds.width;
            var height = bounds.height;

            if (width < 10 || height < 10) {
                return;
            }

            ctx.save();

            var x = parseInt(bounds.x);
            var y = parseInt(bounds.y);

            var radius = parseInt(width / 2);

            var raPaint = ctx.createRadialGradient(x + radius, y + radius, 0, x + radius, y + radius, radius);
            raPaint.addColorStop(0, 'rgba(0, 0, 0, 0)');
            raPaint.addColorStop(0.88, 'rgba(0, 0, 0, 0)');
            raPaint.addColorStop(0.92, 'rgba(0, 0, 0, 0.3)');
            raPaint.addColorStop(1, 'rgba(0, 0, 0, 0.8)');

            ctx.fillStyle = raPaint;
            this.arc2D.paint(ctx);

            ctx.restore();
        }
    }
});


/**
 * TODO:待补充
 * @class FR.Chart.ArcHighLightChart
 * @param shape
 * @constructor
 */
FR.Chart.ArcHighLightChart = function (shape) {
    this.shape = shape;
};

$.extend(FR.Chart.ArcHighLightChart.prototype, /**@class FR.Chart.ArcHighLightChart*/{
    paintStyle: function (ctx) {
        if (this.shape) {
            var bounds = this.shape.getBounds2D();

            if (FR.Chart.GraphHelper.isBoundsNaN(bounds)) {
                return;
            }

            if (bounds.width < 4 || bounds.height < 4) {
                return;
            }
            if(!ctx){
                return;
            }

            ctx.save();
            ctx.globalAlpha = this.alpha;


            var x = this.shape.x;
            var y = this.shape.y;

            var width = bounds.width;
            var radius = width / 2;

            var raPaint = ctx.createRadialGradient(x, y, 0, x, y, radius);
            raPaint.addColorStop(0, 'rgba(255, 255, 255, 0.2)');
            raPaint.addColorStop(1, 'rgba(255, 255, 255, 0)');

            ctx.fillStyle = raPaint;
            this.shape.paint(ctx);

            var second = ctx.createRadialGradient(x - radius, y, 0, x - radius, y, width);
            second.addColorStop(0, 'rgba(255, 255, 255, 0.4)');
            second.addColorStop(0.75, 'rgba(255, 255, 255, 0.1)');
            second.addColorStop(1, 'rgba(255, 255, 255, 0)');

            ctx.fillStyle = second;

            ctx.beginPath();
            // leftarc
            var secA = Math.atan(159.0 / 17) * 180 / Math.PI;// 固定比例, 直接根据UI效果得到
            var startAngle = secA * Math.PI / 180;
            var endAngle = (360 - secA) * Math.PI / 180;
            ctx.arc(x, y, radius, startAngle, endAngle, false);

            // rightarc
            var angle = Math.acos(3.0 / 4.0) * 180 / Math.PI;
            var rightStart = angle * Math.PI / 180;
            var rightEnd = (360 - angle) * Math.PI / 180;
            ctx.arc(x - radius, y, radius * 1.5, rightEnd, rightStart, false);
            ctx.fill();

            ctx.restore();
        }
    }
});

/**
 * TODO:待补充
 * @class FR.Chart.GeneralInfo
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.GeneralInfo = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};

        this.seriesAttrAlpha = new FR.Chart.AttrAlpha(FR.pick(js.seriesAttrAlpha, {alpha:js.alpha}));
        this.seriesAttrBorder = new FR.Chart.AttrBorder(FR.pick(js.border, js.seriesAttrBorder));
        this.seriesAttrBackground = new FR.Chart.AttrBackground(FR.pick(js.brush, js.seriesAttrBackground));
    },

    getBackground: function () {
        return this.seriesAttrBackground.seriesBackground;
    },

    setBackground: function (background) {
        this.seriesAttrBackground.seriesBackground = background;
    },

    getBorderStyle: function () {
        return this.seriesAttrBorder.getBorderStyle();
    },

    setBorderStyle: function (borderStyle) {
        this.seriesAttrBorder.setBorderStyle(borderStyle);
    },

    getBorderColor: function () {
        return this.seriesAttrBorder.borderColor;
    },

    setBorderColor: function (borderBackground) {
        this.seriesAttrBorder.borderColor = borderBackground;
    },

    isRoundBorder: function () {
        return this.seriesAttrBorder.isRoundBorder;
    },

    setRoundBorder: function (isRoundBorder) {
        this.seriesAttrBorder.isRoundBorder = isRoundBorder;
    },

    getAlpha: function () {
        return this.seriesAttrAlpha.alpha;
    },

    setAlpha: function (alpha) {
        this.seriesAttrAlpha.alpha = alpha;
    },

    paint: function (ctx, shape) {
        if(!ctx){
            return;
        }

        if (shape) {
            ctx.save();

            ctx.globalAlpha = this.seriesAttrAlpha.alpha;

            if (this.seriesAttrBackground.seriesBackground) {
                this.seriesAttrBackground.seriesBackground.paint(ctx, shape);
            }

            if (this.seriesAttrBorder.borderStyle != FR.Chart.Constants.LINE_NONE
                && this.seriesAttrBorder.borderColor != null) {

                ctx.strokeStyle = this.seriesAttrBorder.borderColor;
                ctx.lineWidth = FR.Chart.GraphHelper.getLineStyleSize(this.seriesAttrBorder.borderStyle);

                shape.draw(ctx);
            }

            ctx.restore();
        }
    },

    paintWithOutBorder:function (ctx,shape){
        if(!ctx){
            return;
        }

        if (shape) {
            ctx.save();

            ctx.globalAlpha = this.seriesAttrAlpha.alpha;

            if(!this.seriesAttrBackground){
                return;
            }
            if (this.seriesAttrBackground.seriesBackground) {
                this.seriesAttrBackground.seriesBackground.paint(ctx, shape);
            }

            ctx.restore();
        }
    },

    paintOnlyBorder : function(ctx,shape){
        if(!ctx){
            return;
        }
        if (shape) {
            ctx.save();

            ctx.globalAlpha = this.seriesAttrAlpha.alpha;

            if(!this.seriesAttrBorder){
                return ;
            }

            if (this.seriesAttrBorder.borderStyle != FR.Chart.Constants.LINE_NONE
                && this.seriesAttrBorder.borderColor != null) {

                ctx.strokeStyle = this.seriesAttrBorder.borderColor;
                ctx.lineWidth = FR.Chart.GraphHelper.getLineStyleSize(this.seriesAttrBorder.borderStyle);

                shape.draw(ctx);
            }

            ctx.restore();
        }
    },

    dealCondition: function (collection, index, colors) {
        var attrAlpha = collection.getConditionAttr(new FR.Chart.AttrAlpha(), index);
        this.seriesAttrAlpha = attrAlpha;

        var attrBackground = collection.getConditionAttr(new FR.Chart.AttrBackground(), index, colors);
        this.seriesAttrBackground = attrBackground;

        var attrBorder = collection.getConditionAttr(new FR.Chart.AttrBorder(), index, colors);
        this.seriesAttrBorder = attrBorder;
    },

    dealColorCondition: function (collection, index, colors) {
        var attrAlpha = collection.getConditionAttr(new FR.Chart.AttrAlpha(), index);
        this.seriesAttrAlpha = attrAlpha;

        var attrColor = collection.getConditionAttr(new FR.Chart.AttrColor(), index, colors);
        this.seriesAttrBackground = new FR.Chart.AttrBackground();
        this.seriesAttrBackground.seriesBackground = FR.Chart.ColorBackground.getInstance(attrColor.getSeriesColor());

        var attrBorder = collection.getConditionAttr(new FR.Chart.AttrBorder(), index, colors);
        this.seriesAttrBorder = attrBorder;
    },

    // 如果包含系列的颜色, 就取用条件显示的, 没有 则按照分类着色.
    dealConditionWithSeriesColor: function (collection, dataPoint, colors) {
        var seriesCondition = collection.getAttr(dataPoint).isContains(new FR.Chart.AttrBackground());
        if (seriesCondition == null) {
            seriesCondition = collection.defaultAttr.isContains(new FR.Chart.AttrBackground());
            if (seriesCondition == null) {
                seriesCondition = FR.Chart.ConditionAttrFactory.createConditionAttr(new FR.Chart.AttrBackground(), dataPoint.categoryIndex, colors);
            }
        }

        this.seriesAttrBackground = seriesCondition;
    }
});// GeneralInfo.end

/**
 * TODO:待补充
 * @class FR.Chart.LineStyleInfo
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.LineStyleInfo = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};

        this.seriesAttrAlpha = new FR.Chart.AttrAlpha(js.seriesAttrAlpha);
        this.seriesAttrBorder = new FR.Chart.AttrBorder(js.seriesAttrBorder);
        this.attrLineColor = new FR.Chart.AttrColor(js.attrLineColor);
        this.attrLineStyle = new FR.Chart.AttrLineStyle(js.attrLineStyle);
    },

    paint: function (ctx, shape) {
        if(!ctx){
            return;
        }
        if (shape) {
            ctx.save();

            var lineSize = FR.Chart.GraphHelper.getLineStyleSize(this.attrLineStyle.lineStyle);
            if (this.shadow != null && lineSize > 0) { // lineStyle
                this.shadow.paint(ctx, shape, lineSize);
            }

            if (this.outerLight && lineSize > 0) {
                this.outerLight.paint(ctx, shape, lineSize);
            }

            ctx.globalAlpha = this.seriesAttrAlpha.alpha;

            if (this.seriesAttrBorder && this.seriesAttrBorder.borderStyle != FR.Chart.Constants.LINE_NONE
                && this.seriesAttrBorder.borderColor != null) {

                ctx.strokeStyle = this.seriesAttrBorder.borderColor;
                ctx.lineWidth = FR.Chart.GraphHelper.getLineStyleSize(this.seriesAttrBorder.borderStyle);
                shape.draw(ctx);
            }

            if (this.attrLineColor && this.attrLineColor.seriesColor != null
                && this.attrLineStyle && this.attrLineStyle.lineStyle != FR.Chart.Constants.LINE_NONE) {

                ctx.strokeStyle = this.attrLineColor.seriesColor;
                ctx.lineWidth = FR.Chart.GraphHelper.getLineStyleSize(this.attrLineStyle.lineStyle);

                shape.draw(ctx);
            }

            ctx.restore();
        }
    },

    dealCondition: function (collection, index, colors) {
        var lineColor = collection.getConditionAttr(new FR.Chart.AttrColor(), index, colors);
        this.attrLineColor = lineColor;

        var lineStyle = collection.getConditionAttr(new FR.Chart.AttrLineStyle(), index, colors);
        this.attrLineStyle = lineStyle;

        var attrAlpha = collection.getConditionAttr(new FR.Chart.AttrAlpha(), index, colors);
        this.seriesAttrAlpha = attrAlpha;
    }
});


/**
 * TODO:待补充
 * @class FR.Chart.ColorInfo
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.ColorInfo = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function () {
        this.seriesAttrAlpha = new FR.Chart.AttrAlpha();
        this.seriesAttrBorder = new FR.Chart.AttrBorder();
        this.seriesAttrColor = new FR.Chart.AttrColor();
    },

    setSeriesColor: function (seriesColor) {
        this.seriesAttrColor.setSeriesColor(seriesColor);
    },

    getSeriesColor: function () {
        return this.seriesAttrColor.getSeriesColor();
    },

    paint: function (ctx, shape) {
        if(!ctx){
            return;
        }
        if (shape) {
            ctx.save();

            ctx.globalAlpha = this.seriesAttrAlpha.getAlpha();

            if (this.getSeriesColor() != null) {
                ctx.fillStyle = this.getSeriesColor();
                shape.paint(ctx);
            }

            if (this.seriesAttrBorder.borderStyle != FR.Chart.Constants.LINE_NONE && this.seriesAttrBorder.borderColor != null) {
                ctx.lineWidth = FR.Chart.GraphHelper.getLineStyleSize(this.seriesAttrBorder.borderStyle);
                ctx.strokeStyle = this.seriesAttrBorder.borderColor;

                shape.draw(ctx);
                // 画边框.
                //			GraphHelper.drawLine(ctx, shape, this.seriesAttrBorder.getBorderStyle());
            }

            ctx.restore();
        }
    },

    dealCondition: function (collection, obj, colors) {
        var attrColor = collection.getConditionAttr(new FR.Chart.AttrColor(), obj, colors);
        this.setSeriesColor(attrColor.getSeriesColor());

        var attrBorder = collection.getConditionAttr(new FR.Chart.AttrBorder(), obj, colors);
        this.seriesAttrBorder.setBorderColor(attrBorder.getBorderColor());
        this.seriesAttrBorder.setBorderStyle(attrBorder.getBorderStyle());

        var attrAlpha = collection.getConditionAttr(new FR.Chart.AttrAlpha(), obj);
        this.seriesAttrAlpha.alpha = attrAlpha.alpha;
    }

});


/**
 * TODO:待补充
 * @class FR.Chart.ChartGlyphLayout
 * @constructor
 */
FR.Chart.ChartGlyphLayout = function () {
};
$.extend(FR.Chart.ChartGlyphLayout.prototype, /**@class FR.Chart.ChartGlyphLayout*/{
    DEFAULT_WIDTH: 507,
    DEFAULT_HEIGHT: 340,
    DEFAULT_GAP: 8,
    MIN_GAP: 4,
    MAX_GAP: 16,
    INCRE_ONE_PIX: 100,
    WIDTH_GAP: 8,
    HEIGHT_GAP: 8,
    //各个glyph之间间隙的比例
    HEIGHT_GAP_SCALE:0.02,


    doLayout: function (chartGlyph) {
        if (chartGlyph == null || chartGlyph.getBounds() == null) {
            return;
        }

        var leftBounds = new FR.Chart.Bounds(chartGlyph.getBounds().x, chartGlyph.getBounds().y,
            chartGlyph.getBounds().width, chartGlyph.getBounds().height);// 不改变原有的bounds

        this.componentHeightGap = leftBounds.height*this.HEIGHT_GAP_SCALE;
        this.componentHeightGap = Math.min(this.MAX_GAP,this.componentHeightGap);
        this.componentHeightGap = Math.max(this.MIN_GAP,this.componentHeightGap);

        this._preMoreChangeChart(chartGlyph, leftBounds);

        this._preGap4ChartBorder(chartGlyph, leftBounds);
        this._preGap4ChartInPadding(leftBounds);

        this._pre4TimeSwitchSize(leftBounds);
        this._pre4DemoHeight(leftBounds);

        this._titleGlyphDoLayout(leftBounds, chartGlyph.titleGlyph);

        this._calculatorDataSheetCateUnitLength(leftBounds, chartGlyph);
        this._legendDoLayoutWithLeftBounds(leftBounds, chartGlyph);
        this._makeSureDataSheetBounds(leftBounds, chartGlyph);

        this._preTimeSwitchHeight4LeftBounds(leftBounds,chartGlyph);
        this._preDemoChart4LeftBoundsHeight(leftBounds, chartGlyph);

        this._plotDoLayout(leftBounds, chartGlyph);

        this._dataSheetDoLayoutWithPlotGlyph(chartGlyph);
    },

    _preMoreChangeChart: function (chartGlyph, chartBounds) {
        if (chartGlyph.isUseChangeChart || chartGlyph.isUseDragRefresh) {
            var changeHeight = 20;
            chartBounds.y = chartBounds.y + changeHeight;
            chartBounds.height = chartBounds.height - changeHeight;
        }
    },

    _preGap4ChartBorder: function (chartGlyph, chartBounds) {
        var pre4ChartBorder = FR.Chart.GraphHelper.getLineStyleSize(chartGlyph.info.seriesAttrBorder.borderStyle);
        chartBounds.x = chartBounds.x + pre4ChartBorder;
        chartBounds.y = chartBounds.y + pre4ChartBorder;
        chartBounds.width = chartBounds.width - pre4ChartBorder * 2;
        chartBounds.height = chartBounds.height - pre4ChartBorder * 2;
    },

    _preGap4ChartInPadding: function (chartBounds) {
        var widthGap = this.DEFAULT_GAP + (chartBounds.width - this.DEFAULT_WIDTH) / this.INCRE_ONE_PIX;
        this.WIDTH_GAP = Math.min(this.MAX_GAP, Math.max(this.MIN_GAP, widthGap));

        var heightGap = this.DEFAULT_GAP + (chartBounds.height - this.DEFAULT_HEIGHT) / this.INCRE_ONE_PIX;
        this.HEIGHT_GAP = Math.min(this.MAX_GAP, Math.max(this.MIN_GAP, heightGap));


        chartBounds.x = chartBounds.x + this.WIDTH_GAP;
        chartBounds.y = chartBounds.y + this.HEIGHT_GAP;
        chartBounds.width = chartBounds.width - this.WIDTH_GAP * 2;
        chartBounds.height = chartBounds.height - this.HEIGHT_GAP * 2;
    },

    _pre4TimeSwitchSize:function(chartBounds){
        var widgetHeight = chartBounds.height * FR.Chart.TimeSwitchGlyph.WIDGET_HEIGHT_SCALE;
        widgetHeight =( widgetHeight > FR.Chart.TimeSwitchGlyph.MIN_WIDGET_HEIGHT)?widgetHeight:FR.Chart.TimeSwitchGlyph.MIN_WIDGET_HEIGHT;
        this.timeSwitchHeight = (widgetHeight < FR.Chart.TimeSwitchGlyph.MAX_WIDGET_HEIGHT)?widgetHeight:FR.Chart.TimeSwitchGlyph.MAX_WIDGET_HEIGHT;

        var buttonWidth = chartBounds.width * FR.Chart.TimeSwitchGlyph.BUTTON_WIDTH_SCALE;
        buttonWidth = (buttonWidth > FR.Chart.TimeSwitchGlyph.BUTTOM_MIN_WIDTH)?buttonWidth:FR.Chart.TimeSwitchGlyph.BUTTOM_MIN_WIDTH;
        this.switchButtonWidth = (buttonWidth < FR.Chart.TimeSwitchGlyph.BUTTON_MAX_WIDTH)?buttonWidth:FR.Chart.TimeSwitchGlyph.BUTTON_MAX_WIDTH;
    } ,

    _pre4DemoHeight: function (chartBounds) {
        var demoHeight = chartBounds.height * FR.Chart.GlobalDemoGlyph.DEMO_HEIGHT_SCALE;// 然后判断高度是否足够  y的起始位置.

        demoHeight = (demoHeight > FR.Chart.GlobalDemoGlyph.MIN_DEMO_HEIGHT) ? demoHeight : FR.Chart.GlobalDemoGlyph.MIN_DEMO_HEIGHT;
        this.demoHeight = (demoHeight < FR.Chart.GlobalDemoGlyph.MAX_DEMO_HEIGHT) ? demoHeight : FR.Chart.GlobalDemoGlyph.MAX_DEMO_HEIGHT;
    },

    _timeSwitchGlyphDoLayout:function(chartGlyph){
        var oldPlotGlyph = chartGlyph.plotGlyph;
        if(!oldPlotGlyph || !oldPlotGlyph.xAxisGlyph ||
            !oldPlotGlyph.xAxisGlyph.isZoom || !oldPlotGlyph.isNeedTimeSwitchWidget()){
            return;
        }


        var oldPlotBounds = oldPlotGlyph.bounds;// 已经计算完毕的, 实际的绘图区位置.
        var startX =  oldPlotBounds.x;
        if (oldPlotGlyph.yAxisGlyph && oldPlotGlyph.yAxisGlyph.bounds && !oldPlotGlyph.xAxisGlyph.axisReversed) {
            // 缩略图实际的位置, 是在x坐标轴下方
            startX =  oldPlotGlyph.yAxisGlyph.bounds.x;
        }

        if(oldPlotGlyph.secondAxisGlyph && oldPlotGlyph.secondAxisGlyph.bounds && oldPlotGlyph.xAxisGlyph.axisReversed){
            startX = oldPlotGlyph.secondAxisGlyph.bounds.x;
        }

        if(!chartGlyph.timeSwitchGlyph){
            chartGlyph.timeSwitchGlyph = new FR.Chart.TimeSwitchGlyph();
            chartGlyph.timeSwitchGlyph.xAxisGlyph = oldPlotGlyph.xAxisGlyph;
            chartGlyph.timeSwitchGlyph.timeSwitchArray = oldPlotGlyph.xAxisGlyph.timeSwitchArray;
        }

        chartGlyph.timeSwitchGlyph.bounds = new FR.Chart.Bounds(startX, oldPlotBounds.y-this.timeSwitchHeight-this.componentHeightGap,
                        oldPlotBounds.width, this.timeSwitchHeight);
        chartGlyph.timeSwitchGlyph.switchButtonWidth =this.switchButtonWidth;
        chartGlyph.timeSwitchGlyph.doLayout()
    },

    _titleGlyphDoLayout: function (chartBounds, titleGlyph) {
        if (titleGlyph == null || !titleGlyph.text || !titleGlyph.visible) {
            return;
        }
        var dimension = titleGlyph.preferredDimension(chartBounds.width, chartBounds.height);
        var titleX = 0;

        if (titleGlyph.position == FR.Chart.Constants.LEFT) {
            titleX = chartBounds.x;
        } else if (titleGlyph.position == FR.Chart.Constants.RIGHT) {
            titleX = chartBounds.x + chartBounds.width - dimension.width;
        } else {
            titleX = chartBounds.x + (chartBounds.width - dimension.width) / 2;
        }

        var titleBounds = new FR.Chart.Bounds(titleX, chartBounds.y, dimension.width, dimension.height);
        titleGlyph.bounds = FR.Chart.ChartUtils.rectangle2RoundRectangle(titleBounds, titleGlyph.isRoundBorder());
        chartBounds.y = chartBounds.y + dimension.height + this.HEIGHT_GAP;
        chartBounds.height = chartBounds.height - dimension.height - this.HEIGHT_GAP;
    },

    _makeSureDataSheetBounds: function (chartBounds, chartGlyph) {
        var dataSheetGlyph = chartGlyph.dataSheetGlyph;
        if (dataSheetGlyph == null) {
            return;
        }

        var height = dataSheetGlyph.getPrefferedSize(chartGlyph).height;
        var dataSheetBounds = new FR.Chart.Bounds(chartBounds.x, chartBounds.y + chartBounds.height - height,
            chartBounds.width, height);

        chartBounds.height = chartBounds.height - height;

        dataSheetGlyph.bounds = dataSheetBounds;
    },

    /**
     * 为了计算出 实际的数据表分类占用的 宽度. 需要与计算Plot的坐标轴
     * @param leftBounds 剩余的用于布局的边界
     * @param chartGlyph 图表glyph
     */
    _calculatorDataSheetCateUnitLength: function (leftBounds, chartGlyph) {// 只是用于计算 实际结果的分类坐标轴的分类宽度
        var dataSheetGlyph = chartGlyph.dataSheetGlyph;
        if (dataSheetGlyph == null) {
            return;
        }

        var tmpBounds = new FR.Chart.Bounds(leftBounds.x, leftBounds.y, leftBounds.width, leftBounds.height);
        this._legendDoLayoutWithLeftBounds(tmpBounds, chartGlyph);// 只有在左右 右上两侧时  才会对分类轴的宽度 有影响.  直接先布局即可
        this._justAxisDoLayout(tmpBounds, chartGlyph);// 只进行坐标轴布局.

        var plotGlyph = chartGlyph.plotGlyph;
        var bounds = dataSheetGlyph.getBounds();
        var unitLength = 0;
        if (plotGlyph instanceof FR.Chart.CategoryPlotGlyph) {
            var position = plotGlyph.xAxisGlyph.position;
            if (position == FR.Chart.Constants.TOP || position == FR.Chart.Constants.BOTTOM) {
                unitLength = plotGlyph.xAxisGlyph.getBounds().width / plotGlyph.getCategoryCount();
            } else {
                var beginX = plotGlyph.yAxisGlyph.getBounds().x + plotGlyph.getBounds().x;
                unitLength = (bounds.x + bounds.width - beginX) / plotGlyph.getCategoryCount();
            }
        } else if (plotGlyph instanceof FR.Chart.StockPlotGlyph) {
            unitLength = plotGlyph.xAxisGlyph.unitLength;
        }

        dataSheetGlyph.setUnitLength(unitLength);
    },

    _justAxisDoLayout: function (chartBounds, chartGlyph) {
        var plotGlyph = chartGlyph.plotGlyph;
        if (plotGlyph == null) {
            return;
        }

        var preAxisWidth = plotGlyph.getPreGap4AxisRightUnit();
        var preAxisHeight = plotGlyph.getPreGap4AxisTopUnit();

        var dataSheetGlyph = chartGlyph.dataSheetGlyph;

        var preLeft = 0;
        if (dataSheetGlyph) {
            var pre4DataSheet = plotGlyph.getPreLeft4DataSheet();
            var width = dataSheetGlyph.getPrefferedSize(chartGlyph).width;
            preLeft = pre4DataSheet > width ? 0 : width - pre4DataSheet;
        }

        var arrowWidth = 0;
        if (plotGlyph.xAxisGlyph && plotGlyph.xAxisGlyph.isArrowShow) {
            arrowWidth = 10;
        }

        var arrowHeight = 0;
        if (plotGlyph.yAxisGlyph && plotGlyph.yAxisGlyph.isArrowShow) {
            arrowHeight = 5;
        }

        plotGlyph.bounds = new FR.Chart.Bounds(
            chartBounds.x + preLeft,
            chartBounds.y + preAxisHeight + arrowHeight,
            chartBounds.width - preLeft - preAxisWidth - arrowWidth,
            chartBounds.height - preAxisHeight - arrowHeight
        );
        plotGlyph.layoutAxisGlyph(-1);
    },

    _plotDoLayout: function (chartBounds, chartGlyph) {
        var plotGlyph = chartGlyph.plotGlyph;
        if (plotGlyph == null) {
            return;
        }

        this._justAxisDoLayout(chartBounds, chartGlyph);

        plotGlyph.isStockChart = plotGlyph.xAxisGlyph && plotGlyph.xAxisGlyph.isZoom && plotGlyph.isNeedTimeSwitchWidget();
        plotGlyph.layoutDataSeriesGlyph();
        plotGlyph.bounds = FR.Chart.ChartUtils.rectangle2RoundRectangle(plotGlyph.bounds, plotGlyph.isRoundBorder());


        this._timeSwitchGlyphDoLayout(chartGlyph);
        this.demoPlotDoLayoutWithPlotBounds(chartGlyph);
    },

    _dataSheetDoLayoutWithPlotGlyph: function (chartGlyph) {
        var dataSheetGlyph = chartGlyph.dataSheetGlyph;
        if (dataSheetGlyph) {
            dataSheetGlyph.doLayout(chartGlyph.plotGlyph);
        }
    },

    _legendDoLayoutWithLeftBounds: function (chartBounds, chartGlyph) {
        var legendGlyph = chartGlyph.legendGlyph;
        if (legendGlyph == null) {
            return;
        }

        //考虑组合地图的情况
        if(chartGlyph.plotGlyph && !FR.isEmpty(chartGlyph.plotGlyph.mapName)){
            var plotGlyph = chartGlyph.plotGlyph;
            var isNeedCombinedLegend = plotGlyph.mapType != FR.Chart.MapType.Map_Normal;
            var isHeatMap = plotGlyph.isHeatMap;
            var isSvgMap = plotGlyph.isSvgMap;

            if(!isSvgMap || (isNeedCombinedLegend && !isHeatMap)){
                legendGlyph.layoutLegendAndRefreshChartBounds(chartBounds, this.WIDTH_GAP, this.HEIGHT_GAP);
                return;
            }

            var position = legendGlyph.position;
            var mapAreaColor = plotGlyph.mapAreaColor;
            var textAttr = new FR.Chart.TextAttr();
            if(legendGlyph.font != null){
                textAttr.frFont = legendGlyph.font;
            } else {
                textAttr.frFont = new FR.Chart.FRFont({fontName:'Microsoft YaHei'});
            }
            var controlBarDimension = this._getControlBarDimension(position, mapAreaColor, chartBounds, textAttr);

            //先测试一下能不能放下控件
            var hasEnoughSpace = false;
            var testBounds = new FR.Chart.Bounds();
            if(position == FR.Chart.Constants.TOP || position == FR.Chart.Constants.BOTTOM){
                var testWidth = controlBarDimension.width + this.WIDTH_GAP * 2 + 30;
                hasEnoughSpace = testWidth < chartBounds.width;
                testBounds = new FR.Chart.Bounds(chartBounds.x, chartBounds.y, chartBounds.width - testWidth, chartBounds.height);
            }else {
                var testHeight = controlBarDimension.height + this.HEIGHT_GAP * 2 + 30;
                hasEnoughSpace = testHeight < chartBounds.height;
                testBounds = new FR.Chart.Bounds(chartBounds.x, chartBounds.y, chartBounds.width, chartBounds.height - testHeight);
            }

            if(hasEnoughSpace){
                var legendDim = new FR.Chart.Dimension2D(legendGlyph._getLegendWidth(testBounds), legendGlyph._getLegendHeight(testBounds));
                var startX = this._getLegendStartX(position,controlBarDimension,legendDim,chartBounds);
                var startY = this._getLegendStartY(position,controlBarDimension,legendDim,chartBounds);

                var barBounds = new FR.Chart.Bounds(startX, startY, controlBarDimension.width, controlBarDimension.height);
                var legendBounds;
                if(position == FR.Chart.Constants.TOP || position == FR.Chart.Constants.BOTTOM){
                    legendBounds = new FR.Chart.Bounds(barBounds.x+controlBarDimension.width+22, barBounds.y, legendDim.width, legendDim.height);
                }else{
                    legendBounds = new FR.Chart.Bounds(barBounds.x, barBounds.y+controlBarDimension.height+22, legendDim.width, legendDim.height);
                }
                legendGlyph.changeLegendBounds(legendBounds);

                this._makeBoundsInCenter(barBounds, legendBounds, position);

                position = position == FR.Chart.Constants.RIGHT_TOP ? FR.Chart.Constants.RIGHT : position;
                chartGlyph.mapControlBar = new FR.Chart.HeatMapControlBar(barBounds, position, mapAreaColor, plotGlyph.dataSeries, textAttr);

                this._refreshChartBoundsWithControlBar(position, chartBounds, barBounds,legendBounds);
            }else{
                legendGlyph.layoutLegendAndRefreshChartBounds(chartBounds, this.WIDTH_GAP, this.HEIGHT_GAP);
            }

        }else{
            legendGlyph.layoutLegendAndRefreshChartBounds(chartBounds, this.WIDTH_GAP, this.HEIGHT_GAP);
        }
    },

    //图例和控件的区域都居中
    _makeBoundsInCenter:function(barBounds, legendBounds, position){
        if(position == FR.Chart.Constants.TOP || position == FR.Chart.Constants.BOTTOM){
            var barHeight = barBounds.height;
            var legendHeight = legendBounds.height;
            if(barHeight > legendHeight){
                legendBounds.y = barBounds.y + (barHeight - legendHeight) / 2;
            }else{
                barBounds.y = legendBounds.y + (legendHeight - barHeight) / 2;
            }
        }else{
            var barWidth = barBounds.width;
            var legendWidth = legendBounds.width;
            if(barWidth > legendWidth){
                legendBounds.x = barBounds.x + (barWidth - legendWidth) / 2;
            }else{
                barBounds.x = legendBounds.x + (legendWidth - barWidth) / 2;
            }
        }
    },

    _getControlBarDimension:function(position, mapAreaColor, chartBounds, textAttr){
        if(position == FR.Chart.Constants.TOP || position == FR.Chart.Constants.BOTTOM){
            return this._getControlBarDimensionTopAndBottom(mapAreaColor, chartBounds, textAttr);
        }else{
            return this._getControlBarDimensionLeftAndRight(mapAreaColor, chartBounds, textAttr);
        }
    },

    _getControlBarDimensionTopAndBottom:function(mapAreaColor, chartBounds, textAttr){
        var width = FR.Chart.HeatMapControlBar.BAR_LONG;
        var height = FR.Chart.HeatMapControlBar.BAR_SHORT;
        var gap = FR.Chart.HeatMapControlBar.BAR_GAP;
        var barCount = mapAreaColor.getAreaNumber();
        var fontHeight = textAttr.frFont.size;

        var startLabel = mapAreaColor.getMaxLabelWithIndex(0);
        var endLabel = mapAreaColor.getMinLabelWithIndex(barCount - 1);

        var startLabelWidth = FR.Chart.TextUtils.calculateTextDimensionWithNoRotation(startLabel, textAttr).width;
        var endLabelWidth = FR.Chart.TextUtils.calculateTextDimensionWithNoRotation(endLabel, textAttr).width;

        var barWith = (startLabelWidth + endLabelWidth) / 2.0 + width * barCount + gap * (barCount - 1);
        var barHeight = fontHeight * 2 + 10 + height;

        return new FR.Chart.Dimension2D(barWith, barHeight);
    },

    _getControlBarDimensionLeftAndRight:function(mapAreaColor, chartBounds, textAttr){
        var width = FR.Chart.HeatMapControlBar.BAR_SHORT;
        var height = FR.Chart.HeatMapControlBar.BAR_LONG;
        var gap = FR.Chart.HeatMapControlBar.BAR_GAP;
        var barCount = mapAreaColor.getAreaNumber();

        var fontHeight = textAttr.frFont.size;

        var barHeight = height * barCount + gap * (barCount - 1) + fontHeight;
        var maxLabelWith = 0;

        var labels = mapAreaColor.getNumberLabels();
        for(var i = 0; i < labels.length; i++){
            var label = labels[i];
            maxLabelWith = Math.max(FR.Chart.TextUtils.calculateTextDimensionWithNoRotation(label, textAttr).width, maxLabelWith);
        }

        var barWidth = maxLabelWith + 5 + width;
        barWidth = Math.min(FR.Chart.LegendGlyph.MAX_LEFT_WIDTH * chartBounds.width, barWidth);

        return new FR.Chart.Dimension2D(barWidth, barHeight);
    },

    _getLegendStartX:function(position, controlBarDimension, legendDim, chartBounds){
        var gap = 22;
        if(position == FR.Chart.Constants.TOP || position == FR.Chart.Constants.BOTTOM){
            return chartBounds.x + (chartBounds.width - controlBarDimension.width - legendDim.width - 22)/2;
        }else if(position == FR.Chart.Constants.LEFT){
            return chartBounds.x;
        }else{
            return chartBounds.x + chartBounds.width - Math.max(controlBarDimension.width, legendDim.width);
        }
    },

    _getLegendStartY:function(position, controlBarDimension, legendDim, chartBounds){
        var gap = 22;
        if(position == FR.Chart.Constants.LEFT || position == FR.Chart.Constants.RIGHT){
            return chartBounds.y + (chartBounds.height - controlBarDimension.height - legendDim.height - 22)/2;
        }else if(position == FR.Chart.Constants.RIGHT_TOP || position == FR.Chart.Constants.TOP){
            return chartBounds.y;
        }else if(position == FR.Chart.Constants.BOTTOM){
            return chartBounds.y + chartBounds.height - Math.max(controlBarDimension.height, legendDim.height);
        }
    },

    _refreshChartBoundsWithControlBar:function(position, chartBounds, barBounds, legendBounds){
        if(position == FR.Chart.Constants.TOP || position == FR.Chart.Constants.BOTTOM){
            this._refreshChartBoundsWithControlBarTopAndBottom(position, chartBounds, barBounds, legendBounds);
        }else{
            this._refreshChartBoundsWithControlBarLeftAndRight(position, chartBounds, barBounds, legendBounds);
        }
    },

    _refreshChartBoundsWithControlBarTopAndBottom:function(position, chartBounds, barBounds, legendBounds){
        var height = Math.max(barBounds.height, legendBounds.height);
        if(position == FR.Chart.Constants.TOP){
            chartBounds.y += height;
        }
        chartBounds.height -= height;
    },

    _refreshChartBoundsWithControlBarLeftAndRight:function(position, chartBounds, barBounds, legendBounds){
        var width = Math.max(barBounds.width, legendBounds.width);
        if(position == FR.Chart.Constants.LEFT){
            chartBounds.x += width;
        }
        chartBounds.width -= width;
    },

    _preDemoChart4LeftBoundsHeight: function (chartBounds, chartGlyph) {
        var plotGlyph = chartGlyph.plotGlyph;
        if (plotGlyph && plotGlyph.xAxisGlyph && plotGlyph.xAxisGlyph.isZoom) {
            chartBounds.height = chartBounds.height - this.demoHeight;
        }
    },

    _preTimeSwitchHeight4LeftBounds:function(chartBounds, chartGlyph){
        var oldPlotGlyph = chartGlyph.plotGlyph;
        if(!oldPlotGlyph || !oldPlotGlyph.xAxisGlyph ||
            !oldPlotGlyph.xAxisGlyph.isZoom || !oldPlotGlyph.isNeedTimeSwitchWidget()){
            return;
        }

        chartBounds.y += this.timeSwitchHeight+this.componentHeightGap;
        chartBounds.height -= this.timeSwitchHeight+this.componentHeightGap;
    },

    // 根据plot的起点位置, x, 判定缩略图的x, 以及plotGlyph的实际宽度   preDemoChart  PreChartGlyph  Bounds---> doLayout --> draw
    demoPlotDoLayoutWithPlotBounds: function (chartGlyph) {
        var oldPlotGlyph = chartGlyph.plotGlyph;
        if (oldPlotGlyph && oldPlotGlyph.xAxisGlyph && oldPlotGlyph.xAxisGlyph.isZoom) {
            var preChartGlyph = new FR.Chart.GlobalDemoGlyph();
            if(chartGlyph.timeSwitchGlyph){
                preChartGlyph.timeSwitchGlyph = chartGlyph.timeSwitchGlyph;
            }
            if (chartGlyph.preChartGlyph) {
                preChartGlyph.dragStyle = chartGlyph.preChartGlyph.dragStyle;
                preChartGlyph.isScroll = chartGlyph.preChartGlyph.isScroll;
            }
            preChartGlyph.demoPlot = chartGlyph.smallDemoPlotGlyph;
            preChartGlyph.xAxisGlyph = oldPlotGlyph.xAxisGlyph;
            preChartGlyph.yAxisGlyph = oldPlotGlyph.yAxisGlyph;

            chartGlyph.preChartGlyph = preChartGlyph;

            var oldPlotBounds = oldPlotGlyph.bounds;// 已经计算完毕的, 实际的绘图区位置.

            var plotGlyph = preChartGlyph.demoPlot;

            var xHeight = 0;
            if (oldPlotGlyph.xAxisGlyph && oldPlotGlyph.xAxisGlyph.bounds) {
                // 缩略图实际的位置, 是在x坐标轴下方
                xHeight = oldPlotGlyph.xAxisGlyph.position == FR.Chart.Constants.TOP ? 0 : oldPlotGlyph.xAxisGlyph.bounds.height;
            }

            var demoBounds = new FR.Chart.Bounds(oldPlotBounds.x, oldPlotBounds.y + oldPlotBounds.height + xHeight + FR.Chart.PreChartGlyph.PRE_CATE_GAP,
                oldPlotBounds.width, this.demoHeight);

            plotGlyph.bounds = demoBounds;
            plotGlyph.bounds.height = plotGlyph.bounds.height - FR.Chart.PreChartGlyph.MOVE_BACKGROUND_HEIGHT;

            plotGlyph.layoutAxisGlyph(-1);
            plotGlyph.layoutDemoGlyph();
            preChartGlyph.bounds = new FR.Chart.Bounds(chartGlyph.plotGlyph.xAxisGlyph.bounds.x,demoBounds.y,
                        chartGlyph.plotGlyph.xAxisGlyph.bounds.width,demoBounds.height);
            var position = oldPlotGlyph.yAxisGlyph.position;
            var axisBounds = oldPlotGlyph.yAxisGlyph.bounds;
            if(position == FR.Chart.Constants.LEFT){
                preChartGlyph.bounds.x = axisBounds.x + axisBounds.width;
            }else if(position == FR.Chart.Constants.RIGHT){
                preChartGlyph.bounds.x = axisBounds.x - oldPlotGlyph.yAxisGlyph.axisGridLength;
            }
            preChartGlyph.doLayout();
        }

    }
});

/**
 * 警戒线值
 * @class FR.Chart.ChartAlertValue
 * @extends FR.Chart.ChartJsInit
 *
 * @param {JSON} js 配置属性
 * @param {String} js.formula 公式
 * @param {Color} js.attrLineColor 线的颜色
 * @param {Number} [js.alertPosition=FR.Chart.Constants.LEFT] {@link FR.Chart.Constants#LEFT} 警戒线位置
 * @param {String} [js.alertContent=FR.i18nText("ChartF_Alert")] 警戒线文本内容
 * @param {Number} [js.alertLineAlpha=1.0] 警戒线透明度
 * @param {FR.Chart.FRFont} [js.alertFont] 警戒线文本字体
 */
FR.Chart.ChartAlertValue = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};

        this.formula = js.formula;

        this.attrLineColor = new FR.Chart.AttrColor(js.attrLineColor);
        this.attrLineStyle = new FR.Chart.AttrLineStyle(js.attrLineStyle);

        this.alertPosition = FR.pick(FR.Chart.ChartUtils.getPosition(js.alertPosition), FR.Chart.Constants.LEFT);
        this.alertContent = FR.pick(js.alertContent, FR.i18nText("Fine-Dec_Chart_Chart_Alert"));
        this.alertLineAlpha = FR.pick(js.alertLineAlpha, 1.0);
        this.alertFont = js.alertFont == undefined ? "" : new FR.Chart.FRFont(js.alertFont);
    }
});


/**
 * TODO:待补充
 * @class FR.Chart.ConditionAttr
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.ConditionAttr = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};

        this.attrList = [];
        if (js.attrList) {
            var list = js.attrList;
            for (var i = 0; i < list.length; i++) {
                this.attrList.push(new FR.Chart[list[i].attrType](list[i].attr));
            }
        }

        this.name = js.name;

        this.conditions = [];
        this.joins = [];
        if(js.attrConditions){
            var attrConditions = js.attrConditions;
            if(attrConditions.conditions){
                for(var i = 0; i < attrConditions.conditions.length; i++){
                    var condition = new FR.Chart.Condition(attrConditions.conditions[i]);
                    this.conditions.push(condition);
                }
            }

            if(attrConditions.joins){
                for(var i = 0; i < attrConditions.joins.length; i++){
                    var condition = new FR.Chart.Condition(attrConditions.joins[i]);
                    this.joins.push(condition);
                }
            }
        }

        this.conditionDataSeries = js.ConditionDataSeries == undefined ? null : this.initsConditionDataSeries(js.ConditionDataSeries);
        this.conditionDataPoint = js.ConditionDataPoint == undefined ? null : this.initsConditionDataPoint(js.ConditionDataPoint);
    },

    //初始化满足条件的数据点和
    initConditionSeriesAndPoints:function(dataSeries){
        var conditionSeries = [];
        var conditionPoint = [];
        for (var i = 0; i < dataSeries.length; i++) {
            var series = dataSeries[i];
            if (this.equalsAllConditions(series)) {
                conditionSeries.push(series.seriesIndex);
            }
            for (var k = 0, p = series.getDataPointCount(); k < p; k++){
                var dataPoint = series.points[k];
                if (this.equalsAllConditions(dataPoint)) {
                    var po = {
                        series:series.seriesIndex,
                        category:dataPoint.categoryIndex
                    };
                    conditionPoint.push(po);
                }
            }
        }
        this.conditionDataSeries = this.initsConditionDataSeries(conditionSeries);
        this.conditionDataPoint = this.initsConditionDataPoint(conditionPoint);
    },

    //result是数据点或者系列
    equalsAllConditions:function(result){
        var flag = false;
        var count = this.conditions.length;
        for (var i = 0; i < count; i++) {
            var condition = this.conditions[i];
            var join = 0;
            if(i !== 0){
                join = this.joins[i];
            }
            if (i === 0) {
                flag = condition.eval(result);
            } else if (join === 0) {
                flag = flag && condition.eval(result);
            } else {
                flag = flag || condition.eval(result);
            }
        }
        return flag;
    },

    initsConditionDataSeries: function (js) {
        var arr = [];
        for (var i = 0; i < js.length; i++) {
            arr[i] = js[i];
        }
        return arr;
    },

    initsConditionDataPoint: function (js) {
        var arr = [];
        for (var i = 0; i < js.length; i++) {
            var value = js[i];
            arr[i] = [];
            arr[i][0] = value.series;
            arr[i][1] = value.category;
        }
        return arr;
    },

    getAttr: function (index) {
        if (index >= this.attrList.length) {
            return null;
        }
        return this.attrList[index];
    },

    addAttr: function (condition) {
        this.attrList.push(condition);
    },

    isContains: function (condition) {
        for (var i = 0; i < this.attrList.length; i++) {
            if (this.getAttr(i) != null && this.getAttr(i).equals(condition)) {
                return this.getAttr(i);
            }
        }
        return null;
    },

    removeAttr:function(condition){
        for (var i = 0; i < this.attrList.length; i++) {
            if (this.getAttr(i) != null && this.getAttr(i).equals(condition)){
                this.attrList.splice(i, 1);
            }
        }
    },

    eval: function (obj) {
        if (obj instanceof FR.Chart.DataPoint) {
            for (var i = 0; this.conditionDataPoint && i < this.conditionDataPoint.length; i++) {
                if (this.conditionDataPoint[i][0] == obj.seriesIndex && this.conditionDataPoint[i][1] == obj.categoryIndex) {
                    return true;
                }
            }
        } else if (obj instanceof FR.Chart.DataSeries) {
            for (var i = 0; this.conditionDataSeries && i < this.conditionDataSeries.length; i++) {
                if (this.conditionDataSeries[i] == obj.seriesIndex) {
                    return true;
                }
            }
        } else if (typeof(obj) == typeof(0)) {
            for (var i = 0; this.conditionDataSeries && i < this.conditionDataSeries.length; i++) {
                if (this.conditionDataSeries[i] == obj) {
                    return true;
                }
            }
        }
        return false;
    }
});


/**
 * TODO:待补充
 * @class FR.Chart.CustomAttr
 * @extends FR.Chart.ConditionAttr
 */
FR.Chart.CustomAttr = FR.extend(FR.Chart.ConditionAttr, {
    initConstants: function (js) {
        js = js || {};
        FR.Chart.CustomAttr.superclass.initConstants.apply(this, [js]);

        this.renderer = FR.pick(js.renderer, 1);
        this.useRenderer = FR.pick(js.useRenderer, this.renderer);
    },

    isStackedBarShape:function(){
        return this.renderer == FR.Chart.CustomAttr.BAR_STACK || this.renderer == FR.Chart.CustomAttr.BAR3D_STACK;
    },

    getAxisPosition:function(){
        var attr = this.getAttr(0);
        return attr == null ? FR.Chart.CustomAttr.Axis_LEFT : attr.axisPosition;
    },

    getStackedSeriesList:function(series){
        var seriesList = [];
        if(this.isStackedBarShape()){
            for(var i = 0; i < series.length; i++){
                var dataSeries = series[i];
                if(this.eval(dataSeries)){
                    seriesList.push(dataSeries.seriesIndex);
                }
            }
        }
        return seriesList;
    }
});
$.extend(FR.Chart.CustomAttr,{

    BAR_RENDERER: 1,

    LINE_RENDERER: 2,

    AREA_RENDERER: 4,

    BAR_STACK: 3,

    LINE_STACK: 5,

    AREA_STACK: 6,

    BAR3D:7,

    BAR3D_STACK:8,

    Axis_LEFT: "LEFT",

    Axis_RIGHT: "RIGHT"
});



/**
 * TODO:待补充
 * @class FR.Chart.MapHotAreaColor
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.MapHotAreaColor = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};

        // 初始化 AreaColor 数组
        this.areaColors = [];
        if (js.areaColors) {
            for (var i = 0; i < js.areaColors.length; i++) {
                this.areaColors[i] = new FR.Chart.AreaColor(js.areaColors[i]);
            }
        }

        FR.Chart.MapHotAreaColor.superclass.initConstants.apply(this, [js]);
    },

    getAreaNumber:function(){
        return this.areaColors.length;
    },

    getNumberLabels:function(){
        var labels = [];
        for(var i = 0; i < this.areaColors.length; i++){
            var areaColor = this.areaColors[i];
            labels.push(Math.max(areaColor.maxValue,areaColor.minValue));
            if(i == this.areaColors.length - 1){
                labels.push(Math.min(areaColor.minValue,areaColor.maxValue));
            }
        }
        return labels;
    },

    getColors:function(){
        var colors = [];
        for(var i = 0; i < this.areaColors.length; i++){
            colors.push(this.areaColors[i].color);
        }
        return colors;
    },

    getLabelWithIndex:function(index){
        var areaColor = this.areaColors[index];
        var min = areaColor.minValue;
        var max = areaColor.maxValue;
        return min + "--" + max;
    },

    getMaxLabelWithIndex:function(index){
        if(this.areaColors && this.areaColors[index]){
            return this.areaColors[index].maxValue;
        }
    },

    getMinLabelWithIndex:function(index){
        if(this.areaColors && this.areaColors[index]){
            return this.areaColors[index].minValue;
        }
    },

    getColorWithValue: function (value) {
        var color = 'rgb(255, 255, 255)';
        for (var i = 0; i < this.areaColors.length; i++) {
            var areaColor = this.areaColors[i];

            var minValue = Math.min(areaColor.minValue, areaColor.maxValue);
            var maxValue = Math.max(areaColor.minValue, areaColor.maxValue);

            if (minValue <= value && value <= maxValue) {
                color = areaColor.color;
                break;
            }
        }

        return color;
    },

    getColorIndexWithValue:function(value){
        var index = 0;
        for(var i = 0; i < this.areaColors.length; i++) {
            var areaColor = this.areaColors[i];
            var minValue = Math.min(areaColor.minValue, areaColor.maxValue);
            var maxValue = Math.max(areaColor.minValue, areaColor.maxValue);

            if(minValue <= value && value <= maxValue) {
                index = i;
                break;
            }
        }
        return index;
    },

    getColorByIndex:function(index){
        if(index < this.areaColors.length){
            return this.areaColors[index].color;
        }
        return 'rgb(255,255,255)';
    }
});


/**
 * TODO:待补充
 * @class FR.Chart.AreaColor
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.AreaColor = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};

        this.minValue = FR.pick(js.minValue, 0);
        this.maxValue = FR.pick(js.maxValue, 0);
        this.color = FR.pick(js.color, 'rgb(0, 0, 0)');

        FR.Chart.AreaColor.superclass.initConstants.apply(this, [js]);
    }
});


/**
 * TODO:待补充
 * @class FR.Chart.MapAreaValue
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.MapAreaValue = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};

        this.titleValues = [];
        if (js.titleValues && js.titleValues.length > 0) {
            for (var i = 0; i < js.titleValues.length; i++) {
                this.titleValues[i] = new FR.Chart.MapTitleValue(js.titleValues[i]);
            }
        }
    },

    isTitleValueNull:function(){
        if(this.titleValues.length <= 0) {
            return true;
        }
        var isAllTitleNull = true;
        for(var i = 0, size = this.titleValues.length; i < size; i++) {
            var titleValue = this.titleValues[i];
            if(!FR.isEmpty(titleValue.title)) {
                isAllTitleNull = false;
                break;
            }
        }

        return isAllTitleNull;
    },

    getTitleValueByIndex:function(index){
        return this.titleValues[index];
    },

    getFirstTitleValue:function(){
        if(this.getTitleValueByIndex(0)){
            return this.getTitleValueByIndex(0).value;
        }
        return 0;
    },

    titleValueSize:function(){
        return this.titleValues.length;
    },

    //返回所有title value中的最大值,除了第index个
    getMaxValueExcept:function(index){
        var maxValue = 0;
        for(var i = 0, count = this.titleValueSize(); i < count; i++){
            if(i != index){
                maxValue = Math.max(maxValue, this.titleValues[i].value);
            }
        }

        return maxValue;
    },

    addTitleValue:function(titleValue){
        this.titleValues.push(titleValue);
    }
});


/**
 * TODO:待补充
 * @class FR.Chart.MapTitleValue
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.MapTitleValue = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};

        this.title = js.title;
        this.value = js.value;
        this.percentValue = js.percentValue;
    }
});

/**
 * TODO:待补充
 * @class FR.Chart.ConditionCollection
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.ConditionCollection = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};

        this.attrList = new FR.Chart.HashMap(js.conditionAttrList);

        if (js.defaultAttr) {
            if (js.defaultAttr.conditionAttrType) {
                if (js.defaultAttr.conditionAttrType == "CustomAttr") {
                    this.defaultAttr = new FR.Chart.CustomAttr(js.defaultAttr);
                } else {
                    this.defaultAttr = new FR.Chart.ConditionAttr(js.defaultAttr);
                }
            }
        } else {
            this.defaultAttr = new FR.Chart.ConditionAttr();
        }
    },

    add: function (seriesAttr) {
        this.attrList.add(seriesAttr);
    },

    //从配置里读所有的条件显示
    addAll:function(options, dataSeries){
        for(var i = 0; i < options.length; i++){
            var op = options[i];
            var attr = new FR.Chart[op.conditionAttrType](op);
            attr.initConditionSeriesAndPoints(dataSeries);
            this.attrList.add(attr);
        }
    },

    /**
     * 添加包括defaultAttr在内的所有条件显示
     * @param options 配置
     * @param dataSeries 系列
     */
    addAllWithDefault:function(options, dataSeries){
        if(!options || !options.length || !dataSeries){
            return;
        }
        var defaultOp = options[0];
        this.defaultAttr = new FR.Chart[defaultOp.conditionAttrType](defaultOp);

        for(var i = 1; i < options.length; i++){
            var op = options[i];
            var attr = new FR.Chart[op.conditionAttrType](op);
            attr.initConditionSeriesAndPoints(dataSeries);
            this.attrList.add(attr);
        }
    },

    getAttr: function (obj) {
        var ret = this.defaultAttr;
        for (var i = 0; i < this.attrList.length; i++) {
            if (this.attrList.get(i).eval(obj)) {
                ret = this.attrList.get(i);
            }
        }
        return ret;
    },

    getUnUsedSeriesIndex:function(series){
        var seriesList = [];
        for(var seriesIndex = 0; seriesIndex < series.length; seriesIndex++){
            var dataSeries = series[seriesIndex];
            var unUsed = true;
            for(var i = 0, count = this.getAttrSize(); i < count; i++){
                var attr = this.getAttrByIndex(i);
                if(attr.eval(dataSeries)){
                    unUsed = false;
                    break;
                }
            }
            if(unUsed){
                seriesList.push(dataSeries.seriesIndex);
            }
        }
        return seriesList;
    },

    getAttrSize:function(){
        return this.attrList.length;
    },

    getAttrByIndex:function(index){
        return this.attrList.get(index);
    },

    getAttrContainsCondition: function (obj,conditionInstance) {
        var ret = this.defaultAttr;
        for (var i = 0; i < this.attrList.length; i++) {
            if (this.attrList.get(i).eval(obj)) {
                if( this.attrList.get(i).isContains(conditionInstance)!== null ){
                    ret = this.attrList.get(i);
                }
            }
        }
        return ret;
    },

    isContainsAttr:function(obj,conditionInstance){
        for (var i = 0; i < this.attrList.length; i++) {
            if (this.attrList.get(i).eval(obj)) {
                if( this.attrList.get(i).isContains(conditionInstance)!== null ){
                    return true;
                }
            }
        }
        return false;
    },


    getConditionAttr: function (conditionInstance, obj, colors) {
        var seriesCondition = this.getAttrContainsCondition(obj,conditionInstance).isContains(conditionInstance);
        if (seriesCondition == null) {
            seriesCondition = this.defaultAttr.isContains(conditionInstance);
            if (seriesCondition == null) {
                seriesCondition = FR.Chart.ConditionAttrFactory.createConditionAttr(conditionInstance, obj, colors);
            }
        }
        return seriesCondition;
    }
});

/**
 * TODO:待补充
 * @class FR.Chart.LineMarkerIcon
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.LineMarkerIcon = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};

        this.lineStyle = js.lineStyle;
        this.alpha = FR.pick(js.alpha, 1.0);

        if (js.markerType) {
            this.marker = new FR.Chart[js.markerType](js.marker);
        } else {
            this.marker = null;
        }

        this.iconSize = 6;

        this.background = FR.Chart.AbstractBackground.initBackground(js.background);
    },

    setBackground: function (background) {
        this.background = background;
    },

    getBackground: function () {
        return this.background;
    },

    paint: function (ctx, x, y, disable) {
        if(!ctx){
            return;
        }
        ctx.save();

        ctx.globalAlpha = this.alpha;

        var drawBackground = true;
        var background = this.background;

        var iconSize = this.iconSize;

        if (disable) {
            ctx.globalAlpha = 0.8;
            background = FR.Chart.ColorBackground.getInstance("rgb(128,128,128)");
        }

        var isNullMarker = this.marker && this.marker.getMarkerType() == FR.Chart.Marker.NullMarker;
        var islineStyle = this.lineStyle && this.lineStyle != FR.Chart.Constants.LINE_NONE;

        if (isNullMarker && islineStyle && background != null) {
            ctx.lineWidth = FR.Chart.GraphHelper.getLineStyleSize(this.lineStyle);

            var line2D = new FR.Chart.Line2D(new FR.Chart.Point2D(x, y + iconSize / 2), new FR.Chart.Point2D(x + iconSize, y + iconSize / 2));
            FR.Chart.GraphHelper.dealLine4JSDraw(line2D);

            background.draw(ctx, line2D, this.lineStyle);
            drawBackground = false;
        }

        if (this.marker) {
            var oldbg = this.marker.background;
            if (disable) {
                this.marker.background = background;
            }
            this.marker.size = iconSize/2;
            this.marker.paint(ctx, x + iconSize / 2, y + iconSize / 2);
            this.marker.background = oldbg;
            drawBackground = false;
        }

        if (drawBackground && background != null) {
            background.paint(ctx, new FR.Chart.Bounds(x, y, iconSize, iconSize));
        }

        ctx.restore();
    }
});


/**
 * TODO:待补充
 * LegendItem.start
 * @class FR.Chart.LegendItem
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.LegendItem = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};

        this.label = js.label;
        this.lineMarkerIcon = js.lineMarkerIcon == undefined ? null : new FR.Chart.LineMarkerIcon(js.lineMarkerIcon);
        this.fontColor = js.fontColor;

        this.bounds = new FR.Chart.Bounds(js.bounds);

        this.LABEL_MARKER_GAP = 4;

        this.disable = false;//是否是不可用的
    },

    getBounds: function () {
        return this.bounds;
    },

    findOnMoveGlyph: function (mousePos, event) {
        var itemBounds = this.getBounds();
        if (itemBounds && itemBounds.containsPoint(mousePos.x, mousePos.y)) {
            event.cursor = ChartHandler.POINTER;
            event._hasfound = true;
            event._lastHover = this;
        }
    },

    doOnMove: function (ctx4OnMove, mousePos) {

        var useBackground = null;
        if (this.fontColor) {
            useBackground = new FR.Chart.ColorBackground();
            useBackground.color = this.fontColor;
        } else {
            if (this.lineMarkerIcon) {
                useBackground = this.lineMarkerIcon.background;
            }
        }

        FR.Chart.Tooltip.dataPointTip(ctx4OnMove, this.label, mousePos, useBackground);
    },

    draw: function (ctx, font4Label) {
        if (!this.bounds || !this.bounds.x || !this.bounds.y || !this.bounds.width || !this.bounds.height) {
            return;
        }

        if (this.lineMarkerIcon) {
            this.lineMarkerIcon.paint(ctx, this.bounds.x, this.bounds.y, this.disable);
        }
        if(!ctx){
            return;
        }
        if (this.label) {
            ctx.save();

            var size = parseInt(font4Label.size);// kunsnat: 取整, 因为大于半数, 容易有截取的现象.
            ctx.font = font4Label.style + ' ' + size + 'px ' + font4Label.fontName;

            if (this.fontColor) {
                ctx.fillStyle = this.fontColor;
            } else {
                ctx.fillStyle = font4Label.color;
            }

            ctx.globalAlpha = 1.0;

            if (this.disable) {
                ctx.globalAlpha = 0.8;
                ctx.fillStyle = "rgb(128,128,128)";
            }

            var dim = this.prefferedSize(font4Label);

            var drawString = this.label;
            var preWidth = this.bounds.width;

            var x = this.bounds.x + font4Label.size + this.LABEL_MARKER_GAP;
            var y = this.bounds.y;

            if (preWidth < dim.width) {
                if (this.drawInCutOrNot) {
                    drawString = this.getTextWhenNotEnoughWidth(drawString, preWidth - font4Label.size / 2 - this.LABEL_MARKER_GAP, font4Label);
                }
            } else {// 正常画法.
//                ctx.fillText(drawString, this.bounds.x + font4Label.size / 2 + this.LABEL_MARKER_GAP, this.bounds.y + font4Label.size * 3 / 4);
            }

            var offY = FR.Chart.PaintUtils.isOffSetY4SomeFont(ctx, font4Label);
            if(FR.Browser.isIE() || FR.Chart.ChartUtils.isIE11()) {
                offY = 0;
            }

            var newdiv = $("<div>" + drawString + "</div>").css('position', 'absolute')
                .css('font', ctx.font).css('z-index', 1).css('color', FR.Chart.Color.rgb2hex(ctx.fillStyle))
                .css('left', x).css('top', y + offY);
            //kunsnat: 自适应宽度 高度, 因为Chrome在某些字体"Century Gothic" 等 和 雅黑字体等 起始高度 不定.
//                .css('width', this.bounds.width + offWidth).css('height', this.bounds.height + offHeight);

            FR.Chart.DivCon.addDiv(FR.Chart.currentDivKey, newdiv[0]);

            ctx.restore();
        }
    },

    getTextWhenNotEnoughWidth: function (string, width, font4Label) {
        if (!string) {
            return FR.Chart.Constants.ESP;
        }
        var pointDim = FR.Chart.GraphHelper.stringDimension("…", font4Label, 0);

        if (pointDim.width > width) {
            return FR.Chart.Constants.ESP;
        }

        var preWidth = width - pointDim.width;

        var result = "";
        for (var i = 0; i < string.length; i++) {
            var tmp = string.charAt(i);
            var reDim = FR.Chart.GraphHelper.stringDimension(result, font4Label, 0);
            var tmpDim = FR.Chart.GraphHelper.stringDimension(tmp, font4Label, 0);
            if (reDim.width + tmpDim.width > preWidth) {
                break;
            }
            result += tmp;
        }

        return result + FR.Chart.Constants.ESP;
    },

    prefferedSize: function (font4Label) {
        var dimension = FR.Chart.GraphHelper.stringDimension(this.label, font4Label, 0);
        dimension.width = Math.floor(dimension.width + font4Label.size + this.LABEL_MARKER_GAP);//最新版火狐在计算字符宽度时多了零点几宽度
        dimension.height = Math.max(font4Label.size, dimension.height);
        if(this.lineMarkerIcon) {
            this.lineMarkerIcon.iconSize = font4Label.size;
        }
        return dimension;
    }
});
$.extend(FR.Chart.LegendItem, {
});

/**
 * 三维视图的投影变换
 * 不做变换时， X轴向右，Y轴向下，Z轴从屏幕中出来
 * 1.正交投影
 * 2.透视投影
 * 3.直角坐标系(类似Excel)
 * @class FR.Chart.Projection
 * @extends FR.Chart.ChartJsInit
 */
FR.Chart.Projection = FR.extend(FR.Chart.ChartJsInit, {
    initConstants: function (js) {
        js = js || {};

        this.mode = js.mode || 2;
        this.elevation = js.elevation || 15;
        this.rotation = js.rotation || 20;// TODO kunsnat: 这边其实传的0值, 但是取的是20. 改动角度 很容易造成后续判断角度isAngleAtFront 错误.
        this.focus = js.focus || 800;

        this.need_cal = FR.pick(js.need_cal, true);
        this.sin_theta_alpha = js.sin_theta_alpha || 0;
        this.cos_theta_alpha = js.cos_theta_alpha || 0;
        this.sin_theta_beta = js.sin_theta_beta || 0;
        this.cos_theta_beta = js.cos_theta_beta || 0;
    },

    setElevation: function (elevation) {
        this.elevation = elevation;

        this.need_cal = true;
    },

    setRotation: function (rotation) {
        this.rotation = rotation;

        this.need_cal = true;
    },

    /**
     * 投影三维坐标到二维平面
     */
    projectee: function (x, y, z) {
        this.calculateSINCOS();

        if (this.mode == FR.Chart.Projection.ORTHO) {
            return this.ortho_projectee(x, y, z);
        } else if (this.mode == FR.Chart.Projection.PERSPECTIVE) {
            return this.perspective_projectee(x, y, z);
        } else if (this.mode == FR.Chart.Projection.RIGHT_ANGLE) {
            return this.right_angle_projectee(x, y, z);
        } else {
            return new FR.Chart.Point2D(x, y);
        }
    },

    /**
     * 投影一个圆
     */
    projecteeArc: function (y, R, start, extent, type) {
        this.calculateSINCOS();

        var factor = this.focus / (
            this.sin_theta_alpha * y + this.focus
            );

        var ellipse = new FR.Chart.Ellipse(
            -R * factor, -R * factor * this.sin_theta_alpha + y * this.cos_theta_alpha * factor,
            2 * R * factor, 2 * R * factor * this.sin_theta_alpha, start + this.rotation, extent, !!type);
        return ellipse;
    },

    /**
     * 计算SIN和COS值.
     */
    calculateSINCOS: function () {
        if (!this.need_cal) {
            return;
        }

        this.sin_theta_alpha = Math.sin(this.elevation * Math.PI / 180);
        this.cos_theta_alpha = Math.cos(this.elevation * Math.PI / 180);

        this.sin_theta_beta = Math.sin(-this.rotation * Math.PI / 180);
        this.cos_theta_beta = Math.cos(-this.rotation * Math.PI / 180);

        this.need_cal = false;
    },

    /**
     * 透视投影
     */
    perspective_projectee: function (x, y, z) {
        var dx = x * this.cos_theta_beta + z * this.sin_theta_beta;
        var dy = -x * this.sin_theta_alpha * this.sin_theta_beta
            + y * this.cos_theta_alpha + z * this.sin_theta_alpha * this.cos_theta_beta;

        var factor = this.focus / (
            this.cos_theta_alpha * this.sin_theta_beta * x
                + this.sin_theta_alpha * y - this.cos_theta_alpha * this.cos_theta_beta * z + this.focus
            );
        return new FR.Chart.Point2D(dx * factor, dy * factor);
    },

    /**
     * 平行投影
     */
    ortho_projectee: function (x, y, z) {
        var dx = x * this.cos_theta_beta + z * this.sin_theta_beta;
        var dy = -x * this.sin_theta_alpha * this.sin_theta_beta + y * this.cos_theta_alpha
            + z * this.sin_theta_alpha * this.cos_theta_beta;

        return new FR.Chart.Point2D(dx, dy);
    },

    /**
     * 直角坐标系
     */
    right_angle_projectee: function (x, y, z) {
        var dx = x + z * this.sin_theta_beta * 0.5;
        var dy = y + z * this.sin_theta_alpha * 0.5;

        return new FR.Chart.Point2D(dx, dy);
    },

    projecteeDeep: function (deep) {
        this.calculateSINCOS();
        if (this.sin_theta_alpha < 1E-2) {
            return deep * 2;
        } else {
            return deep * 2 / this.sin_theta_alpha;
        }
    },

    /**
     * 平面坐标轴中一个y值 反射到三维坐标y的值
     */
    projecteeRY: function (x, y, z) {
        this.calculateSINCOS();
        if (this.mode == FR.Chart.Projection.ORTHO) {
            return (y + x * this.sin_theta_alpha * this.sin_theta_beta - z * this.sin_theta_alpha * this.cos_theta_beta) / this.cos_theta_alpha;
        } else if (this.mode == FR.Chart.Projection.PERSPECTIVE) {
            return (x * y * this.cos_theta_alpha * this.sin_theta_beta + y * this.focus - z * y * this.cos_theta_alpha * this.cos_theta_beta + x * this.sin_theta_alpha * this.focus
                - z * this.sin_theta_alpha * this.cos_theta_beta * this.focus) / (this.focus * this.cos_theta_alpha - this.sin_theta_alpha * y);
        } else if (this.mode == FR.Chart.Projection.RIGHT_ANGLE) {
            return y - z * this.sin_theta_alpha * 0.5;
        } else {
            return y;
        }
    },

    /**
     *  平面坐标中的一个x值 反射到三维坐标x的值
     */
    projecteeRX: function (x, y, z) {
        this.calculateSINCOS();
        if (this.mode == FR.Chart.Projection.ORTHO) {
            return (x - z * this.sin_theta_beta) / this.cos_theta_beta;
        } else if (this.mode == FR.Chart.Projection.PERSPECTIVE) {
            return (x * (this.focus + this.sin_theta_alpha * y - this.cos_theta_alpha * this.cos_theta_beta) - z * this.sin_theta_beta * this.focus) / (cos_theta_beta * focus - x * cos_theta_alpha * sin_theta_beta);
        } else if (this.mode == FR.Chart.Projection.RIGHT_ANGLE) {
            return x - z * this.sin_theta_beta * 0.5;
        } else {
            return x;
        }
    }
});
$.extend(FR.Chart.Projection, /**@class FR.Chart.Projection*/{
    /**
     * @static
     * @property 正交投影
     */
    ORTHO: 0,

    /**
     * @static
     * @property 透视投影
     */
    PERSPECTIVE: 1,
    /**
     * @static
     * @property 直角坐标投影
     */
    RIGHT_ANGLE: 2
});

FR.Chart.Condition = FR.extend(FR.Chart.ChartJsInit,{
    initConstants:function(js){
        this.leftValue = FR.pick(js.leftValue, "");
        this.rightValue = FR.pick(js.rightValue, "");
        this.compare = FR.pick(js.compare, FR.Chart.Compare.EQUALS);
    },

    //result是dataPoint或者dataSeries
    eval:function(result){
        var value = result.toResult(this.leftValue);
        switch (this.compare){
            case FR.Chart.Compare.EQUALS:
                return value == this.rightValue;
                break;
            case FR.Chart.Compare.NOT_EQUAL:
                return value != this.rightValue;
                break;
            case FR.Chart.Compare.GREATER_THAN:
                return value > this.rightValue;
                break;
            case FR.Chart.Compare.GREATER_THAN_OR_EQUAL:
                return value >= this.rightValue;
                break;
            case FR.Chart.Compare.LESS_THAN:
                return value < this.rightValue;
                break;
            case FR.Chart.Compare.LESS_THAN_OR_EQUAL:
                return value <= this.rightValue;
                break;
            default :
                return false;
        }
    }
});