// SimpleChart.start
/*
 * 图表Report端的展示控件, 用于在Report指定位置dom上 展示u图表.
 */
FR.SimpleChart = FR.extend(FR.Widget, {
    type: "simplechart",

    _init: function () {
        FR.SimpleChart.superclass._init.apply(this, arguments);

        var o = this.options;

        this.curChart = null;
        this.chartArray = [];

        this.width = o.chartWidth || 0;
        this.height = o.chartHeight || 0;

        if (this.width <= 0 || this.height <= 0) {
            return;
        }

        this.isNeedRefreshButton = !!o.isNeedRefreshButton;

        var selectedIndex = o.selectedIndex == undefined ? 0 : o.selectedIndex;
        this.selectedIndex = selectedIndex;

        if(this.element) {
            this.element.css('position', 'relative').css('width', this.width + 'px').css('height', this.height + 'px');
        }

        this.isNeedBackgroundGlyph = false;
        if ((o && o.items && o.items.length > 1) || this.isNeedRefreshButton){
            this.isNeedBackgroundGlyph = true;
        }

        FR.Chart.WebUtils._storeChartWidget(this, this.options.chartpainter_id_web_change_selected);
        this.changeChartImage(selectedIndex);

    },

    resize: function (width, height) {
        this.width = width || this.width;
        this.height = height || this.height;
        var idx = this.selectedIndex;

        this.element.css({
            width: this.width,
            height: this.height
        });

        if (this.curChart.chartType == "div") {
            if (this.curChart.chartWidth != this.width
                || this.curChart.chartHeight != this.height) {
                var ids = FR.Chart.WebUtils._getChartIDAndIndex(this.options.items[idx].simpleChartInShowID);
                var chartSet = FR.ChartManager[ids[0]];
                this.curChart.css("width", this.width).css("height", this.height);
                chartSet[idx].resize(this.width, this.height);
                this.curChart.chartWidth = this.width;
                this.curChart.chartHeight = this.height;
            }
            var fineChart = FR.Chart.WebUtils.getChart(this.options.items[idx].simpleChartInShowID);
            if(fineChart){
                fineChart.refresh();
            }
        } else {
            if (this.curChart.chartWidth != this.width
                || this.curChart.chartHeight != this.height) {
                this.curChart.css("width", this.width).css("height", this.height);
                this.curChart.chartWidth = this.width;
                this.curChart.chartHeight = this.height;
            }
        }
    },

    destroy:function() {
        if (this.curChart.chartType === "div") {
            var idx = this.selectedIndex;
            var fineChart = FR.Chart.WebUtils.getChart(this.options.items[idx].simpleChartInShowID);

            if(fineChart){
                fineChart.clearAll && fineChart.clearAll();
            }
        }
    },

    getChartItems:function(){
        return this.options.items;
    },

    addTrialLicenseWater: function (chartEl, text, width, height) {

        var gap1 = 20, gap2 = 10, gap3 = 8;
        var frFont = {fontName: 'MicrosoftYaHei-Bold', size: 16},
            textDim = FR.Chart.WebUtils.stringDimensionWidthDiv(text, frFont);

        while (frFont.size >= 12 && textDim.width > width) {
            frFont.size--;
            textDim = FR.Chart.WebUtils.stringDimensionWidthDiv(text, frFont)
        }
        frFont.size = Math.max(frFont.size, 12);
        textDim = FR.Chart.WebUtils.stringDimensionWidthDiv(text, frFont);

        var r = gap1, b = gap1;

        var rectEl = chartEl.data('trail-lic-water-rect');
        var textEl = chartEl.data('trail-lic-water-text');
        if (rectEl) {
            rectEl.remove();
        }
        if (textEl) {
            textEl.remove();
        }

        rectEl = $("<div></div>");
        chartEl.data('trail-lic-water-rect', rectEl);
        chartEl.append(rectEl);

        rectEl.css({
            position: 'absolute',
            right: r,
            bottom: b,
            width: textDim.width + gap2 * 2,
            height: textDim.height + gap3 * 2,
            'background-color': '#007ED3',
            opacity: 0.5,
            'border-radius': '4px'
        });


        textEl = $("<div></div>");
        chartEl.data('trail-lic-water-text', textEl);
        chartEl.append(textEl);

        textEl.css({
            position: 'absolute',
            right: r + gap2,
            bottom: b + gap3,
            color: 'white',
            'font-family': frFont.fontName,
            'font-size': frFont.size
        });
        textEl[0].innerHTML = text;
    },

    changeChartImage: function (idx) {
        if (idx < 0 || idx >= this.options.items.length) {
            return;
        }

        if(this.selectedIndex != idx) {
            this.selectedIndex = idx;

            var FRSessionID = FR.SessionMgr.getSessionID();
            if(FRSessionID) {// kunsnat: BI的图表使用不需要此切换, 并且FRSessionID 为空.
                FR.ajax({
                    type: "POST",
                    url: FR.servletURL,
                    data: {
                        op: 'chart',
                        cmd: 'change_selected',
                        selectedValue: idx,
                        chartpainter_id_web_change_selected: this.options.chartpainter_id_web_change_selected,
                        chartID: this.options.items[idx].simpleChartInShowID
                    },
                    headers: {
                        sessionID: FRSessionID
                    },
                    async: false,
                    complete: function (res) {
                    }
                });
            }
        }

        if (!this.chartArray[idx]) {
            var url =  this.options.items[idx].url;
            var id = "Chart__" + this.options.items[idx].simpleChartInShowID;

            // kunsnat: 用于判断是否加载动态图表的div
            var isJS = this.options.items[idx].isJS;
            if (isJS) {
                var width = this.width;
                var height = this.height;

                var div = $("<div>");
                div.attr('id',id);
                div.appendTo(this.element);
                div.css('position', 'relative').css('background-color', 'transparent')
                    .css('width', width).css('height', height)
                    .css('left', 0 ).css('top', 0)
                    .css('onselectstart', false).css('userinteractionenabled', 'no');
                this.element.append(div.html());

                var self = this;
                FR.ajax({
                    type:'GET',
                    dataType:'json',
                    url: FR.servletURL + url,
                    data: {__time: new Date().getTime()},
                    beforeSend: function () {
                        // 开始加载动画
                        FR.HtmlLoader.loadingEffect({
                            el: div,
                            show: true,
                            delay: 1000,
                            loadingType: 'local'  // 局部加载动画
                        });
                    },
                    complete: function(result, status){
                        if (status === "success"){
                            var res = FR.jsonDecode(result.responseText);

                            // jim:火狐下面异步总是立刻跳过来执行啊，导致自适应布局调整图表控件大小时，
                            //web端会出现图表边框线不断变化，闪屏的感觉，先加个延迟了

                            var chartName = res.wrapperName;
                            if(chartName){
                                res.AnimateAttr = self.options.AnimateAttr;

                                FR.Chart.WebUtils.importFineChartJS(chartName);

                                if(res && res.wrapperName == "VanChartWrapper") {
                                    //轮播切换时，options数组是this.options.chartAttr.options
                                    var option = res.chartAttr || {};
                                    var optionArray = option.options;
                                    VanCharts.initPaddingScale(optionArray && $.isArray(optionArray) && optionArray.length ? optionArray[0].scale : option.scale);
                                }

                                if ($.browser.mozilla) {
                                    setTimeout( function () {
                                        new VanChartWidget(res, div);
                                    }, 200);
                                } else {
                                    new VanChartWidget(res, div);
                                }

                                //水印
                                if (res.chartAttr && res.chartAttr.trialLicenseWater) {
                                    self.addTrialLicenseWater(self.element, res.chartAttr.trialLicenseWater, width, height);

                                    setInterval(function () {
                                        self.addTrialLicenseWater(self.element, res.chartAttr.trialLicenseWater, width, height);
                                    }, 5 * 60 * 1000)
                                }

                            }
                        } else {
                            self.element.html(result.responseText);
                        }

                        // 结束加载动画
                        if (FR.Browser.isIE9Later()) {
                            setTimeout(function () {
                                FR.HtmlLoader.loadingEffect({
                                    el: div,
                                    overflow:'hidden'
                                });
                            }, 200);
                        } else {
                            FR.HtmlLoader.loadingEffect({
                                el: div,
                                overflow:'hidden'
                            });
                        }
                    }
                });
                this.chartArray[idx] = div;
                this.chartArray[idx].chartType = "div";// kunsnat: 标记chartType, 是用的div还是image
                this.chartArray[idx].chartWidth = width;
                this.chartArray[idx].chartHeight = height;
            } else {
                var $image = $("<img src='" + url + "'/>").css("width", this.width).css("height", this.height)
                    .css('border-width', 0)// ie 强制0
                    .attr("idx", idx).css('position', 'relative').css('top', 0).css('left', 0);
                if($.browser.msie) {
                    var $msbox = $("<div>"); // kunsnat: IE6 加图片会有一层灰色背景, // 如果用滤镜, 则不支持事件点击.

                    this.chartArray[idx] = $image.appendTo($msbox);
                } else {
                    this.chartArray[idx] = $image.appendTo(this.element);
                }

                this.chartArray[idx].chartType = "img";
                this.chartArray[idx].chartWidth = this.width;
                this.chartArray[idx].chartHeight = this.height;
                // 添加热点地图
                if (this.options.items[idx].usemap && this.options.items[idx].mapHtml) {
                    this.chartArray[idx].attr("usemap", this.options.items[idx].usemap);
                    if ($.browser.msie) {
                        $msbox.append(this.options.items[idx].mapHtml);
                    } else {
                        this.element.append(this.options.items[idx].mapHtml);
                    }
                }
                if ($.browser.msie) {
                    this.element.append($msbox.html());
                    this.chartArray[idx] = $("img[idx='" + idx + "']", this.element);
                }

                if(this.isNeedBackgroundGlyph){
                    var background = new FR.Chart.BackgroundGlyph(this.element,this.getChartItems(),this.selectedIndex,this.isNeedRefreshButton,{width:this.width, height:this.height});
                    background.init4MouseHandler();
                    background.chartWidget = this;
                }
            }
        }

        this.chartArray[idx].idxNumber = idx;
        if (this.curChart) {
            if (this.curChart.idxNumber == idx) {
                if (this.curChart.chartType == "div") {
                    if (this.curChart.chartWidth != this.width
                        || this.curChart.chartHeight != this.height) {
                        var ids = FR.Chart.WebUtils._getChartIDAndIndex(this.options.items[idx].simpleChartInShowID);
                        var chartSet = FR.ChartManager[ids[0]];
                        chartSet[idx].resize(this.width, this.height);
                        this.curChart.chartWidth = this.width;
                        this.curChart.chartHeight = this.height;
                    }
                    var fineChart = FR.Chart.WebUtils.getChart(this.options.items[idx].simpleChartInShowID);
                    if(fineChart){
                        fineChart.refresh();
                    }
                }

                return;
            } else {
                if (this.curChart.chartWidth != this.width
                    || this.curChart.chartHeight != this.height) {
                    this.curChart.css("width", this.width).css("height",
                        this.height);
                    this.curChart.chartWidth = this.width;
                    this.curChart.chartHeight = this.height;
                }
            }
        }
        var next = this.chartArray[idx];

        if (this.curChart) {
            if (this.curChart.chartType == "div") {
                this.curChart.css('display', "none");
                if (next.chartType == "div") {
                    next.css('width', this.width + "px")
                        .css('height', this.height + 'px').css('display',
                            "");
                    this.curChart = next;
                    if (this.curChart.isNotFirstShow) {
                        if (this.curChart.chartWidth != this.width
                            || this.curChart.chartHeight != this.height) {
                            var ids = FR.Chart.WebUtils._getChartIDAndIndex(this.options.items[idx].simpleChartInShowID);
                            var chartSet = FR.ChartManager[ids[0]];
                            chartSet[idx].resize(this.width, this.height);
                            this.curChart.chartWidth = this.width;
                            this.curChart.chartHeight = this.height;
                        }
                        var fineChart = FR.Chart.WebUtils.getChart(this.options.items[idx].simpleChartInShowID);
                        if(fineChart){
                            fineChart.refresh();
                        }
                    } else {
                        this.curChart.isNotFirstShow = true;
                    }
                } else {
                    next.css("width", this.width).css("height", this.height)
                        .css('display', "").css({
                            opacity: 0.0
                        }).animate({
                            opacity: 1.0
                        }, 150, function () {
                        this.curChart = next;
                    }.createDelegate(this));
                }
            } else {
                this.curChart.css('display', 'none');// kunsnat: 10230 直接消失,初始图片到动态时 无法出现

                if (next.chartType == "div") {
                    next.css("width", this.width + "px")
                        .css("height", this.height + "px").css('display', "");
                    this.curChart = next;
                    if (this.curChart.isNotFirstShow) {
                        if (this.curChart.chartWidth != this.width
                            || this.curChart.chartHeight != this.height) {
                            var ids = FR.Chart.WebUtils._getChartIDAndIndex(this.options.items[idx].simpleChartInShowID);
                            var chartSet = FR.ChartManager[ids[0]];
                            chartSet[idx].resize(this.width, this.height);
                            this.curChart.chartWidth = this.width;
                            this.curChart.chartHeight = this.height;
                        }
                        var fineChart = FR.Chart.WebUtils.getChart(this.options.items[idx].simpleChartInShowID);
                        if(fineChart){
                            fineChart.refresh();
                        }
                    } else {
                        this.curChart.isNotFirstShow = true;
                    }
                } else {
                    next.css("width", this.width).css("height", this.height)
                        .css('display', "").css({
                            opacity: 0.0
                        }).animate({
                            opacity: 1.0
                        }, 150, function () {
                        this.curChart = next;
                    }.createDelegate(this));
                }
            }

        } else {
            if (next.chartType == "div") {
                next.isNotFirstShow = true;
                this.curChart = next;
            } else {
                next.css({
                    opacity: 1.0
                });
                this.curChart = next;
            }
        }
    }
});
$.shortcut("simplechart", FR.SimpleChart);
// simplechart end