/**
 * Created by shine on 2019/7/2.
 * describe:
 */
!(function () {
    window.Van = window.Van || {};

    Van.Utils = Van.Utils || {};

    Van.Utils.initFRVan = function () {
        Van.FRChartBridge = Van.FRChartBridge || {};
        Van.FRChartBridge.Cache = Van.FRChartBridge.Cache || [];
    };

    Van.Utils.storeChartBridge = function (chartBridge) {
        Van.FRChartBridge.Cache.push(chartBridge);
    };

    Van.Utils.getChartBridge = function (idInfo) {
        var result = null;

        if (!idInfo) {
            return result;
        }
        idInfo.ecName = idInfo.ecName || '';
        idInfo.sheetIndex = idInfo.sheetIndex || 0;

        Van.FRChartBridge.Cache.forEach(function (bridge) {
            var equals = true;
            ["type", "sheetIndex", "ecName", "name"].forEach(function (t) {
                equals = equals && (bridge.idInfo[t] === idInfo[t]);
            });

            if (equals) {
                result = bridge;
                return false;
            }
        });

        return result;
    };

    Van.Utils.clearCache = function (chartBridge) {
        Van.FRChartBridge.Cache.remove(chartBridge);
    };

    Van.Utils.doLinkWithFilter = function (bridgeChart, params, data, filter) {

        if (bridgeChart.options.doFineHyperlink) {

            bridgeChart.options.doFineHyperlink(params.event, data);

            return;
        }

        var self = bridgeChart;

        FR.ajax({
            type: 'POST',
            url: FR.servletURL + '?op=chart&cmd=calculate_hyperlink',
            data: data,
            headers: {
                sessionID: FR.SessionMgr.getSessionID()
            },
            dataType: 'json',
            success: function (array) {
                if (array && array.length) {
                    if (filter) {
                        array = array.filter(filter);
                    }
                    FR.doHyperlink(self._linkClickEvent(params), array, true);
                }
            }
        });

    };

    /**
     * vanchart 超链
     * @param params  like:{x:华东,y:100,...}
     * @returns {*|{chartIndex, linkKey, linkParas, __time}}
     */
    Van.Utils.createLinkData4VanChart = function (params) {
        this.specialDealParams4VanChart(params);
        var hyperlink = params.hyperLink;
        return this.createLinkData(params, hyperlink);
    };

    //vanchart+第三方图表 超链 自动播放 等共用
    Van.Utils.createLinkData = function (params, hyperLink) {

        if (hyperLink && hyperLink.parasMap) {

            var parasMap = hyperLink.parasMap || [];

            var parameters = {};
            parasMap.forEach(function (para) {
                var props = para.props || [];
                var value = params;
                props.forEach(function (prop) {
                    value && (value = value[prop]);
                });

                var key = para.key;
                if (key && value !== undefined) {
                    parameters[key] = value;
                }
            });

            return {
                'chartIndex': params.chartIndex,
                'linkKey': params.linkKey,
                'linkParas': parameters,
                '__time': new Date().getTime()
            };
        }

    };

    //对vanchart里面的组合图 钻取目录等特殊处理的东西
    Van.Utils.specialDealParams4VanChart = function (params) {
        var linkKey, vanchart;
        if (params.linkKey === 'dTools') {//钻取目录
            linkKey = params.linkKey;
            vanchart = params.vanchart;
        } else {
            var series = params.series, pointOptions = params.options;
            linkKey = series.type;//normal
            if (pointOptions.plotIndex !== null && pointOptions.plotIndex !== undefined) {
                linkKey = pointOptions.plotIndex;//组合图
            }
            vanchart = series.vanchart;
        }
        var vancharts = vanchart.vancharts.charts;
        var chartIndex = 0;
        for (var i = 0; i < vancharts.length; i++) {
            if (vancharts[i] === vanchart) {
                chartIndex = i;
            }
        }

        var hyperLink = vanchart.options.hyperLink || [];

        params.hyperLink = hyperLink[linkKey];
        params.linkKey = linkKey;
        params.chartIndex = chartIndex;

        var options = params.options || {}, originalCategory = options.originalCategory,
            originalCategoryArray = options.originalCategoryArray;
        if (originalCategory && !originalCategoryArray) {
            //单个分类 后台没有往前台传分类数组
            //超链参数 设置分类数组 在此用分类构造分类数组
            options.originalCategoryArray = [originalCategory];
        }
    }

})();