$(function () {
    var $reportPane = $("<div class='reportPane'></div>");
    window.contentPane = $reportPane.asComponent(${panel_config});

    FR.SessionMgr.register('${sessionID}', contentPane);
    ${widgetCss};
    contentPane.on("init", function () {
        var regions = [{region: 'center', el: $reportPane}];

        /**
         * 判断尺寸，在尺寸为0的情况下返回一个默认值
         * 在某些情况下，如平台快速点击多个报表时，无法获取到尺寸，
         * 提供一个默认值，
         *
         * @param length    默认尺寸
         * @param defaultValue  默认值
         * @returns {*}
         */
        function checkSizeOrDefault(length, defaultValue) {
            if (isNaN(defaultValue)) {
                return length;
            }
            return length === 0 ? defaultValue : length;
        }

        var $container = $("body").asComponent({
            type: "border", items: regions,
            // 当前默认值来自url
            width: checkSizeOrDefault(FR.windowWidth, window.location.href.getQuery("width")),
            height: checkSizeOrDefault(FR.windowHeight, window.location.href.getQuery("height"))
        });
        $container.doLayout();
        $(window).resize(function () {
            $container.element.bounds({
                'width': FR.windowWidth,
                'height': FR.windowHeight
            });
            $container.doLayout();
        });
    });

    (function () {
        ${loading}
    }).apply(contentPane);
});